#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define x first
#define y second

const int INF = 1e18;

const int maxn = 2e5;

vector<pair<int, int>> g[maxn + 1];

const int mod = 1e9 + 7;

int n;

pair<vector<int>, vector<int>> dij(int start) {
    vector<int> dst(n + 1, INF);
    vector<int> vars(n + 1, 0);

    dst[start] = 0;
    vars[start] = 1;

    set<pair<int, int>> d;

    d.insert({0, start});

    while (d.size()) {
        int u = d.begin()->y;
        d.erase(d.begin());

        for (auto [to, w] : g[u]) {
            if (dst[to] > dst[u] + w) {
                d.erase({dst[to], to});
                dst[to] = dst[u] + w;
                d.insert({dst[to], to});
                vars[to] = 0;
            }

            if (dst[to] == dst[u] + w) {
                vars[to] = (vars[to] + vars[u]) % mod;
            }
        }
    }
    return {dst, vars};
}


void solve() {
    int m;
    cin >> n >> m;

    int s, t, l;
    cin >> s >> t >> l;

    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }

    auto [dst, vars] = dij(s);

    if (dst[t] == l) {
        cout << vars[t] << endl;
        return;
    }

    auto [dst2, vars2] = dij(s);

    int res = 0;
    for (int i = 1; i <= n; ++i) {
        for (auto[to, w] : g[i]) {
            if (dst2[to] + dst[i] + w == l) {
                res = (res + vars[i] * vars2[to]) % mod;
            }
        }
    }

    cout << res << endl;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    solve();

    return 0;
}
