#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
#define all(x) x.begin(), x.end()

#define int long long

//using ordered_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
//
//struct sparse_table {
//    vector<vector<pair<int, int>>> spt;
//    vector<int> lg;
//
//    void build(vector<int> a) {
//        int n = a.size();
//        lg.assign(n + 1, 0);
//        for (int i = 2; i <= n; ++i) lg[i] = lg[i >> 1] + 1;
//        spt.assign(n, vector<pair<int, int>>(lg.back() + 1));
//        for (int i = 0; i < n; ++i) spt[i][0] = {a[i], i};
//        for (int k = 0; (1 << k) < n; ++k) {
//            for (int i = 0; i + (1 << k) < n; ++i) {
//                spt[i][k + 1] = min(spt[i][k], spt[i + (1 << k)][k]);
//            }
//        }
//    }
//
//    pair<int, int> get(int l, int r) {
//        int k = lg[r - l + 1];
//        return min(spt[l][k], spt[r - (1 << k) + 1][k]);
//    }
//};

int dx[] = {1, 0, -1, 0};
int dy[] = {0, 1, 0, -1};

int32_t main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
        ios::sync_with_stdio(0);
    cin.tie(0);

    int mod = 1e9 + 7;


    int n, m;
    cin >> n >> m;
    int s, f, l;
    cin >> s >> f >> l;
    --s, --f;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    vector<int> ds(n, 3e18), cnts(n, 0);
    ds[s] = 0;
    cnts[s] = 1;
    set<pair<int, int>> q;
    q.insert({0, s});
    while (q.size()) {
        int u = q.begin()->second;
        assert(cnts[u] > 0);
        q.erase(q.begin());
        for (auto [to, w] : g[u]) {
            if (ds[to] > ds[u] + w) {
                q.erase({ds[to], to});
                ds[to] =  ds[u] + w;
                q.insert({ds[to], to});
                cnts[to] = cnts[u];
            }
            else if (ds[to] == ds[u] + w) cnts[to] = (cnts[to] + cnts[u]) % mod;
        }
    }
    q.clear();
    vector<int> df(n, 3e18), cntf(n, 0);
    df[f] = 0;
    cntf[f] = 1;
    q.insert({0, f});
    while (q.size()) {
        int u = q.begin()->second;
        q.erase(q.begin());
        for (auto [to, w] : g[u]) {
            if (df[to] > df[u] + w) {
                q.erase({df[to], to});
                df[to] =  df[u] + w;
                q.insert({df[to], to});
                cntf[to] = cntf[u];
            }
            else if (df[to] == df[u] + w) cntf[to] = (cntf[to] + cntf[u]) % mod;
        }
    }
    if (l == ds[f]) {
        cout << cnts[f] % mod;
    } else {
        int ans = 0;
        for (int u = 0; u < n; ++u) {
            bool ok = 0;
            if (ds[u] + df[u] != ds[f]) continue;
            for (auto [to, w]: g[u]) {
                if (ds[u] + w + df[to] == l) {
                    assert(ds[u] + w + df[to] != df[s]);
                    //cout << u << ' ' << to << '\n';
                    if (ds[to] + df[to] == ds[f]) {
                        //assert(ds[to] < ds[u]);
//                        cout << ds[to] << ' ' << df[to] << ' ' << ds[f] << ' ' << ds[u] << endl;
//                        cout << "ABOBA\n";
//                        return 0;
                    }
                    ans = (ans + cnts[u] * cntf[to] % mod) % mod;
                }
            }
        }
        cout << ans % mod;
    }
}