#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

#define int ll

using ll = long long;
using ld = long double;
#define all(x) x.begin(), x.end()

//using ordered_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
//
//struct sparse_table {
//    vector<vector<pair<int, int>>> spt;
//    vector<int> lg;
//
//    void build(vector<int> a) {
//        int n = a.size();
//        lg.assign(n + 1, 0);
//        for (int i = 2; i <= n; ++i) lg[i] = lg[i >> 1] + 1;
//        spt.assign(n, vector<pair<int, int>>(lg.back() + 1));
//        for (int i = 0; i < n; ++i) spt[i][0] = {a[i], i};
//        for (int k = 0; (1 << k) < n; ++k) {
//            for (int i = 0; i + (1 << k) < n; ++i) {
//                spt[i][k + 1] = min(spt[i][k], spt[i + (1 << k)][k]);
//            }
//        }
//    }
//
//    pair<int, int> get(int l, int r) {
//        int k = lg[r - l + 1];
//        return min(spt[l][k], spt[r - (1 << k) + 1][k]);
//    }
//};

int dx[] = {1, 0, -1, 0};
int dy[] = {0, 1, 0, -1};

int32_t main() {
//    ios::sync_with_stdio(0);
//    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) cin >> a[i][j];
    queue<pair<int, int>> q;
    vector<vector<bool>> ok(n, vector<bool>(m, 1));
    vector<vector<bool>> used(n, vector<bool>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i == 0 || i == n - 1 || j == 0 || j == m - 1) {
                if (a[i][j] == '.') {
                    q.emplace(i, j);
                }
            }
        }
    }
    function<bool(int, int)> check = [&](int x, int y) -> bool {
        return 0 <= x && x < n && 0 <= y && y < m;
    };
    while (q.size()) {
        auto [x, y] = q.front();
        q.pop();
        used[x][y] = 1;
        ok[x][y] = 0;
        for (int c = 0; c < 4; ++c) {
            if (check(x + dx[c], y + dy[c]) && !used[x + dx[c]][y + dy[c]]) {
                if (a[x + dx[c]][y + dy[c]] == '#') continue;
                used[x + dx[c]][y + dy[c]] = 1;
                q.emplace(x + dx[c], y + dy[c]);
            }
        }
    }
    int lx = n, rx = -1, ly = m,ry = -1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (ok[i][j] && a[i][j] != '#') {
                lx = min(lx, i);
                rx = max(rx, i);
                ly = min(ly, j);
                ry = max(ry, j);
            }
        }
    }
    lx--, rx++, ly--, ry++;
    check = [&](int x, int y) -> bool {
        return lx <= x && x <= rx && ly <= y && y <= ry;
    };
    int x, y;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (check(i, j)) {
                if (i == lx || i == rx || j == ly || j == ry){
                    if (a[i][j] != '#') continue;
                    int cnt = 0;
                    for (int c = 0; c < 4; ++c) if (check(i + dx[c], j + dy[c]) && a[i + dx[c]][j + dy[c]] == '#') ++cnt;
                    if (cnt == 2) x = i, y = j;
                }
            }
        }
    }
    int sx = x, sy = y;
    int ans = 1e9;
    used.assign(n, vector<bool>(m));
    function<void(int, int, int, int, int)> dfs = [&](int x, int y, int len, int px, int py) {
        used[x][y] = 1;
        for (int c = 0; c < 4; ++c) {
            if (check(x + dx[c], y + dy[c])) {
                if (a[x + dx[c]][y + dy[c]] != '#') continue;
                if (x + dx[c] == px && y + dy[c] == py) continue;
                if (x + dx[c] == sx && y + dy[c] == sy) ans = min(ans, len + 1);
                if (!used[x + dx[c]][y + dy[c]]) dfs(x + dx[c], y + dy[c], len + 1, x, y);
            }
        }
    };
    dfs(sx, sy, 0, -1, -1);
    used.assign(n, vector<bool>(m));
    vector<vector<char>> res(n, vector<char>(m, '.'));
    function<bool(int, int, int, int, int)> dfsans = [&](int x, int y, int len, int px, int py) {
        used[x][y] = 1;
        for (int c = 0; c < 4; ++c) {
            if (check(x + dx[c], y + dy[c])) {
                if (a[x + dx[c]][y + dy[c]] != '#') continue;
                if (x + dx[c] == px && y + dy[c] == py) continue;
                if (x + dx[c] == sx && y + dy[c] == sy)  {
                    if (ans == len + 1) {
                        res[x][y] = '#';
                        return 1;
                    }
                }
                if (!used[x + dx[c]][y + dy[c]]) if (dfsans(x + dx[c], y + dy[c], len + 1, x, y)) {
                    res[x][y] = '#';
                    return 1;
                }
            }
        }
        return 0;
    };
    dfsans(sx, sy, 0, -1, -1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) cout << res[i][j];
        cout << '\n';
    }
}