#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

#define int ll

using ll = long long;
using ld = long double;
#define all(x) x.begin(), x.end()

//using ordered_set = tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
//
//struct sparse_table {
//    vector<vector<pair<int, int>>> spt;
//    vector<int> lg;
//
//    void build(vector<int> a) {
//        int n = a.size();
//        lg.assign(n + 1, 0);
//        for (int i = 2; i <= n; ++i) lg[i] = lg[i >> 1] + 1;
//        spt.assign(n, vector<pair<int, int>>(lg.back() + 1));
//        for (int i = 0; i < n; ++i) spt[i][0] = {a[i], i};
//        for (int k = 0; (1 << k) < n; ++k) {
//            for (int i = 0; i + (1 << k) < n; ++i) {
//                spt[i][k + 1] = min(spt[i][k], spt[i + (1 << k)][k]);
//            }
//        }
//    }
//
//    pair<int, int> get(int l, int r) {
//        int k = lg[r - l + 1];
//        return min(spt[l][k], spt[r - (1 << k) + 1][k]);
//    }
//};

int dx[] = {1, 0, -1, 0};
int dy[] = {0, 1, 0, -1};

int32_t main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    //    ios::sync_with_stdio(0);
//    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<vector<char>> a(n, vector<char>(m));
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) cin >> a[i][j];
    queue<pair<int, int>> q;
    vector<vector<bool>> ok(n, vector<bool>(m, 1));
    vector<vector<bool>> used(n, vector<bool>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i == 0 || i == n - 1 || j == 0 || j == m - 1) {
                if (a[i][j] == '.') {
                    q.emplace(i, j);
                    used[i][j] = 1;
                }
            }
        }
    }
    function<bool(int, int)> check = [&](int x, int y) -> bool {
        return 0 <= x && x < n && 0 <= y && y < m;
    };
    while (q.size()) {
        auto [x, y] = q.front();
        q.pop();
        ok[x][y] = 0;
        for (int c = 0; c < 4; ++c) {
            if (check(x + dx[c], y + dy[c]) && !used[x + dx[c]][y + dy[c]]) {
                if (a[x + dx[c]][y + dy[c]] == '#') continue;
                used[x + dx[c]][y + dy[c]] = 1;
                q.emplace(x + dx[c], y + dy[c]);
            }
        }
    }
    int lx = n, rx = -1, ly = m, ry = -1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (ok[i][j] && a[i][j] != '#') {
                lx = min(lx, i);
                rx = max(rx, i);
                ly = min(ly, j);
                ry = max(ry, j);
            }
        }
    }
    lx--, rx++, ly--, ry++;
    function<bool(int, int)> check2 = [&](int x, int y) -> bool {
        return lx <= x && x <= rx && ly <= y && y <= ry;
    };
    int x, y;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (check2(i, j)) {
                if (i == lx || i == rx || j == ly || j == ry){
                    if (a[i][j] != '#') continue;
                    int cnt = 0;
                    for (int c = 0; c < 4; ++c) if (check2(i + dx[c], j + dy[c]) && a[i + dx[c]][j + dy[c]] == '#') ++cnt;
                    if (cnt == 2) x = i, y = j;
                }
            }
        }
    }
    int sx = x, sy = y;
    int ans = 1e9;
    used.assign(n, vector<bool>(m, 0));
    vector<vector<int>> d(n, vector<int>(m, 1e9));
    vector<vector<pair<int, int>>> p(n, vector<pair<int, int>>(m, {-1, -1}));
    d[sx][sy] = 0;
    for (int c = 0; c < 4; ++c) {
        if (check2(sx + dx[c], sy + dy[c])) {
            if (a[sx + dx[c]][sy + dy[c]] == '#') {
                d[sx + dx[c]][sy + dy[c]] = 1;
                p[sx + dx[c]][sy + dy[c]] = {sx, sy};
                q.emplace(sx + dx[c], sy + dy[c]);
                break;
            }
        }
    }
    while (q.size()) {
        auto [x, y] = q.front();
        q.pop();
        for (int c = 0; c < 4; ++c) {
            if (check2(x + dx[c], y + dy[c]) && d[x +  dx[c]][y + dy[c]] > d[x][y] + 1) {
                if (a[x + dx[c]][y + dy[c]] != '#') continue;
                d[x + dx[c]][y + dy[c]] = d[x][y] + 1;
                p[x + dx[c]][y + dy[c]] = {x, y};
                q.emplace(x + dx[c], y + dy[c]);
            }
        }
    }
    x, y;
    for (int c = 0; c < 4; ++c) {
        if (check2(sx + dx[c], sy + dy[c])) {
            if (a[sx + dx[c]][sy + dy[c]] == '#') {
                x = sx + dx[c], y = sy + dy[c];
            }
        }
    }
    vector<vector<char>> res(n, vector<char>(m, '.'));
    while (x != -1) {
        res[x][y] = '#';
        tie(x, y) = p[x][y];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) cout << res[i][j];
        cout << '\n';
    }
}