#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const int N = 2e5 + 5;
const int INF = 2e18;

vector<int> dist, pr;
vector<pair<int, int>> g[N];

int calc_answer(int v, int l) {
    if (pr[v] == -1) return l == 0;
    int answer = 0;
    answer += calc_answer(pr[v], l - dist[v] + dist[pr[v]]);
    for (auto& e : g[v]) {
        if (e.second + dist[e.first] == l) answer++;
    }
    return answer;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    int s, t, L;
    cin >> s >> t >> L;
    --s, --t;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    set<pair<int, int>> st;
    st.insert({0, t});
    dist.assign(n, INF);
    pr.assign(n, -1);
    dist[t] = 0;
    while (!st.empty()) {
        int v = st.begin()->second;
        st.erase(st.begin());
        for (auto [u, w] : g[v]) {
            if (dist[u] > dist[v] + w) {
                st.erase({dist[u], u});
                dist[u] = dist[v] + w;
                pr[u] = v;
                st.insert({dist[u], u});
            }
        }
    }
    /*
    for (int x : dist) {
        cout << x << ' ';
    }
    cout << '\n';
    for (int x : pr) {
        cout << x << ' ';
    }
    cout << '\n';
     */
    cout << calc_answer(s, L);
}