#include <bits/stdc++.h>
#define ff first
#define ss second
#define pb push_back
#define  all(x) x.begin(), x.end()
#define err(x) cerr << "["#x"] " << (x) << "\n"
#define errv(x) {cerr << "["#x"] "; for(auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "["#x"] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}

using namespace std;
using ll = long long;
const int MOD = 1e9 + 7 + 2e6;
mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());

template <typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return a > b ? a = b, true : false;
}


struct node {
    node *li = nullptr, *ri = nullptr;
    int sum = 0;
};

void upd(node *root, int p, int L = 0, int R = MOD) {
    if(R - L == 1) {
        root->sum = 1;
        return;
    }
    int M = (L + R) / 2;
    if(p < M) {
        if(root->li == nullptr) root->li = new node();
        upd(root->li, p, L, M);
    } else {
        if(root->ri == nullptr) root->ri = new node();
        upd(root->ri, p, M, R);
    }
    int res = 0;
    if(root->li != nullptr) res += root->li->sum;
    if(root->ri != nullptr) res += root->ri->sum;
    root->sum = res;
}

int kth(node *root, int k, int L = 0, int R = MOD) {
    if(R - L == 1) return L;
    int M = (L + R) / 2;
    int li = M - L;
    if(root->li != nullptr) li -= root->li->sum;
    if(k <= li) {
        if(root->li == nullptr) return L + k - 1;
        return kth(root->li, k, L, M);
    } else {
        if(root->ri == nullptr) return M + (k - li) - 1;
        return kth(root->ri, k - li, M, R);
    }
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> v(n);
    for(auto &i : v) cin >> i;
    node *root = new node();
    for(auto i : v) upd(root, i);
    for(int i = 0;i < m;i++) {
        int k;
        cin >> k;
        cout << kth(root, k) << ' ';
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    solve();
}