#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
using pqg = priority_queue<T, vector<T>, greater<T>>;


#define int long long
#define fastIo(a) ios_base::sync_with_stdio(a); cin.tie(a); cout.tie(a)
#define all(a) a.begin(), a.end()
#define F first
#define S second
#define sz(a) (int)a.size()

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i : a) cin >> i;
    sort(all(a));
    vector<int> merge(n);
    multiset<int> mst;
    for (int i = 1; i <= n / 2; i++) {
        merge[i] = n - i;
        merge[n - i] = i;
        mst.insert(a[i] + a[n - i]);
    }
    int ans = *prev(mst.end()) - *mst.begin();
    for (int i = 1; i < n; i++) {
        int c = a[i] + a[merge[i]];
        merge[i - 1] = merge[i];
        merge[merge[i]] = i - 1;
        merge[i] = -1;
        mst.erase(mst.lower_bound(c));
        mst.insert(a[i - 1] + a[merge[i - 1]]);
        ans = min(ans, *prev(mst.end()) - *mst.begin());
    }
    cout << ans << '\n';
}

int32_t main() {
    cout << fixed << setprecision(20);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
