#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;

template<typename T>
using pqg = priority_queue<T, vector<T>, greater<T>>;


#define int long long
#define fastIo(a) ios_base::sync_with_stdio(a); cin.tie(a); cout.tie(a)
#define all(a) a.begin(), a.end()
#define F first
#define S second
#define sz(a) (int)a.size()

const int N = 100100;

pair<int, int> t[2 * N];

void upd(int i, int v) {
    for (t[i += N] = {v, i}; i > 1; i >>= 1)
        t[i >> 1] = min(t[i], t[i ^ 1]);
}

pair<int, int> get(int l, int r) {
    pair<int, int> res{2e18, -1};
    for (l += N, r += N; l < r; l >>= 1, r >>= 1) {
        if (l & 1) res = min(res, t[l++]);
        if (r & 1) res = min(res, t[--r]);
    }
    return {res.first, -res.second};
}

void solve() {
    int n, b, c;
    cin >> n >> b >> c;
    vector<pair<int, int>> oils(n);
    int ind = 0;
    for (auto &[x, p]: oils) {
        cin >> x >> p;
        upd(ind, p);
        ind++;
    }

    int mn = 0;
    vector<int> pref(n), suff(n);
    vector<int> bebra1, bebra2;
    bebra1.emplace_back(0);
    pref[0] = oils[0].S;
    for (int i = 1; i < n; i++) {
        if (oils[i].S <= pref[i - 1]) {
            pref[i] = oils[i].S;
            bebra1.emplace_back(i);
            mn = i;
        } else {
            pref[i] = pref[i - 1];
        }
    }
    bebra2.emplace_back(n - 1);
    suff[n - 1] = oils.back().S;
    for (int i = n - 2; i > mn; i--) {
        if (oils[i].S < suff[i + 1]) {
            suff[i] = oils[i].S;
            bebra2.emplace_back(i);
        } else {
            suff[i] = suff[i + 1];
        }
    }
    for (int i = (int)bebra2.size() - 1; i >= 0; i--) {
        bebra1.emplace_back(bebra2[i]);
    }
    set<tuple<int, int, int>> st;
    for (int i = 1; i < bebra1.size(); i++) {
        int f = bebra1[i - 1], s = bebra1[i];
        st.insert({oils[s].F - oils[f].F, f, s});
    }

    while (st.size() < 100000 && (int)st.size() > 0 && get<0>(*prev(st.end())) > c) {
        auto [d, i, j] = *prev(st.end());
        st.erase(prev(st.end()));
        int k = get(i + 1, j).S;
        int nd1 = oils[k].F - oils[i].F, nd2 = oils[j].F - oils[k].F;
        bebra1.emplace_back(k);
        st.insert({nd1, i, k});
        st.insert({nd2, k, j});
    }

    sort(all(bebra1), [&](int i, int j) {
        return oils[i].F < oils[j].F;
    });

    int ans = 0;
    int cur_c = 0;

    for (int i = 0; i < bebra1.size() - 1; i++) {
        int cur = bebra1[i], nxt = bebra1[i + 1];
        if (oils[cur].S > oils[nxt].S) {
            int d = max(0ll, (oils[nxt].F - oils[cur].F) - cur_c);
            int r = d * oils[cur].S;
            if (r > b) {
                ans += cur_c + b / oils[cur].S;
                cur_c = 0;
                b = 0;
                break;
            } else {
                ans += oils[nxt].F - oils[cur].F;
                cur_c = min(oils[nxt].F - oils[cur].F, cur_c);
                b -= r;
            }
        } else {
            int r = min(c - cur_c, b / oils[cur].S);
            b -= r;
            cur_c += r;
            if (cur_c < oils[nxt].F - oils[cur].F) {
                ans += cur_c;
                b = 0;
                break;
            } else {
                ans += oils[nxt].F - oils[cur].F;
                cur_c -= oils[nxt].F - oils[cur].F;
            }
        }
    }
   // cout << cur_c << ' ' << ans << '\n';
    ans += cur_c + b / oils[bebra1.back()].S;
    cout << ans << '\n';
}

int32_t main() {
    cout << fixed << setprecision(20);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
