#include<bits/stdc++.h>
#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<stack>
#include<queue>
#include<deque>
#include<unordered_map>
#include<map>
#include<unordered_set>
#include<set>
#include<bitset>
#include<iomanip>
#include<ctime>
#include<random>
#include<cassert>

#define int long long
#define ld long double
#define sz(x) x.size()
#define all(x) x.begin(),x.end()
#define allr(x) x.rbegin(),x.rend()
#define fi first
#define se second
#define pii pair<int,int>
#define p_b push_back
#define m_p make_pair
#define pw(x) (1LL<<(x))
#define sqr(x) ((x)*(x))


using namespace std;

const int INF = 1e18, mod = 1e9 + 7;

vector < pii > edge[200005];
int n, dst[200005];
vector < pii > p[200005];
bool used[200005];
int cnt_from[200005], cnt_to[200005], cnt_p[200005];

void find_dst(int s)
{
    for(int i = 0; i < n; i++)
        dst[i] = INF;
    dst[s] = 0;
    cnt_from[s] = 1;
    priority_queue < pii > q;
    q.push({0, s});
    while(sz(q))
    {
        int d = -q.top().fi;
        int v = q.top().se;
        q.pop();
        if(d != dst[v])
            continue;
        for(auto [to, w] : edge[v])
        {
            if(d + w < dst[to])
            {
                dst[to] = d + w;
                q.push({-dst[to], to});
            }
            if(d + w == dst[to])
                cnt_from[to] = (cnt_from[to] + cnt_from[v]) % mod;
        }
    }
}

void dfs(int v)
{
    used[v] = true;
    if(!dst[v])
        return;
    for(auto [to, w] : edge[v])
    {
        if(dst[v] == dst[to] + w)
        {
            p[v].p_b({to, w});
            cnt_p[to]++;
            if(!used[to])
                dfs(to);
        }
    }
}

int get(int v, int L)
{
    if(!dst[v])
        return 0;
//    cout << v << " " << L << '\n';
    int ans = 0;
    for(auto [to, w] : p[v])
    {
        cnt_to[to] = (cnt_to[to] + cnt_to[v]) % mod;
        cnt_p[to]--;
        if(!cnt_p[to])
            ans = (ans + get(to, L - w)) % mod;
    }
    for(auto [to, w] : edge[v])
    {
        if(dst[v] != dst[to] + w && dst[to] + w == L)
        {
            ans = (ans + cnt_from[to] * cnt_to[v]) % mod;
        }
    }
    return ans;
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int m;
    cin >> n >> m;
    int s, t, L;
    cin >> s >> t >> L;
    s--;
    t--;
    for(int i = 0; i < m; i++)
    {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        edge[v].p_b({u, w});
        edge[u].p_b({v, w});
    }
    find_dst(t);
    dfs(s);
//    for(int i = 0; i < n; i++)
//    {
//        cout << i + 1 << ":";
//        for(auto j : p[i])
//            cout << j.fi + 1 << " ";
//        cout << '\n';
//    }
//    for(int i=0;i<n;i++)
//        cout<<cnt_p[i]<<" ";
//    cout<<'\n';
    cnt_to[s] = 1;
    if(L == dst[s])
        return cout << cnt_from[s], 0;
    cout << get(s, L);
    return 0;
}


/*

6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4

4 4
1 4 4
1 2 1
1 3 1
2 4 2
3 4 3

7 10
1 6 10
1 2 1
1 3 1
2 3 2
2 4 2
2 7 1
3 6 7
4 7 1
4 5 2
5 7 1
5 6 5

*/
