#include <bits/stdc++.h>

using namespace std;

//#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef __int128 int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
const int INF = 1e9 + 7;

#define int ll

//mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<array<int, 3>>> g(n);
    int S, T, L;
    cin >> S >> T >> L;
    --S, --T;
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        --u, --v;
        g[u].push_back({v, c, i});
        g[v].push_back({u, c, i});
    }
    const int inf = 1e18;
    vector<int> d(n, inf), p(m);
    set<pair<int, int>> st;
    d[S] = 0;
    st.insert({d[S], S});
    while (!st.empty()) {
        auto [_, v] = *st.begin();
        st.erase(st.begin());
        for (auto &[u, w, id] : g[v]) {
            if (d[v] + w < d[u]) {
                st.erase({d[u], u});
                d[u] = d[v] + w;
                st.insert({d[u], u});
            }
        }
    }

    vector<int> order(n);
    iota(all(order), 0);
    sort(all(order), [&] (int i, int j) {
        return d[i] < d[j];
    });

    const int mod = 1e9 + 7;

    vector<int> dp(n);
    dp[S] = 1;
    for (auto &v : order) {
        for (auto &[u, w, id] : g[v]) {
            if (d[u] + w == d[v]) {
                (dp[v] += dp[u]) %= mod;
            }
        }
    }

    vector<int> d1(n, inf);
    d1[T] = 0;
    st.insert({d1[T], T});
    while (!st.empty()) {
        auto [_, v] = *st.begin();
        st.erase(st.begin());
        for (auto &[u, w, id] : g[v]) {
            if (d1[v] + w < d1[u]) {
                st.erase({d1[u], u});
                d1[u] = d1[v] + w;
                st.insert({d1[u], u});
            }
        }
    }

    vector<int> dp1(n);
    sort(all(order), [&] (int i, int j) {
        return d1[i] < d1[j];
    });
    dp1[T] = 1;
    for (auto &v : order) {
        for (auto &[u, w, id] : g[v]) {
            if (d1[u] + w == d1[v]) {
                (dp1[v] += dp1[u]) %= mod;
            }
        }
    }

    if (d[T] == L) {
        cout << dp[T];
    } else if (d[T] < L) {
        int res = 0;
        for (int i = 0; i < n; i++) {
            if (i == T || d[i] + d1[i] != d[T]) {
                continue;
            }
            for (auto &[u, w, id] : g[i]) {
//                cerr << i << ' ' << d[i] << ' ' << w << ' ' << d1[u] << endl;
                if (d[i] + w + d1[u] == L) {
                    res += (dp[i] * dp1[u]) % mod;
                    res %= mod;
                }
            }
        }
        cout << res;
    } else {
        cout << 0;
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
