#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef __int128 int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define int ll

const char en = '\n';
const int INF = 1e9 + 7;
const int INFLL = 1e18;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(all(a));
    multiset<int> st;
    for (int l = 1, r = n - 1; l < r; ++l, --r) {
        st.emplace(a[l] + a[r]);
    }
    int ans = *st.rbegin() - *st.begin();
    for (int i = 1; i <= n / 2; ++i) {
        st.erase(st.find(a[i] + a[n - i]));
        st.emplace(a[i - 1] + a[n - i]);
        ans = min(ans, *st.rbegin() - *st.begin());
    }
    for (int i = n / 2 + 1; i < n; ++i) {
        st.erase(st.find(a[i] + a[n - i - 1]));
        st.emplace(a[i - 1] + a[n - i - 1]);
        ans = min(ans, *st.rbegin() - *st.begin());
    }
    cout << ans << en;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
