#include<bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define fi first
#define se second

using namespace std;
using pii = pair <int, int>;
using ll = long long;

int const N = 1001;
int n, m;
vector < vector <int> > comp(N, vector <int>(N, 0));
vector <bool> is(N, 0);
char a[N][N];

void dfs(int i, int j, int cmp){
    comp[i][j] = cmp;
    if(i + 1 < n and comp[i + 1][j] == 0 and a[i + 1][j] == '.'){
        dfs(i + 1, j, cmp);
    }
    if(i - 1 >= 0 and comp[i - 1][j] == 0 and a[i - 1][j] == '.'){
        dfs(i - 1, j, cmp);
    }
    if(j + 1 < m and comp[i][j + 1] == 0 and a[i][j + 1] == '.'){
        dfs(i, j + 1, cmp);
    }
    if(j - 1 >= 0 and comp[i][j - 1] == 0 and a[i][j - 1] == '.'){
        dfs(i, j - 1, cmp);
    }
    return;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int _id = 1;
    cin >> n >> m;
    vector < vector <int> > right(n), down(m);
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            cin >> a[i][j];
        }
    }
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            if(comp[i][j] == 0 and a[i][j] == '.'){
                dfs(i, j, _id++);
            }
            if((i == 0 or j == 0 or i == n - 1 or j == m - 1) and a[i][j] == '.'){
                is[comp[i][j]] = 1;
            }
        }
    }
    int comp_o = -1;
    for(int i = 1; i < _id; ++i){
        if(!is[i]){
            comp_o = i;
            break;
        }
    }
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            if(a[i][j] == '.' and comp[i][j] == comp_o){
                right[i].push_back(j);
                down[j].push_back(i);
            }
        }
    }
    for(int i = 1; i < n - 1; ++i){
        for(int k = 0; k < (int)right[i].size() - 1; ++k){
            int j1 = right[i][k], j2 = right[i][k + 1];
            bool dl = 0, ul = 0, f = 1;
            for(int j = j1 + 1; j < j2; ++j){
                if(a[i][j] != '#'){
                    f = 0;
                }
                if(a[i - 1][j] == '.' and comp[i - 1][j] != comp_o){
                    dl = 1;
                }
                if(a[i + 1][j] == '.' and comp[i + 1][j] != comp_o){
                    ul = 1;
                }
            }
            if(f and !ul and !dl){
                for(int j = j1 + 1; j < j2; ++j){
                    a[i][j] = '.';
                    comp[i][j] = comp_o;
                }
            }
        }
    }
    for(int j = 1; j < m - 1; ++j){
        for(int k = 0; k < (int)down[j].size() - 1; ++k){
            int i1 = down[j][k], i2 = down[j][k + 1];
            bool dl = 0, ul = 0, f = 1;
            for(int i = i1 + 1; i < i2; ++i){
                if(a[i][j] != '#'){
                    f = 0;
                }
                if(a[i][j + 1] == '.' and comp[i][j + 1] != comp_o){
                    dl = 1;
                }
                if(a[i][j - 1] == '.' and comp[i][j - 1] != comp_o){
                    ul = 1;
                }
            }
            if(f and !ul and !dl){
                for(int i = i1 + 1; i < i2; ++i){
                    a[i][j] = '.';
                    comp[i][j] = comp_o;
                }
            }
        }
    }
    vector < vector <char> > ans(n, vector <char> (m, '.'));
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            if(a[i][j] == '.' and comp[i][j] == comp_o){
                if(i + 1 < n and a[i + 1][j] == '#'){
                    ans[i + 1][j] = '#';
                    if(j + 1 < m and a[i + 1][j + 1] == '#'){
                        ans[i + 1][j + 1] = '#';
                    }
                    if(j - 1 >= 0 and a[i + 1][j - 1] == '#'){
                        ans[i + 1][j - 1] = '#';
                    }
                }
                if(i - 1 >= 0 and a[i - 1][j] == '#'){
                    ans[i - 1][j] = '#';
                    if(j + 1 < m and a[i - 1][j + 1] == '#'){
                        ans[i - 1][j + 1] = '#';
                    }
                    if(j - 1 >= 0 and a[i - 1][j - 1] == '#'){
                        ans[i - 1][j - 1] = '#';
                    }
                }
                if(j + 1 < m and a[i][j + 1] == '#'){
                    ans[i][j + 1] = '#';
                }
                if(j - 1 >= 0 and a[i][j - 1] == '#'){
                    ans[i][j - 1] = '#';
                }
            }
        }
    }
    for(auto w : ans){
        for(auto v : w){
            cout << v;
        }
        cout << '\n';
    }
}


