#include <bits/stdc++.h>
#define int long long

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;

void solve() {
    int n, B, C;
    cin >> n >> B >> C;

    map <int, int> x2p;
    vector <pair <int, int>> slaves(n);
    for (auto &[p, x]: slaves) {
        cin >> x >> p;
        x2p[x] = p;
    }

    sort(slaves.begin(), slaves.end());

    set <pair <int, int>> seen;
    for (auto &[p, x]: slaves) {
        auto it = seen.lower_bound({x, 0});

        int km = C, killed = 0;
        if (it != seen.begin()) {
            auto [prev_x, prev_km] = *prev(it);

            if (prev_x + prev_km > x) {
                killed = ((prev_x + prev_km) - x);
                km = C - killed;
            }
        }

        if (it != seen.end()) {
            auto [next_x, next_km] = *it;
            if (x + killed >= next_x)
                continue;

            km = min(km, next_x - x);
        }

        seen.emplace(x, km);
    }

    int curr_x = 0;
    for (auto [x, km]: seen) {
        if (x > curr_x)
            break;

        if (B == 0)
            break;

        int p = x2p[x];
        int can_buy = B / p;

        km -= curr_x - x;
        km = min(km, can_buy);

        if (km <= 0)
            continue;

        curr_x += km;
        B -= km * p;
    }

    cout << curr_x << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input", "r", stdin);
    #endif // local

    solve();
}
