#include <bits/stdc++.h>
#define int long long

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 227;

void solve() {
    int n, q;
    cin >> n >> q;

    vector <int> a(n + 1, -1);
    for  (int i = 0; i < n; i++)
        cin >> a[i + 1];

    vector <int> diff(n + 2);
    for (int i = 1; i < n + 1; i++) {
        diff[i] = a[i] - a[i - 1] - 1;
    }

    diff[n + 1] = INF;

    vector <int> pref(n + 2);
    for (int i = 0; i < n + 1; i++)
        pref[i + 1] = pref[i] + diff[i + 1];

    ll k;
    while (q--) {
        cin >> k;

        int m, l = 0, r = n + 1;
        while (r - l > 1) {
            m = (l + r) / 2;

            if (pref[m] >= k) {
                r = m;
            } else {
                l = m;
            }
        }

        cout << a[r - 1] + 1 + k - pref[r - 1] - 1 << '\n';
    }
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input", "r", stdin);
    #endif // local

    solve();
}
