#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(v) v.begin(),v.end()
#define pll pair<long long, long long>
#define pii pair<int, int>
#define ff first
#define ss second

int n, m;
ll L;

const ll mod = 1000000007;
ll INF = 2e18;

vector<pll> dist1, dist2;
vector<vector<pll>> a;
vector<bool> was;


void dd1(int v){
    set<pll> st;
    for(int i = 0; i < n; i++){
        if(v != i) st.insert({INF, i});
    }
    st.insert({0, v});
    dist1[v] = {0, 1};
    while((int)st.size()){
        pll u = *st.begin();
        st.erase(u);
        if(u.ff == INF) continue;
        for(auto& p : a[u.ss]){
            if(dist1[p.ff].ff == u.ff + p.ss){
                dist1[p.ff].ss = (dist1[p.ff].ss + dist1[u.ss].ss) % mod;
            }
            if(dist1[p.ff].ff > u.ff + p.ss){
                st.erase({dist1[p.ff].ff, p.ff});
                dist1[p.ff] = {u.ff + p.ss, dist1[u.ss].ss};
                st.insert({dist1[p.ff].ff, p.ff});
            }
        }
    }
}

void dd2(int v){
    set<pll> st;
    for(int i = 0; i < n; i++){
        if(v != i) st.insert({INF, i});
    }
    st.insert({0, v});
    dist2[v] = {0, 1};
    while((int)st.size()){
        pll u = *st.begin();
        st.erase(u);
        if(u.ff == INF) continue;
        for(auto& p : a[u.ss]){
            if(dist2[p.ff].ff == u.ff + p.ss){
                dist2[p.ff].ss = (dist2[p.ff].ss + dist2[u.ss].ss) % mod;
            }
            if(dist2[p.ff].ff > u.ff + p.ss){
                st.erase({dist2[p.ff].ff, p.ff});
                dist2[p.ff] = {u.ff + p.ss, dist2[u.ss].ss};
                st.insert({dist2[p.ff].ff, p.ff});
            }
        }
    }
}

void solve(){
    cin >> n >> m;
    ll s, t;
    cin >> s >> t >> L;
    s--; t--;
    was.resize(n, 0);
    a.resize(n);
    dist1.assign(n, {INF, INF});
    dist2.assign(n, {INF, INF});
    for(int i = 0; i < m; i++){
        ll u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        a[u].push_back({v, w});
        a[v].push_back({u, w});
    }
    dd1(s);
    dd2(t);
    //cout << "here\n";
    if(dist1[t].ff == L){
        cout << dist1[t].ss;
        return;
    }
    ll ans = 0;
    for(int i = 0; i < n; i++){
        if(dist1[i].ff + dist2[i].ff == dist1[t].ff){
            for(pll& u : a[i]){
                if(dist2[u.ff].ff + dist1[i].ff + u.ss == L){
                    ans = (ans + ((dist2[u.ff].ss * dist1[i].ss) % mod)) % mod;
                }
            }
        }
    }
    cout << ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    cin.tie(0);
    int tt;
    //cin >> tt;
    tt = 1;
    while(tt--){
        solve();
        #ifdef LOCAL
            cout << "_________________________________\n";
        #endif // LOCAL
    }
    return 0;
}


