#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;


using vi = vector<int>;
using vpi = vector<pair<int, int>>;
const int INF = 2e9 + 1;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q; cin >> n >> q;
    vi a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vi p;
    vi r;
    if (a[0] != 0) {
        p.push_back(-1);
        r.push_back(a[0] - 0);
    }

    for (int i = 1; i < n; ++i) {
        if (a[i] - a[i - 1] > 1) {
            p.push_back(a[i - 1]);
            if (r.size() == 0) {
                r.push_back(a[i] - a[i - 1]);
            }
            else r.push_back(r.back() + a[i] - a[i - 1] - 1);
        }
    }
    p.push_back(a.back());
    r.push_back(INF);
    while (q--) {
        int k; cin >> k;
        int ind = lower_bound(r.begin(), r.end(), k) - r.begin();
        if (ind == 0) {
            cout << p[ind] + k << " ";
        }
        else cout << p[ind] + (k - r[ind - 1]) << " ";
    }
    return 0;
}
/*
4 10
1 2 6 7
1 2 3 4 5 6 7 8 10
 */