#include <bits/stdc++.h>

using namespace std;

#define ll long long
//#define int long long
#define pb push_back

const int N = 2e5 + 7;
const int md = 1e9 + 7;

void add(int &a, int b) {
    a += b;
    if (a >= md) a -= md;
}

int n, m;
int s, t;
ll L;
vector<pair<int, ll>> g[N];
ll ds[N], dt[N];
int cnts[N], cntt[N];

void go(int st, ll d[N], int cnt[N]) {
    for (int i = 0; i < n; ++i) {
        d[i] = 1e18;
        cnt[i] = 0;
    }
    priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> q;
    d[st] = 0;
    cnt[st] = 1;
    q.push({d[st], st});
    while (!q.empty()) {
        auto [dd, v] = q.top();
        q.pop();
        if (dd != d[v]) continue;
        for (auto [u, w] : g[v]) {
            if (d[v] + w < d[u]) {
                d[u] = d[v] + w;
                cnt[u] = cnt[v];
                q.push({d[u], u});
            } else if (d[v] + w == d[u]) {
                add(cnt[u], cnt[v]);
            }
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m >> s >> t >> L;
    --s;
    --t;
    for (int i = 0; i < m; ++i) {
        int v, u;
        ll w;
        cin >> v >> u >> w;
        --v;
        --u;
        g[v].push_back({u, w});
        g[u].push_back({v, w});
    }
    go(s, ds, cnts);
    go(t, dt, cntt);
    int ans = 0;
    if (ds[t] == L) {
        add(ans, cnts[t]);
    }
    for (int v = 0; v < n; ++v) {
        bool ok = false;
        for (auto [u, w] : g[v]) {
            if (ds[v] + w + dt[u] == ds[t]) {
                ok = true;
                break;
            }
        }
        if (!ok) continue;
        for (auto [u, w] : g[v]) {
            if (ds[v] + w + dt[u] == L && ds[v] + w + dt[u] > ds[t]) {
                add(ans, cnts[v] * 1ll * cntt[u] % md);
            }
        }
    }
    cout << ans << endl;
    return 0;
}