#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define pb push_back
#define F first
#define S second
vector<pair<int, int>> tree;
const int N = 5 * 1e4 + 100;
int a[N];
int n;

void build_tree(int v, int tl, int tr) {
    if (tr - tl == 1) {
        tree[v].F = a[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build_tree(2 * v, tl, tm);
    build_tree(2 * v + 1, tm, tr);
    tree[v].F = max(tree[2 * v].F, tree[2 * v + 1].F);
    tree[v].S = max(max(tree[2 * v].S, tree[2 * v + 1].S), min(tree[2 * v].F, tree[2 * v + 1].F));
}

pair<int, int> GetSMax(int v, int tl, int tr, int l, int r) {
    if (r < tl && tr - 1 < l) {
        return {-1, -1};
    }
    if (l <= tl && tr-1 <= r) {
        return tree[v];
    }
    int tm = (tl + tr) / 2;
    pair<int, int> x = GetSMax(2 * v, tl, tm, l, r);
    pair<int, int> b = GetSMax(2 * v + 1, tm, tr, l, r);
    pair<int, int> ans;
    ans.F = max(x.F, b.F);
    ans.S = max(max(x.S, b.S), min(x.F, b.F));
    return ans;
}

int main() {
    cin >> n;
    tree.assign(4 * N, {-1, -1});
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    build_tree(1, 0, n);
    int q;
    cin >> q;
    while (q--) {
        int l, r;
        cin >> l >> r;
        cout << GetSMax(1, 0, n, l - 1, r - 1).S << "\n";
    }
    return 0;
}
