#pragma GCC optimize("O3", "fast-math", "unroll-loops", "Ofast")
#pragma GCC target("avx2", "bmi", "lzcnt", "popcnt")

#include<bits/stdc++.h>

using namespace std;

#define vt vector
#define all(s) s.begin(), s.end()
#define rall(s) s.end(), s.begin()
#define pb push_back
#define sz(s) (int)s.size()
#define nl '\n'
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int inf = 1e9, N = 4e2 + 5, MOD = 1e9 + 7;

int n, m, dp[N][N], v[N][N], o[N][N], d[N][N];

int sum(int x, int y) {
    x += y;
    if(x >= MOD) x -= MOD;
    return x;
}

int mult(int x, int y) {
    return 1ll * x * y % MOD;
}

signed main() {
    cin.tie(0) -> sync_with_stdio(0);
    cin >> n >> m;

    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= m; ++j) {
            v[i][j] = 1;
            for(int x = 1; x < i - 1; ++x) {
                v[i][j] = sum(v[i][j], mult(i - x - 1, o[x][j]));
            }
        }
        for(int j = 1; j <= m; ++j) {
            for(int x = 1; x < j - 1; ++x) {
                o[i][j] = sum(o[i][j], mult(j - x - 1, v[i][x]));
            }
        }
    }


    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= m; ++j) {
            dp[i][j] = i * j;
            for(int x = 1; x < i - 1; ++x) {
                dp[i][j] = sum(dp[i][j], mult(i - x - 1, d[x][j]));
                /*
                for(int y = 1; y < j - 1; ++y) {
                    int cnt = (i - x - 1) * (j - y - 1);
                    dp[i][j] = sum(dp[i][j], mult(dp[x][y], cnt));
                }
                */
                dp[i][j] = sum(dp[i][j], mult(i * j, mult(i - x - 1, o[x][j])));
            }
        }

        for(int j = 1; j <= m; ++j) {
            for(int x = 1; x < j - 1; ++x) {
                d[i][j] = sum(d[i][j], mult(j - x - 1, dp[i][x]));
            }
        }
    }
    cout << dp[n][m];
    return 0;
}

