#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e5 + 100;

int n, m;
int a[maxn];

int get(int x){
    int cnt = 0;
    for(int l = 1, r = n; l <= r;){
        int mid = (l + r) >> 1;
        if(a[mid] > x) r = mid - 1;
        else l = mid + 1, cnt = mid;
    }
    return x - cnt + 1;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> n >> m;
    for(int i = 1; i <= n; i++) cin >> a[i];
    sort(a + 1, a + n + 1);
    for(int i = 1; i <= m; i++){
        int k;
        cin >> k;
        int ans;
        for(int l = 0, r = 2e9; l <= r;){
            int mid = (1ll * l + r) >> 1;
            int num = get(mid);
            if(num > k) r = mid - 1;
            else if(num < k) l = mid + 1;
            else ans = mid, r = mid - 1;
        }
        cout << ans << ' ';
    }
}