#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define mp make_pair
#define f first
#define s second
#define pb push_back

const ll maxn = 2e5 + 10, inf = 1e9, mod = 1e9 + 7;

ll n, m;
ll s, t, l;
ll u[maxn], v[maxn], w[maxn];
ll dp[maxn], dp2[maxn], dp3[maxn], dpk[maxn];
vector<pair<ll, ll>> g[maxn], g2[maxn];
void dijkstra(){
    for (int i = 1; i <= n; ++i){
        dp[i] = inf * inf;
    }
    set<pair<ll, int>> setik;
    setik.insert(mp(0, s));
    dp[s] = 0;
    while (setik.size() > 0){
        pair<ll, int> cur = *setik.begin();
        ll cost = cur.f, v = cur.s;
        setik.erase(cur);
        if (cost > dp[v])
            continue;
        for (auto to : g[v]){
            int nv = to.f, l2 = to.s;
            if (dp[nv] > dp[v] + l2){
                dp[nv] = dp[v] + l2;
                setik.insert(mp(dp[nv], nv));
            }
        }
    }
}
void dijkstra2(){
    for (int i = 1; i <= n; ++i){
        dp3[i] = inf * inf;
    }
    set<pair<ll, int>> setik;
    setik.insert(mp(0, t));
    dp3[t] = 0;
    dpk[t] = 1;
    while (setik.size() > 0){
        pair<ll, int> cur = *setik.begin();
        ll cost = cur.f, v = cur.s;
        setik.erase(cur);
        if (cost > dp3[v])
            continue;
        for (auto to : g[v]){
            int nv = to.f, l2 = to.s;
            if (dp3[nv] > dp3[v] + l2){
                dp3[nv] = dp3[v] + l2;
                dpk[nv] = dpk[v];
                setik.insert(mp(dp3[nv], nv));
            }
            else if (dp3[nv] == dp3[v] + l2){
                dpk[nv] = (dpk[nv] + dpk[v]) % mod;
            }
        }
    }
}
void dfs(int v, ll curlen = 0){
    for (auto to : g2[v]){
        dfs(to.f, curlen + to.s);
        dp2[v] = (dp2[v] + dp2[to.f]) % mod;
    }
    for (auto to : g[v]){
        if (curlen + to.s + dp3[to.f] == l){
            dp2[v] = (dp2[v] + dpk[to.f]) % mod;
            /*if (dpk[to.f] > 0){
                cout << v << " " << to.f << " " << dpk[to.f] << '\n';
            }*/
        }
    }/*
    cout << v << " " << dp2[v] << '\n';*/
}
int main() {
    speed;
    cin >> n >> m;
    cin >> s >> t >> l;
    for (int i = 1; i <= m; ++i){
        cin >> u[i] >> v[i] >> w[i];
        g[u[i]].pb(mp(v[i], w[i]));
        g[v[i]].pb(mp(u[i], w[i]));
    }
    dijkstra();
    dijkstra2();
    for (int i = 1; i <= m; ++i){
        if (dp[u[i]] + w[i] + dp3[v[i]] == dp[t]){
            g2[u[i]].pb(mp(v[i], w[i]));
        }
        else if (dp[v[i]] + w[i] + dp3[u[i]] == dp[t]){
            g2[v[i]].pb(mp(u[i], w[i]));
        }
    }
    dpk[t] = 1;
    dfs(s);
    cout << dp2[s];
}
/*
6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4
0 2 4 6 4 8 1 2
1 3
2 5
2 4
5 6
0



6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4
6 1
5 1
2 1
ok
1 1
0
*/
