#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define ll long long
#define int ll
#define ld long double
#define ins insert
#define emin(x, y) (x = min(x, y))
#define emax(x, y) (x = max(x, y))
#define ss size()
#define fi first
#define se second
#define pb push_back
#define FOR(x, y, z) for (int x = y; x <= z; x++)
#define ROF(x, y, z) for (int x = y; x >= z; x--)

using namespace std;
using namespace __gnu_pbds;

typedef tree < int, null_type, less < int >, rb_tree_tag, tree_order_statistics_node_update > ordered_set;

const ll INF = 1e18;
const int N = 1e3 + 40, T = 4 * N, inf = 1e9 + 7, sx[] = {1, 0, -1, 0}, sy[] = {0, 1, 0, -1};

int n, m, e, l, r, id, mn = inf, mx, w;

int p[N][N], M[N][N], us[N * N], X[N * N], Y[N * N], d[N * N], par[N * N];
set < int > S[N];
vector < int > g[N * N];
char c[N][N];

ll f;

int get(int x, int y1, int y2)
{
    return p[x][y2] - p[x][y1 - 1];
}

void add(int v)
{
    us[v] = 1;
    int x = X[v];
    int y = Y[v];
    if (S[x].ss) f -= get(x, *S[x].rbegin(), *S[x].begin());
    S[x].ins(y);
    f += get(x, *S[x].rbegin(), *S[x].begin());
    if (S[x].ss == 2) e++;
}

void del(int v)
{
    us[v] = 2;
    int x = X[v];
    int y = Y[v];
    if (S[x].ss) f -= get(x, *S[x].rbegin(), *S[x].begin());
    if (S[x].ss == 2) e--;
    S[x].erase(y);
    if (S[x].ss) f += get(x, *S[x].rbegin(), *S[x].begin());
}

void out()
{
    FOR (i, 1, n)
    {
        FOR (j, 1, m)
        {
            if (us[M[i][j]] == 1) cout << '#';
            else cout << '.';
        }
        cout << endl;
    }
    FOR (i, 1, n)
    {
        cout << *S[i].rbegin() << " " << *S[i].begin() << endl;
    }
    cout << endl;
}

void dfs(int v, int pr)
{
    d[v] = d[pr] + 1;
    add(v);
    for (auto to : g[v])
    {
        if (to == pr) continue;
        if (us[to] == 2) continue;
        if (us[to] == 1)
        {
            if (f && e)
            {
                if (d[v] - d[to] <= 4) continue;
                //out();
                emin(mn, d[v] - d[to]);
            }
            continue;
        }
        dfs(to, v);
    }
    del(v);
}

void ans(int v, int to)
{
    int x = v;
    while (x != to)
    {
        us[x] = 3;
        x = par[x];
    }
    us[to] = 3;

    FOR (i, 1, n)
    {
        FOR (j, 1, m)
        {
            if (us[M[i][j]] == 3) cout << '#';
            else cout << '.';
        }
        cout << endl;
    }
    exit(0);
}

void dfs1(int v, int pr)
{
    d[v] = d[pr] + 1;
    par[v] = pr;
    add(v);
    for (auto to : g[v])
    {
        if (to == pr) continue;
        if (us[to] == 2) continue;
        if (us[to] == 1)
        {
            if (f && e)
            {
                //out();
                ans(v, to);
            }
            continue;
        }
        dfs1(to, v);
    }
    del(v);
}

void solve()
{
    int x = 0, y = 0, z = 0;

    cin >> n >> m;

    FOR (i, 1, n)
    {
        FOR (j, 1, m)
        {
            cin >> c[i][j];
            p[i][j] = p[i][j - 1];
            if (c[i][j] == '.') p[i][j]++;
            M[i][j] = ++id;
            X[id] = i;
            Y[id] = j;
        }
    }
    FOR (i, 1, n)
    {
        FOR (j, 1, m)
        {
            if (c[i][j] != '#') continue;
            FOR (k, 0, 3)
            {
                int nx = i + sx[k];
                int ny = j + sy[k];
                if (c[nx][ny] != '#') continue;
                x = M[i][j];
                y = M[nx][ny];
                g[x].pb(y);
                g[y].pb(x);
            }
        }
    }

    FOR (i, 1, n)
    {
        FOR (j, 1, m)
        {
            if (!us[M[i][j]]) dfs(M[i][j], 0);
        }
    }
    //cout << mn << endl;

    FOR (i, 1, n)
    {
        S[i].clear();
        FOR (j, 1, m)
        {
            us[M[i][j]] = 0;
            d[M[i][j]] = 0;
        }
    }
    f = 0;
    e = 0;
    FOR (i, 1, n)
    {
        FOR (j, 1, m)
        {
            if (!us[M[i][j]])
            {
                dfs1(M[i][j], 0);
            }
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    solve();
}
