#include "bits/stdc++.h"

using namespace std;
#define int long long
#define ff first
#define ss second
const int N = 1e5 + 1;
const int M = 2e9;
vector< pair<int ,int> > a(N);
int n, B,c;
pair<int, int> tree[4 * N];


pair<int, int> combine(pair<int, int> a, pair<int, int> b){
    if(a.ff > b.ff) return a;
    if(b.ff > a.ff)return a;
    if(a.ss>b.ss)return b;
    return a;
}

void build(int v, int vl, int vr){
    if(vl == vr){
        if(vl > n) tree[v] = {M, 1LL};
        else tree[v] = {a[vl].ss, vl};
        return;
    }
    int mid = (vl + vr)>>1;
    build(v<<1|1, vl, mid);
    build(v*2+2, mid+1, vr);
    tree[v] = combine(tree[v<<1|1], tree[v*2+2]);
}

pair<int, int> get_min(int l, int r, int v, int vl, int vr){
    if(l > vr or vl > r) return {M, 1};
    if(l <= vl and r >= vr) return tree[v];
    int mid = (vl + vr)>>1;
    pair<int, int> L = get_min(l, r, v<<1|1, vl, mid);
    pair<int, int> R = get_min(l, r, (v * 2)+2, mid+1, vr);
    return combine(L,R);
}
/*
pair<int, int> get_first(int l, int r, int x, int v, int vl, int vr){
    if(vl > r || l > vr) return {-1e9, 1};
    if(vl == vr) {
        if(l <= vl && vr <= r) return tree[v];
        else return {-1e9,1};
    }
    if(l <= vl && vr <= r) {
        int vm = (vl + vr) / 2;
        if(tree[2*v+1].first > x && tree[2*v+2].first > x) return tree[v];
        if(tree[2*v+1].first > x) return get_first(l, r, x, 2*v+2, vm + 1, vr);
        if(tree[2*v+2].first > x) return get_first(l, r, x, 2*v+1, vl, vm);
        auto L = get_first(l, r, x, 2*v+1, vl, vm);
        auto R = get_first(l, r, x, 2*v+2, vm + 1, vr);
        if(x - L.first <= x - R.first) return L;
        return R;
    }
    int vm = (vl + vr) / 2;
    auto L = get_first(l, r, x, 2*v+1, vl, vm);
    auto R = get_first(l, r, x, 2*v+2, vm + 1, vr);
    if(x - L.first <= x - R.first) return L;
    return R;
}*/

main () {
    cin >> n >> B >> c;
    vector<int> x(n);
    for(int i = 0; i < n; i ++) cin >> a[i].first >> a[i].second;
    for(int i = 0;i < n; i++){
        x[i] = a[i].ff;
    }
    build(0, 0, n);
    priority_queue <pair <int,int>> q;
    q.push({0, 0});
    vector <int> dist(n, M);
    dist[0] = 0;
    vector<int> go(n,0);
    stack<pair<int, int> > st;
    st.push(a[n-1]);
    for(int i = n-2; i >= 0; i--){
        while(st.empty() == false){
            pair<int, int> v = st.top();
            if(v.ff == a[i].ss){
                go[i] = v.ss;
            }
            if(v.ff >= a[i].ss){
                st.pop();
            }else{
                go[i] = v.ss;
                break;
            }
        }
        st.push(a[i]);
    }



    while(!q.empty()){
        int v = q.top().second;
        q.pop();
        int i;
        if(v + 1 < n){
            i = v+1;
            if((a[i].first - a[v].first) * a[v].second <= B-dist[v]
             && a[i].first - a[v].first <= c
            && (a[i].first - a[v].first) * a[v].second < dist[i]) {
                dist[i] = dist[v] + (a[i].first - a[v].first);
                q.push({-dist[i], i});
            }
        }
        if(go[v] > v){
                i = go[v];
                if((a[i].first - a[v].first) * a[v].second <= B-dist[v]
                 && a[i].first - a[v].first <= c
                && (a[i].first - a[v].first) * a[v].second < dist[i]) {
                    dist[i] = dist[v] + (a[i].first - a[v].first);
                    q.push({-dist[i], i});
                }
        }
    }
    int ans = 0;
    for(int i = 0; i < n; i ++) {
            //cout << dist[i] << " ";
        if(dist[i] >= M) continue;
        ans = max(ans, a[i].first + min(c, (B - dist[i]) / a[i].second));
    }
    cout << ans;
    return 0;
}
