#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define pii pair < ll, ll >

const int N = 1e5 + 5, mod = 1e9 + 7, INF = 2e9 + 7;

const ll BIG = 1e18;

int n, b, c, a[N], p[N], b1;

int u[N * 4], t[N * 4];


void push(int v, int l, int r){
    u[v + v] += u[v];
    u[v + v + 1] += u[v];
    t[v + v] += u[v];
    t[v + v + 1] += u[v];
    u[v] = 0;
}

void build(int v, int l, int r){
    if(l == r){
        t[v] = 0;
        return;
    }
    int tm = (l + r) >> 1;
    push(v, l, r);
    build(v + v, l, tm);
    build(v + v + 1, tm + 1, r);
    t[v] = 0;
}

void update(int v, int l, int r, int x, int y, int val){
    if(x > r or l > y)
        return;
    if(x <= l and r <= y){
        u[v] += val;
        t[v] += val;
        return;
    }
    int tm = (l + r) >> 1;
    push(v, l, r);
    update(v + v, l, tm, x, y, val);
    update(v + v + 1, tm + 1, r, x, y, val);
    t[v] = max(t[v + v], t[v + v + 1]);
}

int get(int v, int l, int r, int x, int y){
    if(x > r or l > y)
        return -INF;
    if(x <= l and r <= y)
        return t[v];
    int tm = (l + r) >> 1;
    return max(get(v + v, l, tm, x, y), get(v + v + 1, tm + 1, r, x, y));
}

set < pair < int, int > > s;//cost and index

inline bool check(int x){
    b = b1;
    //    cout << "for x = " << x << endl;
    build(1, 0, n);
    s.clear();
    s.insert({p[1], -1});
    for(int i = 2; i <= n + 1; i++){
        int cur = min(x, a[i]);
        int dist = cur - a[i - 1];
        if(dist > get(1, 0, n, i - 1, i - 1)){
            bool cond = 0;
            while(!cond){
                if(s.empty()){
                 //   cout << "batsnem\n";
                    return 0;
                }
                pair < int, int > v = *s.begin();
                if(get(1, 0, n, -v.second, i - 1) + dist > c){
                    int distp = c - get(1, 0, n, 1, -v.second);
                    update(1, 0, n, -v.second, i - 1, distp);
                    dist -= distp;
                    if(b < distp * 1ll * v.first)
                        return 0;
                    b -= distp * v.first;
                    s.erase(v);
                }
                else{
                    cond = 1;
                    update(1, 0, n, -v.second, i - 1, dist);
                    if(b < dist * 1ll * v.first)
                        return 0;
                    b -= dist * v.first;
                }
            }
            update(1, 0, n, i, i, get(1, 0, n, i - 1, i - 1) - (cur - a[i - 1]));
        }
        else{
            update(1, 0, n, i, i, get(1, 0, n, i - 1, i - 1) - dist);
        }
        if(a[i] >= x)
            return 1;
        s.insert({p[i], -i});
    }
    return 1;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    //cin >> n >> b >> c;
    scanf("%d%d%d", &n, &b, &c);
    b1 = b;
    for(int i = 1; i <= n; i++){
        //cin >> a[i] >> p[i];
        scanf("%d%d", &a[i], &p[i]);
    }
    //cout << "buhoi" << endl;
    a[n + 1] = INF;
    int l = 0, r = 1e9, ans = -20;
    while(l <= r){
        int mid = (l + r) >> 1;
        if(check(mid)){
            l = mid + 1;
            ans = mid;
        }
        else{
            r = mid - 1;
        }
    }
    //cout << ans << endl;
    printf("%d", ans);
}
