#include <bits/stdc++.h>
using namespace std;

void fastIO() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
}

const long long inf = 1e12;
const int N = 5e5 + 10;
long long n, a[N];
long long p[N];

void solve() {
  cin >> n;
  
  for(int i = 1; i <= n; i++) {
    cin >> a[i];
  }

  multiset<long long> mt;
  for(int i = 2; i <= (n + 1) / 2; i++) {
    mt.insert(a[i] + a[n - i + 2]);
    p[i] = n - i + 2;
    p[n - i + 2] = i;
  }

  long long pat = *mt.rbegin() - *mt.begin();
  for(int i = 2; i <= n; i++) {
    mt.erase(mt.find(a[p[i]] + a[i]));

    p[i - 1] = p[i];
    p[p[i]] = i - 1;
    p[i] = -1;

    mt.insert(a[p[i - 1]] + a[i - 1]);
    pat = min(pat, *mt.rbegin() - *mt.begin());
  }

  cout << pat << '\n';
}

int main() {
  int test_cases = 1;
  // cin >> test_cases;

  while(test_cases--) {
    solve();
  }
  return 0;
}