#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define f first
#define s second
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

typedef tree
<ll,
 null_type,
 less<ll>,
 rb_tree_tag,
 tree_order_statistics_node_update> ordered_set;

const ll N = 2e5 + 100;
const ll oo = 1e18;
const ll MOD = 1e9 + 7;

 vector <pair<ll, ll> > a[N];
 pair<ll, ll> st_inf[N];
 pair<ll, ll> fn_inf[N];

 ll sum(ll x, ll y)
 {
     return (x + y) % MOD;
 }

 ll mult(ll x, ll y)
 {
     return (x * y) % MOD;
 }

int main()
{
    ios_base::sync_with_stdio(0);
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m;
    cin >> n >> m;
    ll st, fn, len;
    cin >> st >> fn >> len;
    for (ll i = 0; i < m; i++)
    {
        ll x, y, z;
        cin >> x >> y >> z;
        a[--x].pb({--y, z});
        a[y].pb({x, z});
    }

    for (ll i = 0; i < n; i++) st_inf[i] = {oo, 0};
    st_inf[--st] = {0, 1};
    priority_queue<pair<ll, ll>, vector <pair<ll, ll> >, greater<pair<ll, ll> > > q;
    q.push({0, st});
    while (!q.empty())
    {
        pair<ll, ll> c = q.top();
        q.pop();
        if (c.f > st_inf[c.s].f) continue;
        for (auto i : a[c.s])
        {
            if (i.s + st_inf[c.s].f < st_inf[i.f].f)
            {
                st_inf[i.f] = {i.s + st_inf[c.s].f, st_inf[c.s].s};
                q.push({st_inf[i.f].f, i.f});
            }
            else
            if (i.s + st_inf[c.s].f == st_inf[i.f].f)
            {
                st_inf[i.f].s = sum(st_inf[i.f].s, st_inf[c.s].s);
            }
        }
    }

    for (ll i = 0; i < n; i++) fn_inf[i] = {oo, 0};
    fn_inf[--fn] = {0, 1};
    q.push({0, fn});
    while (!q.empty())
    {
        pair<ll, ll> c = q.top();
        q.pop();
        if (c.f > fn_inf[c.s].f) continue;
        for (auto i : a[c.s])
        {
            if (i.s + fn_inf[c.s].f < fn_inf[i.f].f)
            {
                fn_inf[i.f] = {i.s + fn_inf[c.s].f, fn_inf[c.s].s};
                q.push({fn_inf[i.f].f, i.f});
            }
            else
            if (i.s + fn_inf[c.s].f == fn_inf[i.f].f)
            {
                fn_inf[i.f].s = sum(fn_inf[i.f].s, fn_inf[c.s].s);
            }
        }
    }
    ll ans = 0;
    for (ll i = 0; i < n; i++)
        for (auto j : a[i])
    {
        if (st_inf[i].f + j.s + fn_inf[j.f].f == len && st_inf[j.f].f != st_inf[i].f + j.s)
        {
            ans = sum(ans, mult(st_inf[i].s, fn_inf[j.f].s));
        }
    }
    if (st_inf[fn].f == len) ans = sum(ans, st_inf[fn].s);
    cout << ans;


}
/*
6 7
1 6 5
1 2 3
2 5 1
1 3 1
3 5 1
2 4 1
5 6 2
4 6 1

5 5
1 5 4
1 3 2
1 2 1
2 3 1
4 2 1
5 2 1
*/
