#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define sz(x) long(x.size())
typedef long long ll;
typedef long double ld;

const int MX = 3e6 + 2;
const int INF32 = 3e9 + 5;
const ll INF64 = 2e18 + 7;

int n, m, ind = 1, a[MX], q[MX], t[MX * 4], son[MX * 4];


void create(int v) {
    if (son[v] != 0) return;
    son[v] = ind;
    ind += 2;
}


void update(int v, int tl, int tr, int i, int x) {
    create(v);
    if (tl == tr) {
        t[v] = x;
        return;
    }
    int tm = (tl + tr) / 2;
    if (i <= tm) update(son[v], tl, tm, i, x);
    else update(son[v] + 1, tm + 1, tr, i, x);
    t[v] = t[son[v]] + t[son[v] + 1];
}


int get(int v, int tl, int tr, int l, int r) {
    create(v);
    if (l > tr || tl > r) return 0;
    if (l <= tl && tr <= r) return t[v];
    int tm = (tl + tr) / 2;
    return get(son[v], tl, tm, l, r) + get(son[v] + 1, tm + 1, tr, l, r);
}

void solve() {
    cin >> n >> m;
    vector<int> aa(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        aa[i] = a[i];
        update(0, 0, INF32 - 1, a[i], 1);
    }
    sort(all(aa));
    for (int i = 0; i < m; i++) cin >> q[i];
    for (int i = 0; i < m; i++) {
        int l = -1;
        int r = INF32 - 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            auto it = upper_bound(all(aa), mid) - aa.begin();
            it--;
            int zr = mid - it;
            //cout << mid << " " << zr << "\n";
            if (zr >= q[i]) r = mid;
            else l = mid;
        }
        cout << r << " ";
    }
}

int32_t main() {
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) solve();
    return 0;
}
