#include <bits/stdc++.h>

#pragma GCC optimize ("-O3")
#pragma GCC optimize ("unroll-loops")
#pragma GCC target ("avx2")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define int long long

using namespace std;

typedef long double ld;
typedef long long ll;


const ll mod = 1e9 + 7;
const ll base = 1e6 + 6;
const ll inf = 1e18;
const int MAX = 2e5;

random_device rd;

int f(int x, int y, int a, int b) {
    int ans = max(x - a + 1, 0LL) * max(y - b + 1, 0LL) + max(x - b + 1, 0LL) * max(y - a + 1, 0LL);
    if(a == b) {
        ans /= 2;
    }
    ans %= mod;
    return ans;
}

void adds(int &a, int b) {
    b %= mod;
    a += b;
    if(a >= mod) {
        a -= mod;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> dp(n + 1, vector<int>(m + 1));
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            if(i <= 2 || j <= 2) {
                dp[i][j] = i * j;
                continue;
            }
            dp[i][j] = i * j;
            for(int x = 1; x <= i - 2; x++) {
                for(int y = 1; y <= j - 2; y++) {
                    dp[i][j] += (i * j + dp[x][y]) * f(i - 2, j - 2, x, y);
                    dp[i][j] %= mod;
                }
            }
        }
    }
    cout << dp[n][m] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) {
        solve();
    }
}
