#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define int ll
struct p {
    int v,w;
};
vector<vector<p>> g;

const int M = 1e9+7;

void solve() {

    int n,m; cin >> n >> m;
    int s,t,l; cin >> s >> t >> l, --s,--t;
    g.resize(n);
    while(m--) {
        int u,v,w; cin >> u >> v >> w, --u, --v;
        g[u].push_back({v,w});
        g[v].push_back({u,w});
    }

    vector<__int128> dt(n, __int128(1)<<23); dt[t] = 0;
    vector<int> ct(n); ct[t] = 1;
    set<pair<__int128, int>> st; st.insert({dt[t],t});
    while(!st.empty()) {
        int v = st.begin()->second; st.erase(st.begin());

        for(auto &[u,w] : g[v]) {
            if(dt[u] > dt[v]+w) {
                st.erase({dt[u], u});
                dt[u] = dt[v]+w;
                ct[u] = ct[v];
                ct[u]%=M;
                st.insert({dt[u], u});
            }
            else if(dt[u] == dt[v]+w) {
                ct[u]+=ct[v];
                ct[u]%=M;
            }
        }
    }

    vector<__int128> ds(n, __int128(1)<<23); ds[s] = 0;
    vector<int> cs(n); cs[s] = 1;
    st.clear(); st.insert({ds[s],s});
    while(!st.empty()) {
        int v = st.begin()->second; st.erase(st.begin());

        for(auto &[u,w] : g[v]) {
            if(ds[u] > ds[v]+w) {
                st.erase({ds[u], u});
                ds[u] = ds[v]+w;

                cs[u] = cs[v];
                cs[u]%=M;
                st.insert({ds[u], u});
            }
            else if(ds[u] == ds[v]+w) {
                cs[u]+=cs[v];
                cs[u]%=M;
            }
        }
    }

    int dst = ds[t];

//    for(auto &i : ct) cout << i << ' ';

    int res = 0;
    for(int i = 0; i < n; ++i) {
        if(ds[i] + dt[i] == dst) {
            for(auto &[u,w] : g[i]) {
                if(ds[i] + w + dt[u] == l) {
                    res += (cs[i]*ct[i])%M;
                    res%=M;
                }
            }
        }
    }

    cout << res << '\n';

    return;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
#ifdef ischv
    freopen("../.in", "r", stdin);
    freopen("../.out", "w", stdout);
#endif

    solve();
}