#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <cmath>
#include <string>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;
typedef long long ll;
typedef long double ld;
const long long INF = 1e18;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	int n;
	ll ans = INF;
	cin >> n;
	vector<ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	sort(a.begin(), a.end());
	multiset<ll> s;
	int l, r;
	ll mi, ma;

	ma = -INF;
	mi = INF;
	l = 0;
	r = n - 1;
	while (l < r) {
		s.insert(a[l] + a[r]);
		l++;
		r--;
	}
	ans = *s.rbegin() - *s.begin();

	for (int i = n / 2 - 1; i >= 0; i--) {
		s.erase(s.find(a[i] + a[n - 1 - i]));
		s.insert(a[i + 1] + a[n - 1 - i]);
		ans = min(ans, *s.rbegin() - *s.begin());
	}
	s.clear();

	ma = -INF;
	mi = INF;
	l = 0;
	r = n - 1;
	while (l < r) {
		s.insert(a[l] + a[r]);
		l++;
		r--;
	}

	for (int i = n / 2 - 1; i >= 0; i--) {
		s.erase(s.find(a[i] + a[n - 1 - i]));
		s.insert(a[i] + a[n - 1 - i - 1]);
		ans = min(ans, *s.rbegin() - *s.begin());
	}

	cout << ans;
}