#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<vector>
#include<queue>
#include<deque>
#include<bitset>
#include<random>

using namespace std;
using ll = long long;
using ld = long double;

#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'

const int N = 1009;
const ll INF = 1e18 + 9, MOD = 1e9+7;

char a[N][N];
int used[N][N];

int mn[N];

int d[N][N];

int dx[] = { 0, -1, 0, 1 };
int dy[] = { -1, 0, 1, 0 };

pair<int, int> p[N][N];
int n, m;

int ans[N][N];

int col[N][N];

void dfs(int i, int j) {
	if (i < 1 || j < 1 || i > n || j > m || a[i][j] == '#' || col[i][j])
		return;
	col[i][j] = 1;
	for (int k = 0; k < 4; k++)
		dfs(i + dx[k], j + dy[k]);
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif



	cin >> n >> m;
	for (int i = 1; i <= m; i++)
		mn[i] = INF;
	int cor = INF;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			cin >> a[i][j];
			if (a[i][j] != '#') {
				used[i][j] = 1;
			}
		}
	}

	for (int i = 1; i <= n; i++) {
		dfs(i, 1);
		dfs(i, m);
	}
	for (int j = 1; j <= m; j++) {
		dfs(1, j);
		dfs(n, j);
	}

	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			if (a[i][j] != '#' && !col[i][j]) {
				mn[j] = min(mn[j], i);
				cor = min(cor, i);
			}
		}
	}

	int x, y;
	for (int j = 1; j <= m; j++) {
		if (mn[j] == cor) {
			x = cor - 1;
			y = j;
			break;
		}
	}

	for (int i = 0; i <= max(n, m) + 1; i++) {
		used[i][0] = 1;
		used[i][m + 1] = 1;
		used[0][i] = 1;
		used[n + 1][i] = 1;
	}

	for (int i = 0; i <= x; i++)
		used[i][y] = 1;

	queue<pair<int, int>> q;
	q.push({ x, y + 1 });
	used[x][y + 1] = 1;
	d[x][y + 1] = 0;
	while (q.size()) {
		int i = q.front().first;
		int j = q.front().second;
		q.pop();
		for (int k = 0; k < 4; k++) {
			int i1 = i + dx[k], j1 = j + dy[k];
			if (!used[i1][j1]) {
				used[i1][j1] = 1;
				q.push({ i1, j1 });
				d[i1][j1] = d[i][j] + 1;
				p[i1][j1] = { i, j };
			}
		}
	}
	int i = x, j = y - 1;
	ans[x][y] = 1;
	ans[x][y + 1] = 1;
	while (i != x || j != y + 1) {
		ans[i][j] = 1;
		int i0 = i, j0 = j;
		i = p[i0][j0].first;
		j = p[i0][j0].second;
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			if (ans[i][j])cout << "#";
			else
				cout << ".";
		}
		cout << endl;
	}

}