#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<vector>
#include<queue>
#include<deque>
#include<bitset>
#include<random>

using namespace std;
using ll = long long;
using ld = long double;

#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'

const int N = 1009;
const ll INF = 1e18 + 9, M = 1e9 + 7;

struct mod {
	int x;
	mod(int d) {
		x = d;
	}
	mod() {
		x = 0;
	}
};

mod operator +(mod a, mod b) {
	if (a.x + b.x >= M)
		return a.x + b.x - M;
	return a.x + b.x;
}

mod operator -(mod a, mod b) {
	if (a.x < b.x)
		return a.x - b.x + M;
	return a.x - b.x;
}

mod operator *(mod a, mod b) {

	return (a.x * b.x) % M;
}


mod dp[N][N];
mod cnt[N][N];
mod pref[N][N];
mod pref2[N][N];


signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif


	int n, m;
	cin >> n >> m;


	for (int x = 1; x <= n; x++) {

		for (int y = 1; y <= m; y++) {
			for (int i = 1; i <= x - 2; i++) {
				cnt[x][y] = cnt[x][y] + (x - 1 - i) * pref2[i][y - 2];
			}
			cnt[x][y] = cnt[x][y] + 1;
		}

		for (int y = 1; y <= m; y++) {
			for (int i = 1; i <= x - 2; i++) {
				dp[x][y] = dp[x][y] + (x - 1 - i) * pref[i][y - 2];
			}
			dp[x][y] = dp[x][y] + x * y * cnt[x][y];
		}

		

		mod sum = 0;
		for (int y = 1; y <= m; y++) {
			sum = sum + dp[x][y];
			pref[x][y] = pref[x][y - 1] + sum;
		}

		sum = 0;
		for (int y = 1; y <= m; y++) {
			sum = sum + cnt[x][y];
			pref2[x][y] = pref2[x][y - 1] + sum;
		}
	}
	cout << dp[n][m].x;
}