//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,abm,popcnt,mmx")
#include<bits/stdc++.h>

#define girlfriend friend
#define int int_fast64_t
#define input(a) for (auto &_ : a) cin >> _;
#define print(a) for (auto _ : a) {cout << _ << " ";} cout << '\n';

using namespace std;

typedef long long ll;
//typedef int_fast64_t ll;

constexpr ll INF32 = 2'000'000'000, INF64 = 4'000'000'000'000'000'000, MOD = 1'000'000'007;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

template<typename T>
bool assign_min(T& a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
T square(T a) {
    return a * a;
}

struct segment_tree {
    vector<pair<ll, ll>> tree;
    ll size;
    segment_tree(vector<ll> arr) {
        size = 1;
        while (size < arr.size()) {
            size *= 2;
        }
        tree.resize(size * 2, make_pair(INF32, INF32));
        arr.resize(size, 0);
        build(1, 0, size, arr);
    }
    void build(ll v, ll l, ll r, vector<ll>& arr) {
        if (r - l == 1) {
            tree[v] = make_pair(arr[l], l);
            return;
        }
        ll mid = (l + r) / 2;
        build(v * 2, l, mid, arr);
        build(v * 2 + 1, mid, r, arr);
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }
    pair<ll, ll> get(ll l, ll r) {
        return get(1, 0, size, l, r);
    }
    pair<ll, ll> get(ll v, ll l, ll r, ll ql, ll qr) {
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        if (l >= qr || r <= ql) {
            return make_pair(INF32, INF32);
        }
        ll mid = (l + r) / 2;
        return min(get(v * 2, l, mid, ql, qr), get(v * 2 + 1, mid, r, ql, qr));
    }
};

struct act {
    int pos, len, ind;

    act() = default;

    act(int a, int b, int c) : pos(a), len(b), ind(c) {}
};

bool cmp(act &a, act &b) {
    if (a.pos == b.pos) return a.len < b.len;
    return a.pos < b.pos;
}
vector<int> dx = {0, 0, -1, 1}, dy{-1, 1, 0, 0};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> dp1(n+1, vector<int> (m+1)), dp2(n+1, vector<int> (m+1)), prefx1(n+1, vector<int> (m+1)), prefx2(n+1, vector<int> (m+1)), prefy1(n+1, vector<int> (m+1)), prefy2(n+1, vector<int> (m+1)), pref1(n+1, vector<int> (m+1)), pref2(n+1, vector<int> (m+1)), prefxy1(n+1, vector<int> (m+1)), prefxy2(n+1, vector<int> (m+1));
    for (int j = 1; j<=m; ++j) {
        dp1[1][j] = j;
        dp2[1][j] = 1;
        if (n > 1) {
            dp1[2][j] = 2*j;
            dp2[2][j] = 1;
        }
    }
    for (int i = 1; i<=n; ++i) {
        dp1[i][1] = i;
        dp2[i][1] = 1;
        if (m > 1) {
            dp1[i][2] = 2*i;
            dp2[i][2] = 1;
        }
    }
    for (int i = 1; i<=n; ++i) {
        for (int j = 1; j<=m; ++j) {
            if (i > 2 && j > 2) {
                dp2[i][j] = (pref2[i-2][j-2]*(i-1)*(j-1))%MOD;
                for (int x = 1; x<=i-2; ++x) {
                    dp2[i][j] += MOD;
                    dp2[i][j] -= (prefx2[x][j-2]*x*(j-1))%MOD;
                    dp2[i][j] %= MOD;
                }
                for (int y = 1; y<=j-2; ++y) {
                    dp2[i][j] += MOD;
                    dp2[i][j] -= (prefy2[i-2][y]*y*(i-1))%MOD;
                    dp2[i][j] %= MOD;
                }
                dp2[i][j] += prefxy2[i-2][j-2]+1;
                dp2[i][j] %= MOD;
                dp1[i][j] = (dp2[i][j]*i*j)%MOD;
                dp1[i][j] += (pref1[i-2][j-2]*(i-1)*(j-1))%MOD;
                dp1[i][j] %= MOD;
                for (int x = 1; x<=i-2; ++x) {
                    dp1[i][j] += MOD;
                    dp1[i][j] -= (prefx1[x][j-2]*x*(j-1))%MOD;
                    dp1[i][j] %= MOD;
                }
                for (int y = 1; y<=j-2; ++y) {
                    dp1[i][j] += MOD;
                    dp1[i][j] -= (prefy1[i-2][y]*y*(i-1))%MOD;
                    dp1[i][j] %= MOD;
                }
                dp1[i][j] += prefxy1[i-2][j-2];
                dp1[i][j] %= MOD;
            }
            pref1[i][j] = (pref1[i-1][j]+pref1[i][j-1]-pref1[i-1][j-1]+dp1[i][j]+MOD)%MOD;
            pref2[i][j] = (pref2[i-1][j]+pref2[i][j-1]-pref2[i-1][j-1]+dp2[i][j]+MOD)%MOD;
            prefx1[i][j] = (prefx1[i][j-1]+dp1[i][j])%MOD;
            prefx2[i][j] = (prefx2[i][j-1]+dp2[i][j])%MOD;
            prefy1[i][j] = (prefy1[i-1][j]+dp1[i][j])%MOD;
            prefy2[i][j] = (prefy2[i-1][j]+dp2[i][j])%MOD;
            prefxy1[i][j] = (prefxy1[i-1][j]+prefxy1[i][j-1]-prefxy1[i-1][j-1]+(dp1[i][j]*i*j)%MOD+MOD)%MOD;
            prefxy2[i][j] = (prefxy2[i-1][j]+prefxy2[i][j-1]-prefxy2[i-1][j-1]+(dp2[i][j]*i*j)%MOD+MOD)%MOD;
        }
    }
    cout << dp1[n][m] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    if (1) {
        ll t = 1;
        if (0) {
            cin >> t;
        }
        for (ll _ = 0; _ < t; _++) {
            solve();
        }
    } else {
        while (true) {
        }
    }
}
