#include <iostream>
#include <vector>
#include <algorithm>
#include<bits/stdc++.h>
#define int long long
#define ll long long
#define mxn 1e9 + 9

using namespace std;
const int maxn = 2e5 + 7;
const int inf = 1e16;
#define all(a) a.begin(), a.end()
struct edge{
    int v, u;
    int w;
    int num;
};
vector <edge> edges;
vector <int> g[maxn];
int dist1[maxn];
int dist2[maxn];
int dp1[maxn];
const int mod = 1e9 + 7;
int dp2[maxn];
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int s, t;
    cin >> s >> t;
    int l; cin >> l;
    edges.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> edges[i].u >> edges[i].v >> edges[i].w;
        g[edges[i].u].push_back(i);
        g[edges[i].v].push_back(i);
    }
    set<pair<int, int>> dists;
    fill(dist1, dist1 + maxn, inf);
    dist1[s] = 0;
    dp1[s] = 1;
    for (int i = 1; i <= n; i++) dists.insert({dist1[i], i});
    while (!dists.empty()) {
        auto [dist, v] = *dists.begin();
        dists.erase(dists.begin());
        for (int i: g[v]) {
            int u = edges[i].u + edges[i].v - v;
            if (dist1[u] > dist1[v] + edges[i].w) {
                dists.erase({dist1[u], u});
                dist1[u] = dist1[v] + edges[i].w;
                dp1[u] = 0;
                dists.insert({dist1[u], u});
            }
            if (dist1[u] == dist1[v] + edges[i].w) {
                dp1[u] = (dp1[u] + dp1[v]) % mod;
            }
        }
    }
    fill(dist2, dist2 + maxn, inf);
    dist2[t] = 0;
    dp2[t] = 1;
    for (int i = 1; i <= n; i++) dists.insert({dist2[i], i});
    while (!dists.empty()) {
        auto [dist, v] = *dists.begin();
        dists.erase(dists.begin());
        for (int i: g[v]) {
            int u = edges[i].u + edges[i].v - v;
            if (dist2[u] > dist2[v] + edges[i].w) {
                dists.erase({dist2[u], u});
                dist2[u] = dist2[v] + edges[i].w;
                dp2[u] = 0;
                dists.insert({dist2[u], u});
            }
            if (dist2[u] == dist2[v] + edges[i].w) {
                dp2[u] = (dp2[u] + dp2[v]) % mod;
            }
        }
    }
//    for (int i = 1; i <= n; i++) {
//        cout << dist1[i] << ' ' << dist2[i] << '\n';
//    }
//    cout << " dists\n";
//    for (int i = 1; i <= n; i++) {
//        cout << dp1[i] << ' ' << dp2[i] << '\n';
//    }

    ll ans = 0;
    if (dist1[t] == l) {
        ans += dp1[t];
        cout << ans;
        return 0;
    }
    if (dist1[t] > l) {
        cout << 0;
        return 0;
    }
    for (int i = 1; i <= n; i++) {
        if (i != t && dist1[i] + dist2[i] == dist1[t]) {
            for (int j: g[i]) {
//                cout << j << " j \n";
                int u = edges[j].u + edges[j].v - i;
//                cout << " got len: " << dist1[i] + dist2[u] + edges[j].w << '\n';
                if (dist1[i] + dist2[u] + edges[j].w == l) {
//                    cout << " woww\n";
                    ans += (dp1[i] * dp2[u]) % mod;
                    ans %= mod;
                }
            }
        }
//        cout << ans << " after vertex " << i << '\n';
    }
    cout << ans;
}
/*
 * 6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4
 */