#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define  vec vector
#define int long long

typedef vector<int> vi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vi> vvi;
typedef vector<bool> vb;

template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	cout << (n + 1) / 2 << endl;
	for (int i = 1; i <= n; ++i) {
		cout << (i + 1) / 2 << ' ';
	}
	cout << endl;
	vvi a(n + 1);
	for (int i = 0; i < (n + 1) / 2; ++i) {
		int k;
		cin >> k;
		vi tmp(k);
		input(tmp);
		if (tmp.size() == 2) {
			a[tmp[0]].push_back(tmp[1]);
			a[tmp[1]].push_back(tmp[0]);
		}
	}
	cout << n / 2 + 1 << endl;
	for (int i = 1; i <= n; ++i) {
		cout << i / 2 + 1 << ' ';
	}
	cout << endl;
	for (int i = 0; i < n / 2 + 1; ++i) {
		int k;
		cin >> k;
		vi tmp(k);
		input(tmp);
		if (tmp.size() == 2) {
			a[tmp[0]].push_back(tmp[1]);
			a[tmp[1]].push_back(tmp[0]);
		}
	}
	cout << 2 << endl << 1 << " ";
	for (int i = 2; i <= n; ++i)
		cout << 2 << " ";
	cout << endl;
	int f;
	for (int i = 0; i < 2; ++i) {
		int k;
		cin >> k;
		vi tmp(k);
		input(tmp);
		if (tmp.size() == 1)
			f = tmp[0];
	}
	vb used(n + 1, false);
	vi ans = { f };
	used[f] = true;
	for (int i = 0; i < n - 1; ++i) {
		for (auto u : a[f]) {
			if (used[u])
				continue;
			f = u;
			used[f] = true;
			ans.push_back(f);
			break;
		}
	}
	for (int i = 0; i < n; ++i)
		cout << ans[i] << endl;
	return 0;
}