#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define rep(i, a, b) for(int i = (a); i < (b); i++)

using namespace std;

const int maxn = 2e5 + 17;
ll d1[maxn], d2[maxn], r1[maxn], r2[maxn];
vector<pair<int, ll> > g[maxn];

const int MOD = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    int s, t;
    ll L;
    cin >> s >> t >> L;
    s--; t--;
    rep(i, 0, m) {
        int u, v;
        ll w;
        cin >> u >> v >> w;
        u--; v--;
        g[u].push_back({v, w});
        g[v].push_back({u, w});
    }


    rep(i, 0, n) d1[i] = 1e18;
    d1[s] = 0;
    r1[s] = 1;
    set<pair<int, int> > all;
    all.insert({d1[s], s});
    int next[n];
    while(!all.empty()) {
        int v = (*all.begin()).second;
        all.erase(all.begin());

        for (auto x : g[v]) {
            if (d1[v] + x.second <= d1[x.first]) {
                all.erase({d1[x.first], x.first});
                if (d1[v] + x.second < d1[x.first]) r1[x.first] = 0;
                d1[x.first] = d1[v] + x.second;
                r1[x.first] += r1[v];
                all.insert({d1[x.first], x.first});
            }
        }
    }

   // rep(i, 0, n) cout << d1[i] << " " << r1[i] << endl;

    rep(i, 0, n) d2[i] = 1e18;
    d2[t] = 0;
    r2[t] = 1;
    set<pair<int, int> > all2;
    all2.insert({d2[t], t});
    while(!all2.empty()) {
        int v = (*all2.begin()).second;
        all2.erase(all2.begin());

        for (auto x : g[v]) {
            if (d2[v] + x.second <= d2[x.first]) {
                all2.erase({d2[x.first], x.first});
                if (d2[v] + x.second < d2[x.first]) {
                    r2[x.first] = 0;
                    next[x.first] = v;
                }
                d2[x.first] = d2[v] + x.second;
                r2[x.first] += r2[v];
                all2.insert({d2[x.first], x.first});
            }
        }
    }

  // rep(i, 0, n) cout << d2[i] << " " << r2[i] << endl;


    ll ans = 0;

    cout << endl;
    rep(i, 0, n) for (auto x : g[i]) {
            if (i != t) {
                if (d1[i] + d2[x.first] + x.second == L && x.first != next[i]) {
                    //cout << i + 1 << " " << x.first + 1 << endl;
                    //cout << ans << endl;
                    ans += r1[i] * r2[x.first];
                }
            }
        }

    cout << ans << endl;

    return 0;

}

/*
 * 6 7
1 6 12
1 2 2 1 3 4
2 5 2 3 5 4 2 4 4 4 6 6 5 6 4
 */