#include <bits/stdc++.h>

#define int long long

using namespace std;

int n;
vector<vector<pair<int, int>>> g;

int mod = 1'000'000'007;

void dei(vector<int> &d, vector<int>& ways, int st) {
    set<pair<int, int>> q;
    d.assign(n, INT64_MAX);
    ways.resize(n);
    ways[st] = 1;
    d[st] = 0;
    q.insert({0, st});
    while (!q.empty()) {
        auto [val, v] = *q.begin();
        q.erase(q.begin());
        for (auto [u, cost] : g[v]) {
            if (d[v] + cost == d[u]) {
                ways[u] = (ways[u] + ways[v]) % mod;
            }
            if (d[v] + cost < d[u]) {
                q.erase({d[u], u});
                d[u] = d[v] + cost;
                ways[u] = ways[v];
                q.insert({d[u], u});
            }
        }
    }
}

void solve() {
    int m;
    cin >> n >> m;
    int s, t, l;
    cin >> s >> t >> l;
    s -= 1;
    t -= 1;
    g.resize(n);
    vector<tuple<int, int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int u, v, p;
        cin >> u >> v >> p;
        u -= 1;
        v -= 1;
        g[u].emplace_back(v, p);
        g[v].emplace_back(u, p);
        edges.emplace_back(u, v, p);
        edges.emplace_back(v, u, p);
    }


    vector<int> ds, wayss, dt, wayst;
    dei(ds, wayss, s);
    dei(dt, wayst, t);
    if (ds[t] == l) {
        cout << wayss[t] << '\n';
    } else {
        int ans = 0;
        vector<int> good(n);
        for (auto [u, v, p] : edges) {
            if (ds[u] + p + dt[v] == ds[t]) {
                good[v] = 1;
                good[u] = 1;
            }
        }
        for (auto [u, v, p] : edges) {
            if (good[u] && ds[u] + p + dt[v] == l) {
                ans = (ans + ((wayss[u] * wayst[v]) % mod)) % mod;
            }
        }
        cout << ans << '\n';
    }
}

int32_t main() {
#ifdef DDD
    freopen("../input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    solve();
}