#include <bits/stdc++.h>

using namespace std;
#define int long long

int MOD = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int H, W;
    cin >> H >> W;
    vector<vector<int>> comb(H + 1, vector<int>(W + 1, 1));
    vector<vector<int>> dp(H + 1, vector<int>(W + 1));
    for (int h = 2; h <= H; ++h) {
        vector<int> S(W + 1);
        for (int i = 1; i < h - 1; ++i) {
            for (int j = 1; j <= W; ++j) {
                S[j] += (h - i - 1) * (comb[i][j]) % MOD, S[j] %= MOD;
            }
        }
        for (int w = 2; w <= W; ++w) {
            for (int j = 1; j + 1 < w; ++j) {
                comb[h][w] = (comb[h][w] + S[j] * (w - j - 1) % MOD) % MOD;
            }
        }
    }
    for (int h = 1; h <= H; ++h) {
        vector<int> S(W + 1);
        for (int i = 1; i < h - 1; ++i) {
            for (int j = 1; j <= W; ++j) S[j] += (h - i - 1) * (dp[i][j]) % MOD, S[j] %= MOD;
        }
        for (int w = 1; w <= W; ++w) {
            for (int j = 1; j + 1 < w; ++j) {
                dp[h][w] = (dp[h][w] + S[j] * (w - j - 1) % MOD) % MOD;
            }
            dp[h][w] += (h * w % MOD) * comb[h][w] % MOD;
            dp[h][w] %= MOD;
        }
    }
    cout << dp[H][W] << endl;

}
