#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const long long INF = 1e18;

const ll MOD = 1e9 + 7;

signed main() {
    ll n, m;
    cin >> n >> m;
    ll s, t, L;
    cin >> s >> t >> L;
    s--, t--;
    vector<vector<pair<ll, ll>>> g(n);
    for (ll i = 0; i < m; i++) {
        ll a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        g[a].push_back({b, w});
        g[b].push_back({a, w});
    }
    map<ll, ll> c;
    vector<ll> dist_s(n, INF), dist_t(n, INF);
    set<pair<ll, ll>> d = {{0, s}};
    dist_s[s] = 0;
    while (!d.empty()) {
        ll v = d.begin()->second;
        d.erase(d.begin());
        for (auto [u, w]: g[v]) {
            if (dist_s[u] > dist_s[v] + w) {
                d.erase({dist_s[u], u});
                dist_s[u] = dist_s[v] + w;
                d.insert({dist_s[u], u});
            }
        }
    }
    d.insert({0, t});
    dist_t[t] = 0;
    while (!d.empty()) {
        ll v = d.begin()->second;
        d.erase(d.begin());
        for (auto [u, w]: g[v]) {
            if (dist_t[u] > dist_t[v] + w) {
                d.erase({dist_t[u], u});
                dist_t[u] = dist_t[v] + w;
                d.insert({dist_t[u], u});
            }
        }
    }
    vector<ll> c_s(n);
    vector<pair<ll, ll>> x;
    for (ll i = 0; i < n; i++)
        x.push_back({dist_s[i], i});
    std::sort(x.begin(), x.end());
    c_s[s] = 1;
    for (auto [a, b]: x) {
        for (auto [i, w]: g[b]) {
            if (dist_s[b] == dist_s[i] + w) {
                c_s[b] += c_s[i];
                c_s[b] %= MOD;
            }
        }
    }
    vector<ll> c_t(n);
    x.clear();
    for (ll i = 0; i < n; i++)
        x.push_back({dist_t[i], i});
    std::sort(x.begin(), x.end());
    c_t[t] = 1;
    for (auto [a, b]: x) {
        for (auto [i, w]: g[b]) {
            if (dist_t[b] == dist_t[i] + w) {
                c_t[b] += c_t[i];
                c_t[b] %= MOD;
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        if (dist_s[i] + dist_t[i] != dist_s[t])
            continue;
        ll l = dist_s[i];
        for (auto [j, w]: g[i]) {
            auto l1 = l + w + dist_t[j];
            c[l1] += (c_s[i] * c_t[j]) % MOD;
            c[l1] %= MOD;
        }
    }
    cout << c[L] % MOD;
}

/*
 * 6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4
 */
