#include <bits/stdc++.h>
using namespace std;
#define pb push_back
const double eps = 1e-10;
typedef long long ll;
typedef pair< ll, ll> pll;
typedef pair<int, int> pii;
const int maxN = 2e5 + 9;
const ll MOD = 1e9 + 7;
const ll llinf = 1e18 + 2281337;
ll ds[maxN];
ll dt[maxN];
ll cnts[maxN], cntt[maxN];
int n, m;
vector<pll> g[maxN];
ll pred[maxN];
bool good[maxN];
int s, t; ll L;
void dij(ll from, ll* d, ll* cnt) {
    for(int i = 1; i <= n; ++i) {
        d[i] = llinf;
    }
    d[from] = 0;
    set<pll> q;
    q.insert({d[from], from});
    vector<int> ord;
    while(!q.empty()) {
        ll z, v;
        tie(z, v) = *q.begin(); q.erase(q.begin());
        ord.pb(v);
        for(auto &i: g[v]) {
            ll nd = z + i.second;
            if(d[i.first] > nd) {
                q.erase({d[i.first], i.first});
                d[i.first] = nd;
                q.insert({d[i.first], i.first});
                pred[i.first] = v;
            }
        }
    }

    cnt[from] = 1;
    for(auto &v: ord) {
        for(auto &i: g[v]) {
            if(d[i.first] == d[v] + i.second) {
                cnt[i.first] += cnt[v];
                cnt[i.first] %= MOD;
            }
        }
    }


    for(auto &i: good) i = 0;

    int cv = t;
    while(cv != from) {
        good[cv] = 1;
        cv = pred[cv];
    }
    good[s] = 1;
}
int main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> n >> m;
    cin >> s >> t >> L;
    for(int i = 0; i < m; ++i) {
        ll u, v, w; cin >> u >> v >> w;
        g[u].pb({v, w});
        g[v].pb({u, w});
    }

    dij(t, dt, cntt);
    dij(s, ds, cnts);

//    for(int i = 1; i <= n; ++i) {
//        cout << cnts[i] << ' ';
//    }
//    cout << '\n';
//    for(int i = 1; i <= n; ++i) {
//        cout << ds[i] << ' ';
//    }
//    cout << '\n';


    if(L == ds[t]) {
        cout << cnts[t] << '\n';
        return 0;
    }

    ll ans = 0;
    for(int v = 1; v <= n; ++v) {
        if(v == t || !good[v]) continue;
        for(auto &i: g[v]) {
            if(ds[v] + i.second + dt[i.first] == L) {
                ans += cnts[v] * cntt[i.first];
//                cout << v << ' ' << i.first << '\n';
                ans %= MOD;
            }
        }
    }
    cout << ans << '\n';

}
/*
6 7
1 6 12
1 2 2
1 3 4
2 5 2
3 5 4
2 4 4
4 6 6
5 6 4



 */