#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

ld eps = 1e-7;

ostream& operator << (ostream& out, vector<int>& vec) {
    for (int el :vec) {
        out << el << ' ';
    }
    return out;
}

ostream& operator << (ostream& out, vector<bool>& vec) {
    for (bool el :vec) {
        if (el)
            out << '#';
        else
            out << '.';
    }
    return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<T>& vec) {
    for (T el :vec) {
        out << el << '\n';
    }
    return out;
}

#define int long long
const ll INF = 1e18;

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    //freopen("input.txt", "r", stdin);
    int n;
    ll b, c;
    cin >> n >> b >> c;
    vector<ll> place(n), cost(n);
    for (int i = 0; i < n; ++i) {
        cin >> place[i] >> cost[i];
    }
    vector<ll> right(n);
    vector<ll> st;
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && cost[st.back()] > cost[i]) {
            st.pop_back();
        }
        if (st.empty())
            right[i] = INF;
        else
            right[i] = st.back();
        st.push_back(i);
    }
    //cout << right << endl;
    ll x = 0, i = 0, bak = 0;
    while (true) {
        if (i == n - 1 || x + min(c, b / cost[i] + bak) < place[i + 1]) {
            x += min(c, b / cost[i] + bak);
            break;
        }
        int it = right[i];
        int less = -1;
        if (it == INF || x + min(c, b / cost[i] + bak) < place[it]) {
            //cout << "first " << '\n';
            less = i + 1;
            bak += min(b / cost[i], c);
            b -= min(b / cost[i], c) * cost[i];
        }
        else {
            //cout << "second " << '\n';
            less = it;
            bak += (place[less] - x);
            b -= (place[less] - x) * cost[i];
        }
        //cout << i << ' ' << less << '\n';
        bak -= (place[less] - x);
        x = place[less];
        i = less;
    }
    cout << x;
}
