import sys
import math
from collections import Counter, deque
import heapq


def II():
    return int(sys.stdin.readline())


def I():
    return [int(i) for i in sys.stdin.readline().split()]


def S():
    return sys.stdin.readline().split()


def main():
    n = II()
    a = I()
    a.sort()
    c = Counter()
    idx = 1
    heap_plus = []
    heap_minus = []
    while idx - 1 < n // 2:
        s = a[idx] + a[n - idx]
        c[s] += 1
        idx += 1
        if c[s] == 1:
            heapq.heappush(heap_plus, s)
            heapq.heappush(heap_minus, -s)

    s_min, s_max = -1, -1
    while c[s_min] <= 0:
        s_min = heapq.heappop(heap_plus)
    while c[s_max] <= 0:
        s_max = -heapq.heappop(heap_minus)
    heapq.heappush(heap_minus, -s_max)
    heapq.heappush(heap_plus, s_min)
    ans = s_max - s_min
    for i in range(1, n):
        if i <= n // 2:
            s1 = a[i] + a[n - i]
            s2 = a[i - 1] + a[n - i]
        else:
            s1 = a[i] + a[n - i - 1]
            s2 = a[i - 1] + a[n - i - 1]
        c[s1] -= 1
        c[s2] += 1
        if c[s2] == 1:
            heapq.heappush(heap_plus, s2)
            heapq.heappush(heap_minus, -s2)
        s_min, s_max = -1, -1
        while c[s_min] <= 0:
            s_min = heapq.heappop(heap_plus)
        while c[s_max] <= 0:
            s_max = -heapq.heappop(heap_minus)
        heapq.heappush(heap_minus, -s_max)
        heapq.heappush(heap_plus, s_min)
        ans = min(ans, s_max - s_min)
    print(ans)






if __name__ == '__main__':
    main()