#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

#define ll long long
#define ld long double

using namespace std;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    b[0] = a[0];
    for (int i = 1; i < n; i++) {
        b[i] = a[i] - a[i - 1] - 1 + b[i - 1];
    }
    for (int i = 0; i < q; i++) {
        int k; cin >> k;
        auto it = lower_bound(b.begin(), b.end(), k);
        if (it != b.end()) {
            cout << a[it - b.begin()] - (*it - k) - 1 << ' ';
        } else {
            cout << a[a.size() - 1] + k - b[b.size() - 1] << ' ';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
