#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef vector<ll> vll;
typedef vector<pll> vpll;
typedef long double ld;

const ll INF = 1e18;
const ll LIMIT = 1e9 * 2;

int main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, q;
    cin >> n >> q;
    vll v(n);
    vll v2(q);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < q; ++i) {
        cin >> v2[i];
    }
    vpll g;
    ll l = 0, ind = 0;
    if (v[0] != 0){
        g.push_back({0, v[0] - 1});
    }
    for (int i = 1; i < n; ++i) {
        if (v[i] - v[i - 1] != 1){
            g.push_back({v[i - 1] + 1, v[i] - 1});
        }
    }
    g.push_back({v[n - 1] + 1, LIMIT});
    vll pref;
    for (int i = 0; i < g.size(); ++i) {
        pref.push_back(g[i].second - g[i].first + 1);
        if (i >= 1) {
            pref[pref.size() - 1] += pref[pref.size() - 2];
        }
    }
    for (int i = 0; i < q; ++i) {
        ll l = -1, r = pref.size() + 1, m;
        while (r - l != 1){
            m = (r + l) / 2;
            if (pref[m] >= v2[i]){
                r = m;
            }
            else{
                l = m;
            }
        }
        if (l == -1){
            cout << v2[i] + g[0].first - 1 << " ";
        }
        else {
            cout << g[r].first + (v2[i] - pref[l]) - 1 << " ";
        }
    }
}
