#include <bits/stdc++.h>

using namespace std;

vector<vector<char> > v;
int n, m;

vector<int> d1 = {0, 0, 1, -1}, d2 = {1, -1, 0, 0};
vector<vector<bool> > used;

bool dfs(int x, int y){
    if(x < 1 || x >= n - 1 || y < 1 || y >= m - 1)
        return 0;
    if(v[x][y] == '#' || used[x][y])
        return 1;
    used[x][y] = 1;
    bool ans = 1;
    for(int i = 0; i < 4; ++i){
        bool cnt = dfs(x + d1[i], y + d2[i]);
        ans &= cnt;
    }
    return ans;
}

void repaint(int x, int y){
    if(x < 0 || x >= n || y < 0 || y >= m || v[x][y] == '#' || v[x][y] == '~')
        return;
    v[x][y] = '~';
    for(int i = 0; i < 4; ++i)
        repaint(x + d1[i], y + d2[i]);
}

int main()
{
    cin >> n >> m; n += 2, m += 2;
    v.resize(n, vector<char> (m, '.'));
    for(int i = 1; i < n - 1; ++i)
        for(int j = 1; j < m - 1; ++j)
            cin >> v[i][j];
    used.resize(n, vector<bool> (m, 0));
    for(int i = 0; i < n; ++i){
        bool f = 0;
        for(int j = 0; j < m; ++j){
            if(!used[i][j] && v[i][j] == '.' && dfs(i, j)){
                repaint(i, j); f = 1;
                break;
            }
        }
        if(f) break;
    }
    priority_queue<pair<bool, pair<int, int> > > qq;
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            int cntt = 0, cntd = 0, cntn = 0;
            for(int q = -1; q < 2; ++q){
                for(int p = -1; p < 2; ++p){
                    if(i + q >= 0 && i + q < n && j + p >= 0 && j + p < m && (i != 0 || j != 0)){
                        if(v[i + q][j + p] == '~') ++cntt;
                        if(v[i + q][j + p] == '.') ++cntd;
                        if((i == 0 || j == 0) && v[i + q][j + p] == '#')
                            ++cntn;
                    }
                }
            }
            if((cntd == 0 ^ cntt == 0) && cntn <= 2)
                if(cntd != 0)
                    qq.push({1, {i, j}});
                else
                    qq.push({0, {i, j}});
        }
    }
    while(!qq.empty()){
        auto[b, a] = qq.top(); qq.pop();
        int i = a.first, j = a.second;
        if(v[i][j] != '#')
            continue;
        queue<pair<int, int> > qqq;
        int cntt = 0, cntd = 0, cntn = 0;
        for(int q = -1; q < 2; ++q){
            for(int p = -1; p < 2; ++p){
                if(i + q >= 0 && i + q < n && j + p >= 0 && j + p < m && (i != 0 || j != 0)){
                    if(v[i + q][j + p] == '~') ++cntt;
                    if(v[i + q][j + p] == '.') ++cntd;
                    if((p == 0 || q == 0) && v[i + q][j + p] == '#')
                        qqq.push({i + q, j + p});
                }
            }
        }
        while(!qqq.empty()){
            auto[ii, jj] = qqq.front(); qqq.pop();
            int ccntt = 0, ccntd = 0, ccntn = 0;
            for(int q = -1; q < 2; ++q){
                for(int p = -1; p < 2; ++p){
                    if(ii + q >= 0 && ii + q < n && jj + p >= 0 && jj + p < m && (ii != 0 || jj != 0)){
                        if(v[ii + q][jj + p] == '~') ++ccntt;
                        if(v[ii + q][jj + p] == '.') ++ccntd;
                        if((p == 0 || q == 0) && v[ii + q][jj + p] == '#') ++ccntn;
                    }
                }
            }
            if((ccntd == 0 ^ ccntt == 0) && ccntn <= 2)
                if(ccntd != 0)
                    qq.push({1, {ii, jj}});
                else
                    qq.push({0, {ii, jj}});
        }
        if(cntt == 0 ^ cntd == 0)
            if(cntt != 0)
                v[i][j] = '~';
            else
                v[i][j] = '.';
    }
    for(int i = 1; i < n - 1; ++i){
        for(int j = 1; j < m - 1; ++j){
            if(v[i][j] == '~')
                v[i][j] = '.';
            cout << v[i][j];
        }
        cout << '\n';
    }
    return 0;
}
//6 6
//###...
//#.#...
//###...
//...###
//...###
//...###
