#include <iostream>
#include <vector>


#define int long long

using namespace std;
vector <pair <int, int>> p = { {1, 0}, {0, 1}, {-1, 0}, {0, -1} };
bool f = true;
void dfs(int x, int y, vector <vector <int>>& a, int h, int w)
{
    if (f)
    {
        for (int i = 0; i < 4; i++)
            if (x + p[i].first == w || y + p[i].second == h || x + p[i].first == -1 || y + p[i].second == -1)
                f = false;
    }
    a[y][x] = 2;
    for (int i = 0; i < 4; i++)
        if (x + p[i].first != w && y + p[i].second != h && x + p[i].first != -1 && y + p[i].second != -1 && a[y + p[i].second][x + p[i].first] == 1)
            dfs(x + p[i].first, y + p[i].second, a, h, w);
    if (!f)
        a[y][x] = 3;
}
pair <pair <int, int>, pair <int, int>> q;
void dfs2(int x, int y, vector <vector <int>>& a, int h, int w)
{
    a[y][x] = 4;
    if (q.first.first > x)
        q.first.first = x;
    if (q.first.second > y)
        q.first.second = y;
    if (q.second.first < x)
        q.second.first = x;
    if (q.second.second < y)
        q.second.second = y;
    for (int i = 0; i < 4; i++)
        if (x + p[i].first != w && y + p[i].second != h && x + p[i].first != -1 && y + p[i].second != -1 && a[y + p[i].second][x + p[i].first] == 2)
            dfs2(x + p[i].first, y + p[i].second, a, h, w);
}
signed main() {
    int h, w;
    string s;
    cin >> h >> w;
    vector <vector <int>> a(h, vector <int>(w, 0));
    for (int i = 0; i < h; i++)
    {
        cin >> s;
        for (int j = 0; j < w; j++)
        {
            if (s[j] == '.')
                a[i][j] = 1;
        }
    }
    int xa, ya;
    for (int i = 0; i < h; i++)
    {
        for (int j = 0; j < w; j++)
        {
            f = true;
            if (a[i][j] == 1)
            {
                dfs(j, i, a, h, w);
                if (f)
                {
                    xa = j;
                    ya = i;
                    q = { {xa, ya}, {xa, ya} };
                }
            }
        }
    }
    dfs2(xa, ya, a, h, w);
    for (int i = q.first.first - 1; i <= q.second.first + 1; i++)
    {
        a[q.first.second - 1][i] = 10;
        a[q.second.second + 1][i] = 10;
    }
    for (int i = q.first.second - 1; i <= q.second.second + 1; i++)
    {
        a[i][q.first.first - 1] = 10;
        a[i][q.second.first + 1] = 10;
    }
    for (int i = 0; i < h; i++)
    {
        for (int j = 0; j < w; j++)
        {
            if (a[i][j] == 10)
                cout << '#';
            else
                cout << '.';
        }
        cout << "\n";
    }
    return 0;
}