#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

int H, V, mod = 1e9 + 7;
vector<vector<pair<int, int>>> S;
int ans = 0, z, x, y;

int rec(int h, int v) {
    if (h <= 2 or v <= 2) {
        S[h][v] = {(h * v) % mod, 1};
    }
    //ans = (ans + h * v) % mod;
    //ans = (ans + S[h][v]) % mod;
    S[h][v].first = h * v;
    S[h][v].second = 1;
    for (int i = 1; i < h - 1; ++i) {
        for (int j = 1; j < v - 1; ++j) {
            if (S[i][j].first == 0)
                rec(i, j);
            x = S[i][j].first;
            y = S[i][j].second;

            S[h][v].first = (S[h][v].first + ((h * v * y + x) * (h - i - 1) * (v - j - 1))) % mod;
            S[h][v].second += (h - i - 1) * (v - j - 1);
            z = S[h][v].first;
        }
    }
}


signed main() {
    cin >> H >> V;
    S.resize(H + 1, vector<pair<int, int>> (V + 1, {0, 0}));
    rec(H, V);
    cout << S[H][V].first;
    return 0;
}