#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
//#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
#define loop(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define pb push_back
#define f first
#define s second
#define inf 1e12
using namespace std;
/*

ll INF = 1e12;


struct RMQ{
    vector<pair<ll, ll>> t;
    RMQ(vector<ll> &a) {
        t.assign(4 * a.size(), {});
        build(0, 0, a.size(), a);
    }

    void build(ll v, ll l, ll r, vector<ll> &a) {
        if (l + 1 == r) {
            t[v] = {a[l], l};
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = min(t[2*v+1], t[2*v+2]);
    }

    pair<ll, ll> find(ll v, ll l, ll r, ll ql, ll qr, ll k) {
        //cout << "vertex: " << v << endl;
        //cout << "val: " << t[v].f << ' ' << t[v].s << endl;
        if (ql <= t[v].s && t[v].s < qr) {
            return t[v];
        }
        ll m = (l + r) / 2;
        pair<ll, ll> res{-1, -1};
        if (ql < m)
            res = find(2 * v + 1, l, m, ql, qr, k);
        cout << res.f << ' ' << res.s << endl;
        if (res.s == -1)
            res = find(2 * v + 2, m, r, ql, qr, k);
        else if (m < qr && res.f >= k) {
            res = min(find(2 * v + 2, m, r, ql, qr, k), res);
        }
        return res;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    //solve_c();
    //return 0;
    //-------DATA-------
    ll n, b, v; cin >> n >> b >> v;
    vector<ll> a(n), cost(n);
    loop(i, n) {
        cin >> a[i] >> cost[i];
    } RMQ rmq(cost);
    //------------------
    //-------ALG--------
    ll l = 1, r = 1;
    ll cur_v = 0;
    while(l < n) {
        if (b < cost[l-1]) break;
        for (ll i = l; i < n ; i++) {
            r = i;
            if (a[i] - a[l - 1] > cur_v + b / cost[l-1]) {
                break;
            }
        }
        if (l >= r) break;
        pair<ll, ll> res = rmq.find(0, 0, n, l, r, cost[l-1]);
        if(res.f < cost[l-1]) {
            b -= max(0ll, (a[res.s] - a[l-1] - cur_v)) * cost[l-1];
            cur_v += max(0ll, (a[res.s] - a[l-1] - cur_v));
        } else {
            cur_v += b / cost[l-1];
            b -= b / cost[l-1] * cost[l-1];
        }
        cout << l << ' ' << r << ' ' << cur_v << endl;
        cur_v -= a[res.s] - a[l-1];
        l = res.s + 1;
    }

    cout << a[l-1] + cur_v;
    //------------------


}

*/
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n; cin >> n;
    vector<ll> a;
    for (int i = 0; i < n; i++) {
        ll x; cin >> x;
        a.push_back(x);
    }
    sort(a.begin(), a.end());
    vector<ll> dist;
    for (int i = 1; i < n; i++) {
        dist.push_back(a[i] - a[i - 1]);
    }
    ll m = dist.size() / 2;
    ll dif = 0;
    for (int i = 0; i < m; i++) {
        dif -= dist[i];
        dif += dist[i + m];
        //cout << dist[i] << ' ' << dist[i + m] << endl;
    }
    //cout << dif << endl;
    ll ans = 1e18;
    ans = min(min((ll)min((ll)abs(dif - dist[dist.size() - 1] + dist[m - 1]), (ll)abs(dif + dist[0] - dist[m])), (ll)min((ll)abs(dif + dist[m - 1]), (ll)abs(dif - dist[m]))), (ll)abs(dif - dist[m] + dist[m - 1]));
    cout << ans;
}
