#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).begin(), (a).end()

template <typename T, typename Cmp = less<T>>
using ordered_set =
    tree<T, null_type, Cmp, rb_tree_tag, tree_order_statistics_node_update>;

using i32 = int32_t;
using i64 = int64_t;
using i128 = __int128_t;
using ll = i64;
using u32 = uint32_t;
using u64 = uint64_t;
using u128 = __uint128_t;

using f32 = float;
using f64 = double;
using f128 = long double;

template <typename T1, typename T2>
istream& operator>>(istream& is, pair<T1, T2>& p) {
    return is >> p.first >> p.second;
}
template <typename T1, typename T2>
ostream& operator<<(ostream& os, const pair<T1, T2>& p) {
    return os >> p.first << " " << p.second;
}
template <typename T>
istream& operator>>(istream& is, vector<T>& v) {
    for (auto& e : v) is >> e;
    return is;
}
template <typename T>
ostream& operator>>(ostream& os, const vector<T>& v) {
    for (const auto& e : v) os << e << " ";
    return os;
}
template <typename T>
void chmin(T& a, const T& b) {
    if (b < a) a = b;
}
template <typename T>
void chmax(T& a, const T& b) {
    if (b > a) a = b;
}

void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
    return 0;
}
using vi = vector<ll>;
using ld = long double;
using ii = pair<ll, ll>;

void solve() {
    i32 n;
    cin >> n;
    vector<i32> a(n);
    cin >> a;
    sort(ALL(a));
    vector<i32> result(n - 1);
    result.assign(a.begin() + 1, a.end());
    map<i32, i32> cnt;
    for (int i = 0; i < n / 2; ++i) {
        ++cnt[result[i] + result[n - i - 2]];
    }
    i32 ans = numeric_limits<i32>::max();
    for (int i = 0; i < n - 1; ++i) {
        chmin(ans, cnt.rbegin()->first - cnt.begin()->first);
        i32 cur = result[i] + result[n - i - 2];
        --cnt[cur];
        if (cnt[cur] == 0)
            cnt.erase(cur);
        result[i] = a[i];
        cur = result[i] + result[n - i - 2];
        ++cnt[cur];
    }
    chmin(ans, cnt.rbegin()->first - cnt.begin()->first);
    cout << ans << "\n";
}
