#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
#define int long long
#define ff first
#define fir first
#define ss second
#define sz size
#define sec second
#define en '\n'
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define all(a) (a).begin(), (a).end()
#define forn(i, n) for (int i = 0; i < n; ++i)

inline void solve();

signed main() {
#ifdef LOCAL
    freopen("C:\\Users\\user\\Desktop\\vkoshp\\read.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int tt = 1;
    while (tt--) {
        solve();
    }
}

struct segtree {
    vector<pair<int, int>> t;

    int size;

    void init(int n) {
        size = 1;
        while(size < n)
            size <<= 1;
        t.assign(2 * n, {INT_MAX, size});
    }

    void build(int v, int vl, int vr, vector<int>& a) {
        if (vl >= a.size())
            return;
        if (vr - vl == 1) {
            t[v] = {a[vl], vl};
            return;
        }
        int m = (vl + vr) >> 1;
        build(2 * v + 1, vl, m, a);
        build(2 * v + 2, m, vr, a);
    }

    void build(vector<int>& a) {
        init(a.size());
        build(0, 0, size, a);
    }

    pair<int, int> get(int l, int r, int v, int vl, int vr) {
        if (vr <= l || r <= vl) {
            return {INT_MAX, size};
        }
        if (l <= vl && vr <= r) {
            return t[v];
        }
        int m = (vr + vl) >> 1;
        auto p1 = get(l, r, 2 * v + 1, vl, m);
        auto p2 = get(l, r, 2 * v + 2, m, vr);
        return min(p1, p2);
    }

    int get(int l, int r) {
        return get(l, r, 0, 0, size).second;
    }
};

inline void solve() {
    int n, b, c;
    cin >> n >> b >> c;
    vector<int> x(n), p(n);
    forn(i, n) cin >> x[i] >> p[i];
    vector<int> next(n, n);
    {
        vector<int> st;
        forn(i, n) {
            while (!st.empty() && p[st.back()] >= p[i]) {
                next[st.back()] = i;
                st.pop_back();
            }
            st.pb(i);
        }
    }
    int now_c = 0;
    int now_b = b;
    int now_pos = 0;
    int ans = 0;
    segtree st;
    st.build(p);
    while (now_pos < n && now_b > 0) {
        ans = max(ans, x[now_pos] + min(now_c + now_b / p[now_pos], c));
        int furthest = upper_bound(x.begin() + now_pos, x.end(), x[now_pos] + min(now_c + now_b / p[now_pos], c)) - x.begin() - 1;
        if (next[now_pos] <= furthest) {
            furthest = next[now_pos];
            now_b -= p[now_pos] * max(x[furthest] - x[now_pos], 0ll);
            now_c = max(0ll, now_c - (x[furthest] - x[now_pos]));
            now_pos = furthest;
        } else {
            furthest = st.get(now_pos + 1, furthest + 1);
            //now_b -= p[now_pos] * max(x[furthest] - x[now_pos], 0ll);
            if (now_c < c) {
                int prev_b = now_b;
                now_b -= p[now_pos] * max(min(now_c + now_b / p[now_pos], c) - now_c, 0ll);
                now_c = min(now_c + prev_b / p[now_pos], c);
            }
            now_c = max(0ll, now_c - (x[furthest] - x[now_pos]));
            now_pos = furthest;
        }
    }
    cout << ans;
}