#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define ll long long
#define sc second
#define fr first
#define all(arr) arr.begin(), arr.end()
#define rall(arr) arr.rbegin(), arr.rend()
#define pb push_back

//template<typename T, typename T2>
//istream& operator>>(istream& in, pair<T, T2> &a) {
//    in >> a.first >> a.second;
//    return in;
//}
//template<typename T, typename T2>
//ostream& operator<<(ostream& out, pair<T, T2> a) {
//    out << a.first << " " << a.second;
//    return out;
//}

//mt19937 rnd(time(0));

using namespace std;
using namespace __gnu_pbds;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;

void solve() {
    ll n, m;
    cin >> n >> m;
    ll s, t;
    ll L;
    cin >> s >> t >> L;
    --s, --t;

    vector< vector< pair<ll, ll> > > adj(n);
    for (ll i = 0; i < m; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        adj[u].pb({v, w});
        adj[v].pb({u, w});
    }

    vector<ll> Dt(n, INF), Ds(n, INF);
    set< pair<ll, ll> > q;
    Dt[t] = 0;
    q.insert({Dt[t], t});
    vector<ll> cnt2(n, 0);
    cnt2[t] = 1;
    while (!q.empty()) {
        ll v = q.begin()->sc;
        q.erase(q.begin());

        for (auto [to, w] : adj[v]) {
            if (Dt[v] + w < Dt[to]) {
                cnt2[to] = 1;
                q.erase({Dt[to], to});
                Dt[to] = Dt[v] + w;
                q.insert({Dt[to], to});
            } else if (Dt[v] + w == Dt[to]) {
                ++cnt2[to];
            }
        }
    }
    Ds[s] = 0;
    q.insert({Ds[s], s});
    vector<ll> cnt1(n, 0);
    cnt1[s] = 1;
    while (!q.empty()) {
        ll v = q.begin()->sc;
        q.erase(q.begin());

        for (auto [to, w] : adj[v]) {
            if (Ds[v] + w < Ds[to]) {
                q.erase({Ds[to], to});
                Ds[to] = Ds[v] + w;
                q.insert({Ds[to], to});
                cnt1[to] = 1;
            } else if (Ds[v] + w == Ds[to]) {
                ++cnt1[to];
            }
        }
    }

    q.insert({0, s});
    set<ll> vertex;
    vertex.insert(s);
    while (!q.empty()) {
        ll v = q.begin()->sc;
        q.erase(q.begin());

        for (auto [to, w] : adj[v]) {
            if (Dt[to] + w == Dt[v]) {
                q.insert({Ds[to], to});
                vertex.insert(to);
            }
        }
    }

    vertex.erase(t);

    ll ans = 0;
    for (auto v : vertex) {
        for (auto [to, w] : adj[v]) {
            if (Ds[v] != INF && Dt[to] != INF && Ds[v] + w + Dt[to] == L)
                ans = (ans + cnt1[v] * cnt2[to] % MOD) % MOD;
        }
    }

    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int tt = 1;
//    cin >> t;
    while (tt--)
    {
        solve();
    }
}