#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ld long double
#define VI vector<int>

template<class T>
istream& operator>>(istream& in, vector<T>& v) {
    for (int i = 0; i < v.size(); ++i) {
        in >> v[i];
    }
    return in;
}

signed main() {
    cout.precision(16);
    int n, b, c;
    cin >> n >> b >> c;
    VI vx(n), vp(n);
    cin >> vx >> vp;

    VI vnext(n);
    vector<pair<int, int>> stack;
    for (int i = 0; i < n; ++i) {
        int x = vx[i];
        while (!stack.empty() && stack.back().first > x) {
            vnext[stack.back().second] = i;
            stack.pop_back();
        }
        stack.emplace_back(x, i);
    }

    while (!stack.empty()) {
        vnext[stack.back().second] = n;
        stack.pop_back();
    }

    int curr = 0;
    for (int i = 0; i < n; ++i) {
        if (curr < vx[i]) break;
        int next = vnext[i];
        int avail = b / vp[i];
        if (vx[next] - curr <= min(c, avail)) {
            curr += max(vx[next] - curr, 0ll);
            b -= max(vx[next] - curr, 0ll) * vp[i];
        } else {
            curr += min(c, avail);
            b -= min(c, avail) * vp[i];
        }
    }
    cout << curr << endl;
    return 0;
}
