#include <bits/stdc++.h>

using namespace std;

//#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef __int128 int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
const int INF = 1e9 + 7;

//#define int ll

//mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> v(n);
    for (auto &i: v) {
        cin >> i;
    }
    vector<pair<int, int>> block1;
    for (int i = 0; i < n;) {
        int j = i + 1;
        while (j < n && v[j] == v[j - 1] + 1) {
            ++j;
        }
        block1.push_back({v[i], v[j - 1]});
        i = j;
    }
    vector<pair<int, int>> block2; // starts in first, len second
    if (block1[0].first > 0) {
        block2.push_back({0, block1[0].first});
    }
    for (int i = 1; i < (int) block1.size(); ++i) {
        block2.push_back({block1[i - 1].second + 1, block1[i].first - block1[i - 1].second - 1});
    }
    block2.push_back({block1.back().second + 1, INF - block1.back().second});
    int sz = block2.size();
//    for (int i = 0; i < sz; ++i) {
//        cout << block2[i].first << " " << block2[i].second << "\n";
//    }
    vector<ll> pref(sz + 1);
    for (int i = 0; i < sz; ++i) {
        pref[i + 1] = pref[i] + block2[i].second;
    }
    while (q--) {
        ll k;
        cin >> k;
        auto it = lower_bound(pref.begin(), pref.end(), k) - pref.begin();
        cout << block2[it - 1].first + (k - pref[it - 1] - 1) << " ";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
