#ifdef Local
#include "debug.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define debug(...)
#endif
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x.size())
using namespace std;
typedef long double ld;
typedef long long ll;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int& i : a)
        cin >> i;
    sort(all(a));
    a.erase(unique(all(a)), a.end());
    for (int k, l, r, m; q--; ) {
        cin >> k;
        l = -1, r = (int)1e10;
        while (r - l > 1) {
            m = (l + r) / 2;
            if (m - (upper_bound(all(a), m) - a.begin()) + 1 >= k)
                r = m;
            else
                l = m;
        }
        cout << r << ' ';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(12);
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}