#ifdef Local

#include "debug.h"

#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define debug(...)
#endif
#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x.size())
using namespace std;
typedef long double ld;
typedef long long ll;

void solve() {
    int h, w;
    cin >> h >> w;
    vector<vector<char>> pol(h, vector<char> (w));
    for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            cin >> pol[i][j];
    vector<vector<int>> d(h, vector<int>(w, 1));
    pair<int, int> mii = {h, -1}, mai = {-1, -1}, mij = {w, -1}, maj = {-1, -1};
    for (int j = 0; j < w; j++) {
        if (pol[0][j] == '.') {
            d[0][j] = 2;
        } else
            d[0][j] = 0;
        if (pol[h - 1][j] == '.') {
            d[h - 1][j] = 2;
        } else
            d[h - 1][j] = 0;
    }
    for (int i = 0; i < h; i++) {
        if (pol[i][0] == '.') {
            d[i][0] = 2;
        } else
            d[i][0] = 0;
        if (pol[i][w - 1] == '.') {
            d[i][w - 1] = 2;
        } else
            d[i][w - 1] = 0;
    }
    for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++) {
            if (pol[i][j] == '.') {
                if (i == 0 || i == h - 1 || j == 0 || j == w - 1 || d[i - 1][j] == 2 || d[i + 1][j] == 2 ||
                    d[i][j - 1] == 2 || d[i][j + 1] == 2)
                    d[i][j] = 2;
                else
                    mii = min(mii, {i, j}), mai = max(mai, {i, j}), mij = min(mij, {j, i}), maj = max(maj, {j, i});
            } else
                d[i][j] = 0;
        }
    vector<vector<int>> used(h, vector<int>(w, 0));
    vector<vector<pair<int, int>>> p(h, vector<pair<int, int>>(w));
    vector<vector<char>> ans(h, vector<char>(w, '.'));
    function<bool(int, int)> dfs10 = [&](int i, int j) -> bool {
        used[i][j] = 1;
        ans[i][j] = '#';
        if (j == maj.first + 1)
            return true;
        if (j + 1 < w && d[i][j + 1] == 0)
            if (dfs10(i, j + 1))
                return true;
        if (j + 1 < w && d[i][j + 1] == 1 || used[i][j + 1]) {
            if (i + 1 < h && dfs10(i + 1, j))
                return true;
            else {
                ans[i][j] = '.';
                return false;
            }
        }
        if (i > 0 && dfs10(i - 1, j))
            return true;
        else {
            ans[i][j] = '.';
            return false;
        }
    };
    function<bool(int, int)> dfs11 = [&](int i, int j) -> bool {
        used[i][j] = 1;
        ans[i][j] = '#';
        if (j == mij.first - 1)
            return true;
        if (j > 0 && d[i][j - 1] == 0)
            if (dfs11(i, j - 1))
                return true;
        if (j > 0 && d[i][j - 1] == 1 || used[i][j - 1]) {
            if (i + 1 < h && dfs11(i + 1, j))
                return true;
            else {
                ans[i][j] = '.';
                return false;
            }
        }
        if (i > 0 && dfs11(i - 1, j))
            return true;
        else {
            ans[i][j] = '.';
            return false;
        }
    };
    function<bool(int, int)> dfs30 = [&](int i, int j) -> bool {
        used[i][j] = 1;
        ans[i][j] = '#';
        if (j == maj.first + 1)
            return true;
        if (j + 1 < w && d[i][j + 1] == 0)
            if (dfs30(i, j + 1))
                return true;
        if (j + 1 < w && d[i][j + 1] == 1 || used[i][j + 1]) {
            if (i > 0 && dfs30(i - 1, j))
                return true;
            else {
                ans[i][j] = '.';
                return false;
            }
        }
        if (i + 1 < h && dfs30(i + 1, j))
            return true;
        else {
            ans[i][j] = '.';
            return false;
        }
    };
    function<bool(int, int)> dfs31 = [&](int i, int j) -> bool {
        used[i][j] = 1;
        ans[i][j] = '#';
        if (j == mij.first - 1)
            return true;
        if (j > 0 && d[i][j - 1] == 0)
            if (dfs31(i, j - 1))
                return true;
        if (j > 0 && d[i][j - 1] == 1 || used[i][j - 1]) {
            if (i > 0 && dfs31(i - 1, j))
                return true;
            else {
                ans[i][j] = '.';
                return false;
            }
        }
        if (i + 1 < h && dfs31(i + 1, j))
            return true;
        else {
            ans[i][j] = '.';
            return false;
        }
    };
    dfs11(mai.first + 1, mai.second);
    for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            used[i][j] = 0;
    dfs10(mii.first - 1, mii.second);for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            used[i][j] = 0;
    dfs31(mii.first - 1, mii.second);for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            used[i][j] = 0;
    dfs30(mai.first + 1, mai.second);for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            used[i][j] = 0;
    function<bool(int, int)> dfs20 = [&](int i, int j) -> bool {
        used[i][j] = 1;
        ans[i][j] = '#';
        if (i == mai.first + 1)
            return true;
        if (i + 1 < h && d[i + 1][j] == 0)
            if (dfs20(i + 1, j))
                return true;
        if (i + 1 < h && d[i + 1][j] == 1 || used[i + 1][j]) {
            if (j + 1 < w && dfs20(i, j + 1))
                return true;
            else {
                ans[i][j] = '.';
                return false;
            }
        }
        if (j > 0 && dfs20(i, j - 1))
            return true;
        else {
            ans[i][j] = '.';
            return false;
        }
    };
    function<bool(int, int)> dfs21 = [&](int i, int j) -> bool {
        used[i][j] = 1;
        ans[i][j] = '#';
        if (i == mii.first - 1)
            return true;
        if (i > 0 && d[i - 1][j] == 0)
            if (dfs21(i - 1, j))
                return true;
        if (i > 0 && d[i - 1][j] == 1 || used[i - 1][j]) {
            if (j + 1 < w && dfs21(i, j + 1))
                return true;
            else {
                ans[i][j] = '.';
                return false;
            }
        }
        if (j > 0 && dfs21(i, j - 1))
            return true;
        else {
            ans[i][j] = '.';
            return false;
        }
    };
    function<bool(int, int)> dfs40 = [&](int i, int j) -> bool {
        used[i][j] = 1;
        ans[i][j] = '#';
        if (i == mai.first + 1)
            return true;
        if (i + 1 < h && d[i + 1][j] == 0)
            if (dfs40(i + 1, j))
                return true;
        if (i + 1 < h && d[i + 1][j] == 1 || used[i + 1][j]) {
            if (j > 0 && dfs40(i, j - 1))
                return true;
            else {
                ans[i][j] = '.';
                return false;
            }
        }
        if (j + 1 < w && dfs40(i, j + 1))
            return true;
        else {
            ans[i][j] = '.';
            return false;
        }
    };
    function<bool(int, int)> dfs41 = [&](int i, int j) -> bool {
        used[i][j] = 1;
        ans[i][j] = '#';
        if (i == mii.first - 1)
            return true;
        if (i > 0 && d[i - 1][j] == 0)
            if (dfs41(i - 1, j))
                return true;
        if (i > 0 && d[i - 1][j] == 1 || used[i - 1][j]) {
            if (j > 0 && dfs41(i, j - 1))
                return true;
            else {
                ans[i][j] = '.';
                return false;
            }
        }
        if (j + 1 < w && dfs41(i, j + 1))
            return true;
        else {
            ans[i][j] = '.';
            return false;
        }
    };for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            used[i][j] = 0;
    dfs20(maj.second, maj.first + 1);for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            used[i][j] = 0;
    dfs21(maj.second, maj.first + 1);for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            used[i][j] = 0;
    dfs40(mij.second, mij.first - 1);for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            used[i][j] = 0;
    dfs41(mij.second, mij.first - 1);for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            used[i][j] = 0;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++)
            cout << ans[i][j];
        cout << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(12);
    int tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}