#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 1e3 + 100;
const int oo = 1e9;

const int dx[8] = {0, 1, 0, -1, 1, -1, -1, 1};
const int dy[8] = {1, 0, -1, 0, 1, -1, 1, -1};

int n, m;
char c[N][N];
int cl[N][N];
int mnx[N*N];
int mxx[N*N];
int mny[N*N];
int mxy[N*N];

bool F[N][N];

queue <pii> q;

ve <pii> p[N*N];

void add(int x, int y, int col) {
    if (x < 0 || y < 0 || x >= n || y >= m || cl[x][y] || c[x][y] == '#') return;
    cl[x][y] = col;
    q.push({x, y});
    p[col].pb({x, y});
    umn(mnx[col], x);
    umn(mny[col], y);
    umx(mxx[col], x);
    umx(mxy[col], y);
}
int C[N][N];
bool valid(int x, int y) {
    if (x < 0 || y < 0 || x >= n || y >= m) return 0;
    return 1;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n >> m;
    fr(i, 0, n - 1) {
        fr(j, 0, m - 1) cin >> c[i][j];
    }
    fr(i, 0, n*m) {
        mnx[i] = oo;
        mny[i] = oo;
    }
    int cnt = 1;
    fr(i, 0, n - 1) {
        fr(j, 0, m - 1) {
            if(c[i][j] == '.' && !cl[i][j]) {
                cl[i][j] = cnt;
                q.push({i, j});
                p[cnt].pb({i, j});

                umn(mnx[cnt], i);
                umn(mny[cnt], j);
                umx(mxx[cnt], i);
                umx(mxy[cnt], j);


                while(sz(q)) {
                    int x = q.front().fi;
                    int y = q.front().se;
                    add(x - 1, y, cnt);
                    add(x, y + 1, cnt);
                    add(x + 1, y, cnt);
                    add(x, y - 1, cnt);
                    q.pop();
                }
                cnt++;
            }
        }
    }

//    fr (i, 0, n - 1) {
//        fr (j, 0, m - 1) {
//            cout << cl[i][j] << " ";
//        }
//        cout << "\n";
//    }

    int idx = -1;
    fr (clr, 1, cnt - 1) {
       if (mnx[clr] == 0 || mny[clr] == 0 || mxx[clr] == n - 1 || mxy[clr] == m - 1) continue;
        idx = clr;
    }

    assert(idx != -1);

//    cout << idx << endl;

    fr (i, 0, n - 1) {
        fr (j, 0, m - 1) {
            if (c[i][j] != '#') continue;
            bool good = 0;
            fr (t, 0, 7) {
                if (valid(i + dx[t], j + dy[t])) {
                    good |= cl[i + dx[t]][j + dy[t]] == idx;
                }
            }
            if (!good) {
                c[i][j] = '.';
            }
        }
    }

//    fr(i, 0, n - 1) {
//        fr(j, 0, m - 1) {
//            cout << c[i][j];
//        }
//        cout << "\n";
//    }



//    fr(i, 0, n - 1) {
//        fr(j, 0, m - 1) {
//            if (c[i][j] == '#') continue;
//    int clr = idx;

    fr (ptr, 0, sz(p[idx]) - 1) {
        auto e = p[idx][ptr];

        int x = e.fi;
        int y = e.se;
//        cout << x << " " << y << "\n";
        fr(t, 0, 3) {
            int nx = x + dx[t];
            int ny = y + dy[t];
            if (valid(nx, ny) && c[nx][ny] == '#') {
                C[nx][ny]++;
                if (C[nx][ny] == 3) {
                    c[nx][ny] = '.';
                    p[idx].pb({nx, ny});
                }
            }
        }
    }

    fr(i, 0, n - 1) {
        fr(j, 0, m - 1) {
            cout << c[i][j];
        }
        cout << "\n";
    }

    return 0;
}
