#include <bits/stdc++.h>

using namespace  std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

const int inf = 2e9 + 1;
const int mod = 1e9 + 7;
const int MAXN = 3e5+1;

struct platform{
    int l;
    int r;
    int id;
};

vi g[MAXN];
vi sum(MAXN);
vi dp(MAXN, -1);
vector<platform> p;



bool cmp(platform &a, platform &b){
    if(a.l != b.l) return a.l < b.l;
    return a.r > b.r;
}

bool in(platform &a, platform &b){
    return  b.l <= a.l and a.r <= b.r;
}

void push(int v, int x){
    bool ok = true;
    for(int u: g[v]){
        if(in(p[x], p[u])){
            ok = false;
            push(u, x);
        }
    }
    if(ok){
        g[v].push_back(x);
    }
}

int dfs(int v){
    if(dp[v] != -1) return dp[v];
    dp[v] = 1;
    for(int u: g[v]){
        dp[v] += dfs(u);
        dp[v] = dp[v] % mod;
    }
    return dp[v];
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int n;
    cin >> n;
    p.resize(n);
    for(int i = 0; i < n; ++i){
        int l, r;
        cin >> l >> r;
        p[i] = {l, r, i};
    }
    sort(p.begin(), p.end(), cmp);
    vi mem;
    for(int i = 0; i < n; ++i){
        if(i == 0){
            mem.push_back(0);
            continue;
        }
        bool add = true;
        for(int root: mem){
            if( in(p[i], p[root]   )  ) {
                add = false;
                push(root, i);
            }
        }
        if(add) mem.push_back(i);
    }
    for(int i = 0; i < mem.size(); ++i){
        int ans = dfs(mem[i]);
    }
    vi ans(n);
    for(int i = 0; i < n; ++i){
        ans[p[i].id] = dp[i];
    }
    for(int i = 0; i < n; ++i) cout << ans[i] << ' ';
    return 0;
}
