#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MOD = 1e9 + 7;
const int INF = 1e18 + 7;
const int BASE = 69;

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

int count(vector<int> &a, int i, int j) {
    int mi = INF, ma = 0;
    while (i < j) {
        mi = min(mi, a[i] + a[j]);
        ma = max(ma, a[i] + a[j]);
        i++, j--;
    }
    return abs(ma - mi);
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i : a)
        cin >> i;
    sort(a.begin(), a.end());
    int ans = INF;
    ans = min(ans, count(a, 0, n - 2));
    ans = min(ans, count(a, 1, n - 1));
    ans = min(ans, count(a, 0, n - 1));
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int t = 1;
    //cin >> t;
    while (t--)
        solve();
    return 0;
}