#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <unordered_map>
#include <map>
#include <unordered_set>
#include <iomanip>
#include <deque>


using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef vector<int> vi;

const int inf = 1e9 + 7;
const int maxn = 3e5 + 100;

signed main() {
#ifdef HOME
    freopen(R"(C:\work\vkopshppcppp\in.txt)", "r", stdin);
    freopen(R"(C:\work\vkopshppcppp\out.txt)", "w", stdout);
#endif
    int n, b, c;
    cin >> n >> b >> c;

    vi dist(n);
    vi cost(n);
    for (int i = 0; i < n; ++i) {
        cin >> dist[i] >> cost[i];
    }

    dist.push_back(inf);
    cost.push_back(inf);

    vi used(n);

    multiset<pair<int, int>> cur_cost;
    cur_cost.insert({cost[0], 0});

    multiset<pair<int, int>> cur_dist;
    cur_dist.insert({dist[0], 0});

    int ans = 0;
    if (n < 2 || dist[1] - dist[0] > c) {
        while (1) {
            if (cur_cost.empty()) {
                cout << ans;
                return 0;
            }
            int j = (*cur_cost.begin()).second;
            int take = c - used[j];
            if (take * cost[j] <= b) {
                b -= take * cost[j];
                used[j] += take;
                ans += take;
                if (used[j] == c) {
                    cur_cost.erase(cur_cost.begin());
                    cur_dist.erase({dist[j], j});
                }
            } else {
                ans += b / cost[j];
                cout << ans;
                return 0;
            }
        }
    }

    for (int i = 1; i <= n; ++i) {
        int d = dist[i] - dist[i - 1];
        while (!cur_dist.empty() && (dist[i] - (*cur_dist.begin()).first > c)) {
            int j = (*cur_dist.begin()).second;
            cur_cost.erase({cost[j], j});
            cur_dist.erase({dist[j], j});
        }
        while (d > 0) {
            if (cur_cost.empty()) {
                cout << ans;
                return 0;
            }
            int j = (*cur_cost.begin()).second;
            int take = min(c - used[j], d);
            if (take * cost[j] <= b) {
                b -= take * cost[j];
                used[j] += take;
                ans += take;
                d -= take;
                if (used[j] == c) {
                    cur_cost.erase(cur_cost.begin());
                    cur_dist.erase({dist[j], j});
                }
            } else {
                ans += b / cost[j];
                cout << ans;
                return 0;
            }
        }

        ans = dist[i];
        cur_dist.insert({dist[i], i});
        cur_cost.insert({cost[i], i});

        if (dist[i + 1] - dist[i] > c) {
            while (1) {
                if (cur_cost.empty()) {
                    cout << ans;
                    return 0;
                }
                int j = (*cur_cost.begin()).second;
                int take = c - used[j];
                if (take * cost[j] <= b) {
                    b -= take * cost[j];
                    used[j] += take;
                    ans += take;
                    if (used[j] == c) {
                        cur_cost.erase(cur_cost.begin());
                        cur_dist.erase({dist[j], j});
                    }
                } else {
                    ans += b / cost[j];
                    cout << ans;
                    return 0;
                }
            }
        }
    }
    cout << "UPS";
}