#include <bits/stdc++.h>

using namespace std;

#define ll long long
//#define int long long
#define pb push_back

const int md = 1e9 + 7;

int add(int a, int b) {
    return a + b < md ? a + b : a + b - md;
}

int sub(int a, int b) {
    return a - b >= 0 ? a - b : a - b + md;
}

int mul(int a, int b) {
    return 1ll * a * b % md;
}

const int N = 405;

int dp[N][N];
int sum[N][N];
int prefdp[N][N], prefdph[N][N], prefdpw[N][N], prefdphw[N][N];
int prefsum[N][N], prefsumh[N][N], prefsumw[N][N], prefsumhw[N][N];

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    for (int h = 1; h <= n; ++h) {
        for (int w = 1; w <= m; ++w) {
            dp[h][w] = 1;
            if (h >= 3 && w >= 3) {
                dp[h][w] = add(dp[h][w], mul(prefdp[h - 2][w - 2], mul(h - 1, w - 1)));
                dp[h][w] = sub(dp[h][w], mul(prefdph[h - 2][w - 2], w - 1));
                dp[h][w] = sub(dp[h][w], mul(prefdpw[h - 2][w - 2], h - 1));
                dp[h][w] = add(dp[h][w], prefdphw[h - 2][w - 2]);
                sum[h][w] = add( sum[h][w], mul(prefsum[h - 2][w - 2], mul(h - 1, w - 1)));
                sum[h][w] = sub(sum[h][w], mul(prefsumh[h - 2][w - 2], w - 1));
                sum[h][w] = sub(sum[h][w], mul(prefsumw[h - 2][w - 2], h - 1));
                sum[h][w] = add(sum[h][w], prefsumhw[h - 2][w - 2]);
            }
            sum[h][w] = add(sum[h][w], mul(mul(h, w), dp[h][w]));
            prefdp[h][w] = add(dp[h][w], add(prefdp[h - 1][w], sub(prefdp[h][w - 1], prefdp[h - 1][w - 1])));
            prefdph[h][w] = add(mul(dp[h][w], h), add(prefdph[h - 1][w], sub(prefdph[h][w - 1], prefdph[h - 1][w - 1])));
            prefdpw[h][w] = add(mul(dp[h][w], w), add(prefdpw[h - 1][w], sub(prefdpw[h][w - 1], prefdpw[h - 1][w - 1])));
            prefdphw[h][w] = add(mul(dp[h][w], mul(h, w)), add(prefdphw[h - 1][w], sub(prefdphw[h][w - 1], prefdphw[h - 1][w - 1])));
            prefsum[h][w] = add(sum[h][w], add(prefsum[h - 1][w], sub(prefsum[h][w - 1], prefsum[h - 1][w - 1])));
            prefsumh[h][w] = add(mul(sum[h][w], h), add(prefsumh[h - 1][w], sub(prefsumh[h][w - 1], prefsumh[h - 1][w - 1])));
            prefsumw[h][w] = add(mul(sum[h][w], w), add(prefsumw[h - 1][w], sub(prefsumw[h][w - 1], prefsumw[h - 1][w - 1])));
            prefsumhw[h][w] = add(mul(sum[h][w], mul(h, w)), add(prefsumhw[h - 1][w], sub(prefsumhw[h][w - 1], prefsumhw[h - 1][w - 1])));
        }
    }
    cout << sum[n][m] << endl;
    return 0;
}