#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = 2e9 + 7;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q;
    cin >> n >> q;

    vector<pair<int, int>> segments;
    int last = -1;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (last != x - 1) {
            segments.emplace_back(last + 1, x);
        }
        last = x;
    }

    segments.emplace_back(last + 1, inf);

    const int m = segments.size();

    vector<int> pref(m);
    for (int i = 0; i < m; ++i) {
        if (i > 0) pref[i] = pref[i - 1];
        pref[i] += segments[i].second - segments[i].first;
    }

    while (q--) {
        int k;
        cin >> k;

        auto it = lower_bound(pref.begin(), pref.end(), k) - pref.begin();
        int s = k - (it == 0 ? 0 : pref[it - 1]);

        cout << segments[it].first + s - 1 << ' ';
    }
    return 0;
}
