#include "bits/stdc++.h"

using namespace std;
#define int long long
#define sz(a) (int) a.size()
const int mod = 1e9 + 7;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> c(n + 1, vector<int>(m + 1)), dp(n + 1, vector<int>(m + 1));
    for (int i = 0; i <= n; ++i)
        c[i][0] = 1;
    for (int i = 0; i <= m; ++i)
        c[0][i] = 1;
    for (int i = 0; i <= n; ++i) {
        c[i][1] = 1;
        dp[i][1] = i;
    }
    for (int i = 0; i <= m; ++i) {
        c[1][i] = 1;
        dp[1][i] = i;
    }
    for (int i = 2; i <= n; ++i) {
        for (int j = 2; j <= m; ++j) {
            c[i][j] = ((2 * c[i][j - 1] - c[i][j - 2]) % mod + mod) % mod;
            (dp[i][j] +=
                     (2 * dp[i][j - 1] - dp[i][j - 2] + 2 * c[i][j - 1] * i%mod - 2 * i * c[i][j - 2]%mod) % mod + mod) %= mod;
            for (int h = 1; h <= i - 2; ++h) {
                int add = (i - h - 1) * (j - 2 > 0);
                (c[i][j] += add * c[h][j - 2]%mod) %= mod;
                (dp[i][j] += add * dp[h][j - 2] + add * i%mod * j%mod * c[h][j - 2]%mod) %= mod;
            }
        }
    }
    cout << dp[n][m] << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}

