#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, q;
    cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());
    vector<ll> b(n);
    b[0] = a[0];
    for (ll i = 1; i < n; i++) {
        b[i] = a[i] - a[i - 1] - 1;
    }
    vector<ll> p(n + 1);
    p[0] = 0;
    for (ll i = 1; i <= n; i++) {
        p[i] = p[i - 1] + b[i - 1];
    }

    while (q--) {
        ll k;
        cin >> k;
        if (k > p[n]) {
            cout << a[n - 1] + k - p[n] << ' ';
        } else {
            ll l = 0, r = n + 1;
            while (r - l > 1) {
                ll m = (l + r) / 2;
                if (p[m] >= k) {
                    r = m;
                } else {
                    l = m;
                }
            }
            if (l == 0) {
                cout << k - p[l] - 1 << ' ';
            } else {
                cout << a[l - 1] + k - p[l] << ' ';
            }
        }
    }
}