#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define f first
#define s second
#define pii pair <int,int>
#define mp make_pair
#define pb push_back
#define en '\n'


#define forn(j, i, n) for(int i = j; i <= n; ++i)

const int N = 3e5 + 100;
const ll LLINF = (ll)1e18 + 10;

int inf = 1e9;
int mod = 1e9+7;

int n, m, used[1100][1100], used2[1100][1100];
pii pred[1100][1100];
queue <pii> q;
int kx[] = {0, 0, -1, 1};
int ky[] = {1, -1, 0, 0};
char a[1100][1100], ans[1100][1100];

void go(int X, int Y, int x2, int y2)
{
//    cout << "GO " << X << " " << Y << " " << x2 << " " << y2 << endl;
    used2[X][Y] = 1;
    q.push({X, Y});
    while(q.size())
    {
        int x = q.front().f;
        int y = q.front().s;
        q.pop();
        forn(0, k, 3)
        {
            int tox = x + kx[k];
            int toy = y + ky[k];
            if(!used2[tox][toy])
            {
                q.push({tox, toy});
                used2[tox][toy] = 1;
                pred[tox][toy] = {x, y};
            }
        }
    }
    while(x2 != X || y2 != Y)
    {
        pii P = pred[x2][y2];
 //       cout << x2 << " " << y2 << " " << P.f << " " << P.s << "   " << X << " " << Y << endl;
        ans[x2][y2] = '#';
        x2 = P.f;
        y2 = P.s;
    }
}
/*
11 9
###..####
#.#####..
#.#.##...
..#..##..
.###.##..
##....#..
##.####..
##.#..#..
##...##..
######...
####...#.

15 7
#######
#.....#
#####.#
....#.#
#####.#
#.....#
#####.#
....#.#
#####.#
#.....#
#####.#
....#.#
#####.#
#.....#
#######
*/
main()
{
    speed;
    cin >> n >> m;
    forn(1, i, n)
    {
        forn(1, j, m)
        {
            cin >> a[i][j];
            if(a[i][j] == '#') used[i][j] = 1;
            else used2[i][j] = 1;
            ans[i][j] = '.';
        }
    }
    forn(0, i, n + 1)
    {
        used[i][0] = 1;
        used[i][m + 1] = 1;
        used2[i][0] = 1;
        used2[i][m + 1] = 1;
    }
    forn(0, j, m + 1)
    {
        used[0][j] = 1;
        used[n + 1][j] = 1;
        used2[0][j] = 1;
        used2[n + 1][j] = 1;
    }
    forn(1, i, n)
    {
        forn(1, j, m)
        {
            if(used[i][j]) continue;
            q.push({i, j});
            used[i][j] = 1;
            int bad = 0;
            pii mxx = {-inf, -inf};
            pii mxy = {-inf, -inf};
            pii mnx = {inf, inf};
            pii mny = {inf, inf};
            while(q.size())
            {
                int x = q.front().f;
                int y = q.front().s;
 //               cout << "AFSA " << x << " " << y << " " << q.size() << endl;
                q.pop();
                if(x == 1 || y == 1 || x == n || y == m) bad = 1;
                if(mxx.f < x) mxx = {x, y};
                if(mxy.s < y) mxy = {x, y};
                if(mnx.f > x) mnx = {x, y};
                if(mny.s > y) mny = {x, y};
                forn(0, k, 3)
                {
                    int tox = x + kx[k];
                    int toy = y + ky[k];
                    if(!used[tox][toy])
                    {
                        q.push({tox, toy});
 //                       cout << "ADD " << tox << " " << toy << endl;
                        used[tox][toy] = 1;
                    }
                }
//                cout << "BUG\n";
            }
            if(!bad)
            {
/*                cout << mny.f << " " << mny.s << endl;
                cout << mnx.f << " " << mnx.s << endl;
                cout << mxy.f << " " << mxy.s << endl;
                cout << mxx.f << " " << mxx.s << endl;*/
                forn(1, i, n)
                {
                    forn(1, j, m)
                    {
                        if(a[i][j] == '#')
                            used2[i][j] = 0;
                    }
                }
                forn(1, i, mnx.f - 1) used2[i][mnx.s + 1] = 1;
                forn(1, j, mny.s - 1) used2[mny.f + 1][j] = 1;
                go(mny.f, mny.s - 1, mnx.f - 1, mnx.s);
                forn(1, i, n)
                {
                    forn(1, j, m)
                    {
                        if(a[i][j] == '#')
                            used2[i][j] = 0;
                    }
                }
                forn(1, i, mnx.f - 1) used2[i][mnx.s - 1] = 1;
                forn(mxy.s + 1, j, m) used2[mxy.f + 1][j] = 1;
                go(mnx.f - 1, mnx.s, mxy.f, mxy.s + 1);
                forn(1, i, n)
                {
                    forn(1, j, m)
                    {
                        if(a[i][j] == '#')
                            used2[i][j] = 0;
                    }
                }
                forn(mxx.f + 1, i, n) used2[i][mxx.s - 1] = 1;
                forn(mxy.s + 1, j, m) used2[mxy.f - 1][j] = 1;
                go(mxy.f, mxy.s + 1, mxx.f + 1, mxx.s);
                forn(1, i, n)
                {
                    forn(1, j, m)
                    {
                        if(a[i][j] == '#')
                            used2[i][j] = 0;
                    }
                }
                forn(mxx.f + 1, i, n) used2[i][mxx.s + 1] = 1;
                forn(1, j, mny.s - 1) used2[mny.f - 1][j] = 1;
                go(mxx.f + 1, mxx.s, mny.f, mny.s - 1);
                forn(1, i, n)
                {
                    forn(1, j, m) cout << ans[i][j];
                    cout << "\n";
                }
            }
        }
    }
}
