#include <bits/stdc++.h>
#define int long long
#define F first
#define S second
#define pb push_back
#define mp make_pair
using namespace std;

const int MAXN = 2e5 + 10;
const int mod = 1e9 + 7;
int n, m;
int L;
int inf = 1e18;
pair <int, int> d[MAXN][2];
vector<pair<int,int> > g[MAXN];

void dijkstra(int x, int type) {
    for(int i = 1; i <= n; i ++) {
        d[i][type].F = inf;
        d[i][type].S = 0;
    }
    d[x][type] = {0 , 1};
    set<pair<int,int>> st;
    st.insert({0 , x});
    while(st.size()) {
        auto cur = *st.begin();
        st.erase(cur);
        for(auto to: g[cur.S]) {
            if(cur.F+to.S < d[to.F][type].F) {
                st.erase({d[to.F][type].F, to.F});
                d[to.F][type].F = cur.F+to.S;
                d[to.F][type].S = d[cur.S][type].S;
                st.insert({d[to.F][type].F, to.F});
            }
            else if(cur.F+to.S == d[to.F][type].F) {
                d[to.F][type].S += d[cur.S][type].S;
                d[to.F][type].S %= mod;
            }
        }
    }
}

main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int startv, finishv;
    cin >> n >> m >> startv>> finishv>> L;
    for(int i = 1; i <= m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb(mp(v, w));
        g[v].pb(mp(u, w));
    }
    dijkstra(startv, 0);
    dijkstra(finishv, 1);
    int len = d[finishv][0].F;
    if(L == len) {
        cout << d[finishv][0].S;
        return 0;
    }
    int ans = 0;
    for(int i = 1; i <= n; i ++) {
            if(i == finishv) continue;
        if(d[i][0].F + d[i][1].F == len) {
            for(auto x: g[i]) {
                if(d[i][0].F + x.S + d[x.F][1].F == L) {
                    ans += d[i][0].S * d[x.F][1].S % mod;
                    ans %= mod;
                }
            }
        }
    }
    cout << ans;
    return 0;
}
/*
8 10
1 8 3
1 2 1
1 3 1
2 4 1
2 5 1
3 6 1
3 7 1
4 8 1
5 8 1
6 8 1
7 8 1
*/
