#include<bits/stdc++.h>

using namespace std;

#define vt vector
#define all(s) s.begin(), s.end()
#define rall(s) s.end(), s.begin()
#define pb push_back
#define sz(s) (int)s.size()
#define nl '\n'
#define int long long
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int inf = 1e18, N = 4e2 + 5, mod = 1e9 + 7;

vt<pii> dir = {{-1, 0}, {1, 0}, {0, -1}, {0, 1}, {-1, 1}, {-1, -1}, {1, -1}, {1, 1}};

int n, m;

bool is(int i, int j) {
    if (i < 1 || i > n) return false;
    if (j < 1 || j > m) return false;
    return true;
}

signed main() {
    cin.tie(0) -> sync_with_stdio(0);
    cin >> n >> m;
    char c[n + 1][m + 1];
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> c[i][j];
        }
    }
    for (int i = 1; i <= n; i++) {
        int fst = 0, lst = -1;
        for (int j = 1; j <= m; j++) {
            if (c[i][j] == '#') {
                lst = j;
                if (!fst) fst = j;
            }
        }
        for (int j = fst; j <= lst; j++) {
            if (c[i][j] == '.') c[i][j] = ',';
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (c[i][j] != '#') continue;
            bool ok = 0;
            for (auto [x, y]: dir) {
                int a = i + x, b = j + y;
                if (!is(a, b)) continue;
                if (c[a][b] == ',') ok = 1;
            }
            if (!ok) c[i][j] = '.';
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (c[i][j] != '#') continue;
            bool ok = 0;
            for (auto [x, y]: dir) {
                int a = i + x, b = j + y;
                if (!is(a, b)) {
                    ok = 1;
                    continue;
                }
                if (c[a][b] == '.') ok = 1;
            }
            if (!ok) c[i][j] = ',';
        }
    }
    cout << nl;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (c[i][j] == ',') c[i][j] = '.';
            cout << c[i][j];
        }
        cout << nl;
    }
    return 0;
}

