
#include <bits/stdc++.h>
#define int long long

using namespace std;


const int MAXN = 1e6 + 5;
const int N = 1e5 + 7;

int n, m;
int ct;
int w[1005][1005];
int sz[MAXN];
int cnt[MAXN];
string s[1005], t[1005];

void dfs(int x, int y) {
    w[x][y] = ct;

    if(x > 1 && !w[x - 1][y] && s[x - 1][y] != '#') dfs(x - 1, y);
    if(x < n && !w[x + 1][y] && s[x + 1][y] != '#') dfs(x + 1, y);
    if(y && !w[x][y - 1] && s[x][y - 1] != '#') dfs(x, y - 1);
    if(y + 1 < m && !w[x][y + 1] && s[x][y + 1] != '#') dfs(x, y + 1);
}

void solve() {
    cin >> n >> m;

    for (int i = 1; i <= n; ++i) cin >> s[i];
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < m; ++j) {
            if(s[i][j] != '#' && !w[i][j]) {
                ++ct;

                dfs(i, j);
            }

            t[i][j] = '.';
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < m; ++j) {
            if(s[i][j] != '#') {
                if(i - 1 > 0 && s[i - 1][j] == '#' || i == 1) sz[w[i][j]]++;
                if(i + 1 <= n && s[i + 1][j] == '#' ||  i == n) sz[w[i][j]]++;
                if(j && s[i][j - 1] == '#' || !j) sz[w[i][j]]++;
                if(j + 1 < m && s[i][j + 1] == '#' || j + 1 == m) sz[w[i][j]]++;
                if(i - 1 > 0 && s[i - 1][j] == '#') cnt[w[i][j]]++;
                if(i + 1 <= n && s[i + 1][j] == '#') cnt[w[i][j]]++;
                if(j && s[i][j - 1] == '#') cnt[w[i][j]]++;
                if(j + 1 < m && s[i][j + 1] == '#') cnt[w[i][j]]++;
            }
        }
    }
    int x = -1;

    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < m; ++j) {
            if(s[i][j] != '#' && sz[w[i][j]] == cnt[w[i][j]]) x = w[i][j];
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < m; ++j) {
            if(w[i][j] == x) {
                if(i - 1 > 0 && s[i - 1][j] == '#') t[i - 1][j] = '#';
                if(i +  1 <= n && s[i + 1][j] == '#') t[i + 1][j] = '#';
                if(j - 1 >= 0 && s[i][j - 1] == '#') t[i][j - 1] = '#';
                if(j + 1 < m && s[i][j + 1] == '#') t[i][j + 1] = '#';
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < m; ++j) {
            if(s[i][j] == '#') {
                if(i + 1 <= n && j + 1 < m && t[i + 1][j] == '#' && t[i][j + 1] == '#') t[i][j] = '#';
                if(i + 1 <= n && j - 1 >= 0 && t[i + 1][j] == '#' && t[i][j - 1] == '#') t[i][j] = '#';
                if(i - 1 > 0 && j + 1 < m && t[i - 1][j] == '#' && t[i][j + 1] == '#') t[i][j] = '#';
                if(i - 1 > 0 && j - 1 >= 0 && t[i - 1][j] == '#' && t[i][j - 1] == '#') t[i][j] = '#';
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < m; ++j) {
            if(t[i][j] == '#') {
                int ct = 0;

                if(i - 1 > 0 && w[i - 1][j] == x) ct++;
                if(i + 1 <= n && w[i + 1][j] == x) ct++;
                if(j - 1 >= 0 && w[i][j - 1] == x) ct++;
                if(j + 1 < m && w[i][j + 1] == x) ct++;

                if(ct > 1) t[i][j] = '.';
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < m; ++j) cout << t[i][j];

        cout << '\n';
    }
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    while (t--)solve();
    return 0;
}
/*
4 6
######
#.#.##
#...#.
#####.
*/

