#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <stack>
#include <cassert>
#include <assert.h>
using namespace std;
using ll = long long;
using ld = long double;

#define pr pair
#define mpr make_pair
#define ff first
#define ss second

const int N = 100005, LG = 20;
ll x[N], p[N];
pr<int, int> h[N];
int o[N];
int n, lg;

pr<ll, int> st[N][LG];

pr<ll, int> merge(pr<ll, int> a, pr<ll, int> b)
{
	return  (a.ff <= b.ff ? a : b);
}

void bld()
{
	int i, j;
	int g = 1;

	for (i = 1; i <= n; i++) {
		st[i][0] = mpr(p[i], x[i]);
	}

	for (i = 1; i <= lg; i++) {
		for (j = 1; j <= n - (g << 1) + 1; j++) {
			st[j][i] = merge(st[j][i - 1], st[j + g][i - 1]);
		}
		g <<= 1;
	}

	return;
}

pr<ll, int> qry(int l, int r)
{
	//cout << l << ' ' << r << "\n";
	int t = (r - l + 1);
	return merge(st[l][h[t].ff], st[r - h[t].ss + 1][h[t].ff]);
}

void pre()
{
	int i, j;

	stack<pr<int, int>> s;

	for (i = n; i >= 1; i--) {
		while (!s.empty() && s.top().ff >= p[i]) s.pop();

		if (!s.empty()) o[i] = s.top().ss;
		
		s.push(mpr(p[i], i));
	}

	return;
}

void solve()
{
	int i, j;

	ll B, C;

	cin >> n >> B >> C;

	for (i = 1; i <= n; i++) {
		cin >> x[i] >> p[i];
	}

	lg = 1;
	while ((1 << lg) <= n) lg++;
	lg--;

	bld();

	pre();

	/*for (i = 1; i <= n; i++) {
		cout << o[i] << ' ';
	}
	cout << "\n";*/

	//cout << qry(2, 2).ff << ' ' << qry(2, 2).ss << "\n";

	ll currB = B, currC = 0, maxC;
	int ind = 1;

	int l, r;

	while (ind < n) {
		ll money = (C - currC) * p[ind];

		if (money > currB) {
			maxC = currC + currB / p[ind];

			l = ind + 1;
			r = upper_bound(x + l, x + n + 1, x[ind] + maxC) - x;
			r--;

			ll mn = qry(l, r).ff;

			if (mn >= p[ind]) {
				cout << x[ind] + maxC << "\n";
				return;
			}

			if (o[ind] == 0) {
				cout << ind << ' ' << "\n";
				assert(false);
			}

			ll dist = x[o[ind]] - x[ind];

			ll cost = max(0LL, (dist - currC) * p[ind]);
			currB -= cost;
			currC = max(0LL, currC - dist);

			ind = o[ind];
		}
		else {
			l = ind + 1;
			r = upper_bound(x + l, x + n + 1, x[ind] + C) - x;
			r--;

			pr<ll, int> mn = qry(l, r);

			if (mn.ff >= p[ind]) {
				ll dist = mn.ss - x[ind];

				currB -= money;
				currC = C - dist;

				ind = mn.ss;
			}
			else {
				if (o[ind] == 0) {
					cout << ind << '.' << "\n";
					assert(false);
				}
				ll dist = x[o[ind]] - x[ind];

				ll cost = max(0LL, (dist - currC) * p[ind]);
				currB -= cost;
				currC = max(0LL, currC - dist);

				ind = o[ind];
			}
		}

		//cout << currB << ' ' << currC << ' ' << "\n";
	}

	currC = min(C, currC + currB / p[n]);

	cout << x[n] + currC << "\n";

	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int i, j;

	h[1] = { 0, 1 };

	for (i = 2; i <= 100002; i++) {
		h[i] = h[i - 1];

		if ((h[i].ss << 1) <= i) {
			h[i].ff++;
			h[i].ss <<= 1;
		}
	}
	
	solve();

	return 0;
}