#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <set>
#include <iomanip>
#include <queue>

using namespace std;

int main()
{
    int n;
    cin>>n;
    vector<int> numbers(n);
    for(int i = 0; i < n; i++){
        cin >> numbers[i];
    }
    sort(numbers.begin(), numbers.end());
    vector<int> d((n-1)/2);
    multiset<int> s;
    for(int i = 0; i < (n-1)/2; i++){
        d[i] = numbers[i+1]+numbers[n-1-i];
        s.insert(numbers[i+1]+numbers[n-1-i]);
    }
    int answer = *--s.end()-*s.begin();

    //for(int i : d) cout << i << ' ';
    //return 0;

    for(int i = 1; i < n; i++){
        if(i <= (n-1)/2){
            s.erase(s.find(d[i-1]));
            d[i-1] -= numbers[i]-numbers[i-1];
            s.insert(d[i-1]);
        }
        else{
            int it = n-i;
            s.erase(s.find(d[it-1]));
            d[it-1] -= numbers[i]-numbers[i-1];
            s.insert(d[it-1]);
        }
        answer = min(answer, *--s.end()-*s.begin());
        //cout << answer << '\n';
        //cout << *--s.end()-*s.begin() << '\n';
        //for(int i : d) cout << i << ' ';
        //cout << '\n';
    }
    cout << answer;
    return 0;
}
