#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

template<typename T>
bool rmax(T& a, T b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
bool rmin(T& a, T b) {
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T>& a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T>& a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

struct node {
    node *left = nullptr;
    node *right = nullptr;

    int cnt_of_null = 0;
};

void upd(node *&v, int tl, int tr, int l) {
    if (tl >= tr || tl > l || tr <= l) {
        return;
    }

    if (!v) {
        v = new node();
        v->cnt_of_null = tr - tl;
    }

//    cout << tl << ' ' << tr << ' ' << v->cnt_of_null << endl;
    if (tl + 1 == tr) {
        v->cnt_of_null = 0;
        return;
    }

    v->cnt_of_null--;

    int tm = (tl + tr) / 2;
    upd(v->left, tl, tm, l);
    upd(v->right, tm, tr, l);
}

int get_k_th(node *&v, int tl, int tr, int &k) {
    if (tl >= tr) {
        return -1;
    }


    if (!v) {
        v = new node();
        v->cnt_of_null = tr - tl;
    }

    if (v->cnt_of_null < k) {
        k -= v->cnt_of_null;
        return -1;
    }
//    cout << tl << ' ' << tr << ' ' << k << ' ' << v->cnt_of_null << endl;

    if (tl + 1 == tr) {
//        cout << tl << endl;
        return tl;
    }

    int tm = (tl + tr) / 2;
    int ans = get_k_th(v->left, tl, tm, k);

    if (ans == -1) {
        return get_k_th(v->right, tm, tr, k);
    }
    return ans;
}

void solve() {
    node *v = new node();
    v->cnt_of_null = 2e9;

    int n, q;
    cin >> n >> q;

    for (int i = 0; i < n; i++) {
        int p;
        cin >> p;

        upd(v, 0, 2e9, p);
    }

//    cout << v->cnt_of_null << endl;
//    return;

    while (q--) {
        int p;
        cin >> p;

        cout << get_k_th(v, 0, 2e9, p) << ' ';
    }
}

signed main() {
//    ios::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);

#ifdef LOCAL
    freopen("..\\input.txt", "r",  stdin);
    freopen("..\\output.txt", "w", stdout);
#endif

    int t  = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}