#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int f(int ind, int n, long long sum, vector<long long>& a) {
	int l = 0, r = n - 1;
	long long max = 0, min = sum;
	int max1, max2, min1, min2;
	for (int i = 0; i < n / 2; ++i) {
		if (ind == l) {
			l += 1;
		}
		else if (ind == r) {
			r -= 1;
		}
		long long s = a[l] + a[r];
		if (s > max) {
			max = s;
			max1 = l;
			max2 = r;
		}
		if (s < min) {
			min = s;
			min1 = l;
			min2 = r;
		}
		++l;
		--r;
	}
	return max - min;
}

long long miN(long long a, long long b) {
	return (a < b) ? a : b;
}
bool cmp(const pair<int, int> &a, const pair<int, int> &b) {
	return (a.first + a.second) < (b.first + b.second);
}

int main() {
	int n;
	cin >> n;
	vector<long long> a(n);
	long long sum = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		sum += a[i];
	}
	sort(a.begin(), a.end());
	
	int mi = n;
	int ind = -1;
	for (int i = 0; i < n; ++i) {
		int med = (sum - a[i]) / (n - 1);
		int t = a[i];
		int c = lower_bound(a.begin(), a.end(), med) - a.begin() + 1;
		a[i] = t;
		if (abs(n - c * 2 - 1) < mi) {
			mi = abs(n - c * 2 - 1);
			ind = i;
		}
	}
	cout << f(ind, n, sum, a);
}