
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define f first
#define s second
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

typedef tree
<ll,
 null_type,
 less<ll>,
 rb_tree_tag,
 tree_order_statistics_node_update> ordered_set;

const ll N = 2e5 + 100;
const ll oo = 1e18;
const ll MOD = 1e9 + 7;

vector <pair<ll, ll> > a[N];
vector <int> b[N];
 pair<ll, ll> fn_inf[N];

 ll sum(ll x, ll y)
 {
     return (x + y) % MOD;
 }

 ll mult(ll x, ll y)
 {
     return (x * y) % MOD;
 }


ll en[N];
ll be[N];

void Calc_Be(int x)
{
    if (be[x] != -1) return;
    be[x] = 0;
    for (auto i : b[x])
    {
        Calc_Be(i);
        be[x] = sum(be[x], be[i]);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m;
    cin >> n >> m;
    ll st, fn, len;
    cin >> st >> fn >> len;
    for (ll i = 0; i < m; i++)
    {
        ll x, y, z;
        cin >> x >> y >> z;
        a[--x].pb({--y, z});
        a[y].pb({x, z});
    }

    priority_queue<pair<ll, ll>, vector <pair<ll, ll> >, greater<pair<ll, ll> > > q;

    for (ll i = 0; i < n; i++) fn_inf[i] = {oo, 0};
    fn_inf[--fn] = {0, 1};
    q.push({0, fn});
    while (!q.empty())
    {
        pair<ll, ll> c = q.top();
        q.pop();
        if (c.f > fn_inf[c.s].f) continue;
        for (auto i : a[c.s])
        {
            if (i.s + fn_inf[c.s].f < fn_inf[i.f].f)
            {
                fn_inf[i.f] = {i.s + fn_inf[c.s].f, fn_inf[c.s].s};
                q.push({fn_inf[i.f].f, i.f});
            }
            else
            if (i.s + fn_inf[c.s].f == fn_inf[i.f].f)
            {
                fn_inf[i.f].s = sum(fn_inf[i.f].s, fn_inf[c.s].s);
            }
        }
    }
    for (int i = 0; i < n; i++) en[i] = fn_inf[i].s;
    for (int i = 0; i < n; i++)
        for (auto j : a[i])
            if (fn_inf[j.f].f + j.s == fn_inf[i].f)
    {
        b[j.f].pb(i);
    }

    for (int i = 0; i < n; i++) be[i] = -1;
    be[--st] = 1;
    for (int i = 0; i < n; i++) Calc_Be(i);


    ll ans = 0;
    for (int i = 0; i < n; i++)
        if (i != fn)
    {
        for (auto j : a[i])
        {
            if ((fn_inf[st].f - fn_inf[i].f) + fn_inf[j.f].f + j.s == len && fn_inf[i].f != fn_inf[j.f].f + j.s)
            {
                ans = sum(ans, mult(be[i], en[j.f]));
            }
        }
    }
    if (fn_inf[st].f == len) ans = sum(ans, be[fn]);
    cout << ans << endl;

}
/*
6 7
1 6 5
1 2 3
2 5 1
1 3 1
3 5 1
2 4 1
5 6 2
4 6 1

5 5
1 5 4
1 3 2
1 2 1
2 3 1
4 2 1
5 2 1
*/
