#include <bits/stdc++.h>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define x first
#define fi first
#define ss second
#define y second
#define se second
#define all(a) a.begin(), a.end()
#define sz(a) (int)a.size()
//#define int long long

using namespace std;
//using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pt;
typedef pair <ll, ll> ptll;
//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int inf = 1000000009;
const ll inf18 = 1000000000000000018;

template <class T1, class T2> istream& operator>>(istream& is, pair <T1, T2>& a){is >> a.ff >> a.ss; return is;}
template <class T1, class T2> ostream& operator<<(ostream& os, pair <T1, T2> a){os << "(" << a.ff << ", " << a.ss << ")"; return os;}
template <class T> istream& operator>>(istream& is, vector <T>& a){for (auto &x : a) is >> x; return is;}
template <class T> ostream& operator<<(ostream& os, vector <T> a){for (auto x : a) os << x << " "; os << endl; return os;}

void solve(){
    int n, m;
    cin >> n >> m;
    vector <string> a(n);
    cin >> a;
    vector <pair <int, int>> d;
    for (int i = 0; i < n; i++){
        if (a[i][0] == '.') d.push_back({i, 0}), a[i][0] = '*';
        if (a[i][m - 1] == '.') d.push_back({i, m - 1}), a[i][m - 1] = '*';
    }
    for (int j = 0; j < m; j++) {
        if (a[0][j] == '.') d.push_back({0, j}), a[0][j] = '*';
        if (a[n - 1][j] == '.') d.push_back({n - 1, j}), a[n - 1][j] = '*';
    }
    for (int i = 0; i < d.size(); i++){
        auto [x, y] = d[i];
        if (x > 0 && a[x - 1][y] == '.'){
            a[x - 1][y] = '*';
            d.emplace_back(x - 1, y);
        }
        if (x < n - 1 && a[x + 1][y] == '.'){
            a[x + 1][y] = '*';
            d.emplace_back(x + 1, y);
        }
        if (y > 0 && a[x][y - 1] == '.'){
            a[x][y - 1] = '*';
            d.emplace_back(x, y - 1);
        }
        if (y < m - 1 && a[x][y + 1] == '.'){
            a[x][y + 1] = '*';
            d.emplace_back(x, y + 1);
        }
    }
    vector <pair <int, int>> to;
    vector <vector <int>> cnt(n, vector <int> (m));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            if (a[i][j] == '.'){
                if (i) cnt[i - 1][j]++;
                if (i < n - 1) cnt[i + 1][j]++;
                if (j) cnt[i][j - 1]++;
                if (j < m - 1) cnt[i][j + 1]++;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (cnt[i][j] >= 2 && a[i][j] == '#') {
                to.emplace_back(i, j);
            }
        }
    }
    for (int i = 0; i < to.size(); i++){
        auto [x, y] = to[i];
        if (a[x][y] != '#' || x == 0 || x == n - 1 || y == 0 || y == m - 1) continue;
        if (cnt[x][y] == 2){
            int fl = 0;
            for (int di = x - 1; di <= x + 1; di += 2){
                for (int dj = y - 1; dj <= y + 1; dj += 2){
                    fl |= a[x][dj] == '#' && a[di][y] == '#' && a[di][dj] == '#';
                }
            }
            if (!fl) continue;
        }
        a[x][y] = '.';
        if (x){
            cnt[x - 1][y]++;
            if (cnt[x - 1][y] == 2) to.emplace_back(x - 1, y);
        }
        if (x < n - 1){
            cnt[x + 1][y]++;
            if (cnt[x + 1][y] == 2) to.emplace_back(x + 1, y);
        }
        if (y){
            cnt[x][y - 1]++;
            if (cnt[x][y - 1] == 2) to.emplace_back(x, y - 1);
        }
        if (y < m - 1){
            cnt[x][y + 1]++;
            if (cnt[x][y + 1] == 2) to.emplace_back(x, y + 1);
        }
    }
    vector <string> ans(n, string(m, '.'));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            if (a[i][j] == '.'){
                for (int di = max(0, i - 1); di < min(n, i + 2); di++){
                    for (int dj = max(0, j - 1); dj < min(m, j + 2); dj++){
                        if (a[di][dj] == '#') ans[di][dj] = '#';
                    }
                }
            }
        }
    }
    for (auto x : ans) cout << x << endl;
}

int32_t main(){
#ifdef LOCAL
    auto st = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) solve();
#ifdef LOCAL
    auto fn = clock();
    cout << endl << "TIME: " << (fn - st) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
}
