#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define ss second
#define ff first
#define all(a) (a).begin(), (a).end()
#define endl '\n'

const ll INF = 1e18 + 10, mod = 1e9 + 7;

vector<pair<int, int>> g[200000];

void f(int s, vector<int> &d, vector<int> &cnt) {
    set<pair<int, int>> mn;
    mn.insert({0, s});
    d[s] = 0;
    cnt[s] = 1;
    while (!mn.empty()) {
        auto [l, v] = *mn.begin();
        mn.erase(mn.begin());
        for (auto [u, w]: g[v]) {
            if (d[v] + w < d[u]) {
                mn.erase({d[u], u});
                d[u] = d[v] + w;
                cnt[u] = cnt[v];
                mn.insert({d[u], u});
            } else if (d[v] + w == d[u]) {
                cnt[u] += cnt[v];
            }
        }
    }
}

void f1(int s, int t, vector<int> &d1, vector<int> &d2, vector<int> &d, vector<int> &cnt) {
    set<pair<int, int>> mn;
    mn.insert({0, s});
    d[s] = 0;
    cnt[s] = 1;
    while (!mn.empty()) {
        auto [l, v] = *mn.begin();
        mn.erase(mn.begin());
        for (auto [u, w]: g[v]) {
            if ((d1[u] + d2[u] == d1[t])) {
                if (d[v] + w < d[u]) {
                    mn.erase({d[u], u});
                    d[u] = d[v] + w;
                    cnt[u] = cnt[v];
                    mn.insert({d[u], u});
                } else if (d[v] + w == d[u]) {
                    cnt[u] += cnt[v];
                }
                cnt[u] %= mod;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    int s, t, l;
    cin >> s >> t >> l;
    s--, t--;;

    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w;
        x--, y--;
        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }

    vector<int> d1(n, INF), d2(n, INF), cnt1(n), cnt2(n), d(n, INF), cnt(n);

    f(s, d, cnt1);
    f(t, d2, cnt2);
    f1(s, t, d, d2, d1, cnt1);

    int ans = 0;

    for (int i = 0; i < n; ++i) {
        if (d1[i] + d2[i] == d1[t]) {
            for (auto [j, w]: g[i]) {
                if (d1[i] + w + d2[j] == l) {
                    ans += cnt1[i] * cnt2[j] % mod;
                    ans %= mod;
                }
            }
        }
    }

    cout << ans;
    return 0;
}
