#include <bits/stdc++.h>
using namespace std;

#define int long long
typedef long long ll;
typedef long double ld;

const int MX = 1e6 + 2;
const int INF32 = 2e9 + 5;
const int INF64 = 2e18 + 7;

int n, m, ind = 1, a[MX], q[MX], t[MX * 4], son[MX * 4];


void create(int v) {
    if (son[v]) return;
    son[v] = ind;
    ind += 2;
}


void update(int v, int tl, int tr, int i, int x) {
    create(v);
    if (tl == tr) {
        t[v] += x;
        return;
    }
    int tm = (tl + tr) / 2;
    if (i <= tm) update(son[v], tl, tm, i, x);
    else update(son[v] + 1, tm + 1, tr, i, x);
    t[v] = t[son[v]] + t[son[v] + 1];
}


int get(int v, int tl, int tr, int l, int r) {
    create(v);
    if (l > tr || tl > r) return 0;
    if (l <= tl && tr <= r) return t[v];
    int tm = (tl + tr) / 2;
    return get(son[v], tl, tm, l, r) + get(son[v] + 1, tm + 1, tr, l, r);
}

void solve() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        update(0, 0, INF32 - 1, a[i], 1);
    }
    for (int i = 0; i < m; i++) cin >> q[i];
    //q[0] = 2;
    for (int e = 0; e < m; e++) {
        int x = q[e];
        int l = -1;
        int r = INF32;
        while (r - l > 1) {
            int m2 = (l + r) / 2;
            int y = get(0, 0, INF32 - 1, 0, m2);
            //if (m2 + 1 - y <= 10) cout << m2 << " " << y << " " << x << "\n";
            if (m2 + 1 - y >= x) r = m2;
            else l = m2;
        }
        cout << r << " ";
    }
}

int32_t main() {
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) solve();
    return 0;
}
