#include <bits/stdc++.h>
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<long long,long long>
#define mpp make_pair
#define ve vector
#define pb push_back
#define sz(x)       (int)((x).size())
#define all(x)      (x).begin(),(x).end()
#define ll long long
const ll inf = 1e18;
using namespace std;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }

constexpr int md = 1e9 + 7;
inline int add(int a, int b) { a += b; if (a >= md) a -= md; return a; }
inline int sub(int a, int b) { a -= b; if (a < 0) a += md; return a; }
inline int mul(int a, int b) { return a * 1ll * b % md; }

inline void solve() {
    int n, m;
    cin >> n >> m;
    ve<ve<pii>> gr(n);

    ll s, t, l;
    cin >> s >> t >> l, --s, --t;

    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w, --v, --u;
        gr[v].pb({u, w}); gr[u].pb({v, w});
    }

    ve<ll> ds(n, inf);
    set<pll> st;

//    cout << s + 1 << '\n';

    ds[s] = 0;
    st.insert({0, s});

    while (sz(st)) {
        int v = st.begin()->se;
        st.erase(st.begin());

        for (auto &[to, w] : gr[v]) {
            if (ds[to] > ds[v] + w) {
                st.erase({ds[to], to});
                ds[to] = ds[v] + w;
                st.insert({ds[to], to});
            }
        }
    }

    ve<ll> dt(n, inf);
    st.insert({0, t});
    dt[t] = 0;

    while (sz(st)) {
        int v = st.begin()->se;
        st.erase(st.begin());

        for (auto &[to, w] : gr[v]) {
            if (dt[to] > dt[v] + w) {
                st.erase({dt[to], to});
                dt[to] = dt[v] + w;
                st.insert({dt[to], to});
            }
        }
    }

    ve<pii> es, et;
    for (int i = 0; i < n; ++i) {
        for (auto &[to, w] : gr[i]) {
            if (ds[to] == ds[i] + w) es.pb({i, to});
            if (dt[to] == dt[i] + w) et.pb({i, to});
        }
    }

    ve<int> ord;
    ve<int> used(n);

    ve<ve<int>> grs(n);
    for (auto &[a, b] : es) grs[a].pb(b);
    function<void(int)> dfso = [&](int v) {
        used[v] = 1;
        for (auto &to : grs[v]) {
            if (used[to]) continue;
            dfso(to);
        }
        ord.pb(v);
    };

    ve<int> dps(n);
    dps[s] = 1;
    dfso(s);

    reverse(all(ord));

    for (int i = 0; i < n; ++i) {
        int v = ord[i];
        for (auto &to : grs[v]) {
            dps[to] = add(dps[to], dps[v]);
        }
    }

    ord.clear();
    fill(all(used), 0);
    ve<ve<int>> grt(n);
    for (auto &[a, b] : et) grt[a].pb(b);

    function<void(int)> dfso1 = [&](int v) {
        used[v] = 1;
        for (auto &to : grt[v]) {
            if (used[to]) continue;
            dfso1(to);
        }
        ord.pb(v);
    };

    ve<int> dpt(n);
    dpt[t] = 1;
    dfso1(t);
    reverse(all(ord));

    for (int i = 0; i < n; ++i) {
        int v = ord[i];
        for (auto &to : grt[v]) {
            dpt[to] = add(dpt[to], dpt[v]);
//            cout << to << " " << v << " " << dpt[v] << "\n";
        }
    }

    int ans = 0;

    ll D = ds[t];
    if (l == D) {
        return void(cout << dps[t]);
    }
    for (int i = 0; i < n; ++i) {
        if (ds[i] + dt[i] == D && i != t) {
//            cout << i + 1 << " on shortest" << '\n';
            for (auto &[to, w] : gr[i]) {
//                cout << i + 1 << ", " << to + 1 << ": " << ds[i] + dt[to] + w << " ";
//                cout << " " << dps[i] << " " << dpt[to] << '\n';
                if (ds[i] + w + dt[to] == l) {
                    ans = add(ans, mul(dps[i], dpt[to]));
                }
            }
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
