#include <bits/stdc++.h>
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<long long,long long>
#define mpp make_pair
#define ve vector
#define pb push_back
#define sz(x)       (int)((x).size())
#define all(x)      (x).begin(),(x).end()
#define ll long long
const ll inf = 1e18;
const int iinf = 1e9;
using namespace std;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }

const pii di[8] = {{-1, 0}, {0, 1}, {1, 0}, {0, -1}, {1, 1}, {1, -1}, {-1, 1}, {-1, -1}};
const pii di1[4] = {{-1, 0}, {0, 1}, {1, 0}, {0, -1}};

inline void solve() {
    int n, m;
    cin >> n >> m;
    ve<ve<char>> a(n, ve<char> (m));
    for (auto &i : a) for (auto &j : i) cin >> j;
    auto valid = [&](int x, int y) { return x >= 0 && x < n && y >= 0 && y < m; };

    queue<pii> q;
    ve<ve<int>> used(n, ve<int> (m));

    pair<int,ve<pii>> ans = mpp(iinf, ve<pii>(0));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (used[i][j] || a[i][j] == '#') continue;

            bool fl = 1;

            ve<pii> bl;
            used[i][j] = 1;
            q.push({i, j});

            while (sz(q)) {
                auto [x, y] = q.front(); q.pop();
                for (auto &[dx, dy] : di) {
                    int xx = x + dx, yy = y + dy;
                    if (!valid(xx, yy)) {
                        fl = 0;
                        break;
                    }

                    if (a[xx][yy] == '#') {
                        bl.pb({xx, yy});
                    }
                    else if (!used[xx][yy]) {
                        used[xx][yy] = 1;
                        q.push({xx, yy});
                    }
                }
            }

            sort(all(bl));
            bl.erase(unique(all(bl)), bl.end());
//            cout << i << " " << j << " " << fl << " " << sz(bl) << endl;

            if (!fl) continue;
            if (!sz(bl)) continue;

            int x = bl[0].fi, y = bl[0].se;
            for (int i = 1; i < n; ++i) {
                if (bl[i].se < y || (bl[i].se == y && bl[i].fi < x)) {
                    x = bl[i].fi;
                    y = bl[i].se;
                }
            }

            set<pii> st(all(bl));

            int s = x, t = y;

            ve<pii> cur;
            function<bool(int,int)> dfs = [&](int x, int y) {

                used[x][y] = 1;
                cur.pb({x, y});

//                cout << x << " " << y << endl;

                for (auto &[dx, dy] : di1) {
                    int xx = x + dx, yy = y + dy;
                    if (!valid(xx, yy) || !st.count(mpp(xx, yy))) continue;
                    if (xx == s && yy == t) return 1;
                    if (used[xx][yy]) continue;
                    if (dfs(xx, yy)) return 1;
                }
                return 0;
            };
            dfs(x, y);
//
            pair<int,ve<pii>> c = mpp(sz(cur), cur);
            chmin(ans, c);
        }
    }

    ve<ve<char>> f(n, ve<char> (m, '.'));
    for (auto &[x, y] : ans.se) f[x][y] = '#';

    for (auto &i : f) {
        for (auto &j : i) cout << j;
        cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
