#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define ve vector
#define fi first
#define se second
#define all(x) x.begin(), x.end()
using namespace std;
typedef pair<long long, long long> pll;
typedef pair<int, int> pii;

ve<ve<char>> mat;
ve<ve<int>>used, ans;

int n, m;

int miny = 1e9, minx = 1e9, maxx = -1,  maxy = -1;

ve<int>x = {1, 0, -1, 0}, y = {0, 1, 0, -1};

void bfs(int y0, int x0, int code, int sp){
    used[y0][x0] = 1;
    queue<pii>q;
    q.push({y0, x0});

    while(!q.empty()){
        auto v = q.front();
        if(sp){
            maxx = max(maxx, v.se);
            maxy = max(maxy, v.fi);

            minx = min(minx, v.se);
            miny = min(miny, v.fi);
        }

        q.pop();
        /// se - x, fi - y
        for(int h = 0; h < 4; h++){
            int nx = v.se + x[h];
            int ny = v.fi + y[h];
            if(ny >= 0 && ny < n && nx >= 0 && nx < m && !used[ny][nx] && mat[ny][nx] == '.'){
                used[ny][nx] = code;
                q.push({ny, nx});
            }
        }
    }
}






int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);

    cin >> n >> m;

    used.resize(n, ve<int>(m, 0));
    ans.resize(n, ve<int>(m, 0));
    mat.resize(n, ve<char>(m));

    for(int i = 0; i < n; i++){
        string s;cin >> s;
        for(int j = 0; j < s.size();j++)
            mat[i][j] = s[j];
    }

    for(int i = 0; i < n; i++){
        if(!used[i][0] && mat[i][0] == '.'){
            bfs(i, 0, 1, 0);
        }
        if(!used[i][m - 1] && mat[i][m - 1] == '.'){
            bfs(i, m - 1, 1, 0);
        }
    }
//    cout << "!1";
//
    for(int j= 0; j < m; j ++){
        if(!used[0][j]&& mat[0][j] == '.'){
            bfs(0, j, 1, 0);
        }
        if(!used[n - 1][j] && mat[n - 1][j] == '.'){
            bfs(n - 1, j, 1, 0);
        }
    }
//    cout << "2";
//
//
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m ;j++){
            if(!used[i][j] && mat[i][j] == '.'){
                bfs(i, j, 2, 1);
            }
        }
    }
//    cout << "3";
//
    maxx++;
    maxy++;
    minx--;
    miny--;
//    cout << maxx << " " << maxy << " " << miny <<" " << minx << endl;

//
    pii t = {miny, minx};

    while(!(mat[t.fi][t.se] == '#' && mat[t.fi + 1][t.se] == '.')){
        t.se++;
    }
    ans[t.fi][t.se] = 3;

    ///   maxx, miny
    while(t.se != maxx){
        if(t.se + 1 >= m || mat[t.fi][t.se + 1] != '#'){
            t.fi++;
        }
        else{
            t.se++;
        }
        ans[t.fi][t.se] = 3;
    }
    ///   maxy, maxx
    while(t.fi != maxy){
        if(t.fi + 1 >= n || mat[t.fi + 1][t.se] != '#'){
            t.se--;
        }
        else{
            t.fi++;
        }
        ans[t.fi][t.se] = 3;
    }
    ///  maxy, minx;
    while(t.se != minx){
        if(t.se - 1 < 0 || mat[t.fi][t.se - 1] != '#' ){
            t.fi--;
        }
        else{
            t.se--;
        }
        ans[t.fi][t.se] = 3;
    }
    ///  miny, minx
    while(t.fi != miny){
        if(t.fi - 1 < 0 || mat[t.fi - 1][t.se] != '#'){
            t.se++;
        }
        else{
            t.fi--;
        }
        ans[t.fi][t.se] = 3;
    }
    ///   miny, maxx
    while(t.se != maxx){
        if(t.se + 1 >= m || mat[t.fi][t.se + 1] != '#'){
            t.fi++;
        }
        else{
            t.se++;
        }
        ans[t.fi][t.se] = 3;
    }


    for(int i = 0; i < n ;i++){
        for(int j = 0; j < m; j++){
            if(ans[i][j] == 3){
                cout << '#';
            }
            else{
                cout << '.';
            }
        }
        cout << '\n';
    }

    return 0;
}
