#include <iostream>
#include <vector>
#include <map>

#define ll long long

using namespace std;

pair<ll, ll> get(string s) {
    string left = s.substr(0, s.find('-')), right = s.substr(s.find('-')+1, s.size());

    ll first = stoi(left);
    ll second = stoi(right);

    return {first, second};
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, q; cin >> n >> q;
    map<string, ll> m;
    vector<ll> a(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    int k = 1;

    if (n == 1) {
        m[to_string(a[0])+'-'+to_string(a[0])] = 1;
    } else {
        for (int i = 1; i < n; ++i) {
            if (a[i] - a[i - 1] == 1 && i != n - 1) {
                k++;
            } else {
                if (i == n - 1 && a[i] - a[i - 1] == 1) {
                    m[to_string(a[i - k])+'-'+ to_string(a[i])] = k + 1;
                } else if (i == n - 1 && a[i] - a[i - 1] > 1) {
                    m[to_string(a[i - 1]) + '-' + to_string(a[i - 1])] = 1;
                    m[to_string(a[i]) + '-' + to_string(a[i])] = 1;
                } else {
                    m[to_string(a[i - k])+'-'+ to_string(a[i-1])] = k;
                }
                k = 1;
            }
        }
    }

    vector<ll> qq(q);

    for (int i = 0; i < q; ++i) {
        cin >> qq[i];
    }

    for (int i = 0; i < q; ++i) {
        --qq[i];
        ll accum = 0;

        for (auto key : m) {
            pair<ll, ll> p = get(key.first);

            if (p.second <= qq[i] + accum) {
                accum += key.second;
            }
        }

//        cout << accum << endl;

        ll ans = qq[i] + accum;

        for (auto key : m) {
            pair<ll, ll> p = get(key.first);
            if (p.first <= ans && ans <= p.second) {
                ans += key.second;
            }
        }

        cout << ans << ' ';

    }
    cout << endl;


    return 0;
}