#include <bits/stdc++.h>

using namespace std;

#define int long long

const int kek = 1e9 + 1;
const int mod = 1e9 + 7;
/*
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int h, w;
    cin >> h >> w;
    vector<vector<int>> dp(h + 1, vector<int>(w + 1)), dppref(h + 1, vector<int>(w + 1)), pref(h + 1, vector<int>(w + 1));
    for (int i = 1; i <= h; ++i) {
        for (int j = 1; j <= w; ++j) {
            if (j == 1) {
                dp[i][j] = i * j;
                pref[i][j] = i * j;
                dppref[i][j] = 0;
                cout << i << ' ' << j << endl;
                cout << dp[i][j] << ' ' << pref[i][j] << ' ' << dppref[i][j] << endl;
                continue;
            }
            if (i == 1) {
                dp[i][j] = i * j;
                pref[i][j] = pref[i][j - 1] + i * j;
                dppref[i][j] = dppref[i][j - 1] + (j - 3 >= 0 ? pref[i][j - 3] : 0) + (j - 2 >= 0 ? dp[i][j - 2] : 0);
                cout << i << ' ' << j << endl;
                cout << dp[i][j] << ' ' << pref[i][j] << ' ' << dppref[i][j] << endl;
                continue;
            }
            dp[i][j] += i * j * ((i - 2) * (j - 2) + 1);
            dp[i][j] %= mod;
            //for (int k = 1; k <= i - 2; ++k) {
            //    dp[i][j] += (i - 1 - k) * dppref[k][j];
           //    dp[i][j] %= mod;
            //}
            for (int k = 1; k <= i - 2; ++k) {
                for (int p = 1; p <= j - 2; ++p) {
                    dp[i][j] += (i - 1 - k) * (j - 1 - p) * dp[k][p];
                    dp[i][j] %= mod;
                }
            }
            pref[i][j] = pref[i][j - 1] + dp[i][j];
            pref[i][j] %= mod;
            dppref[i][j] = dppref[i][j - 1] + (j - 3 >= 0 ? pref[i][j - 3] : 0) + (j - 2 >= 0 ? dp[i][j - 2] : 0);
            dppref[i][j] %= mod;
            cout << i << ' ' << j << endl;
            cout << dp[i][j] << ' ' << pref[i][j] << ' ' << dppref[i][j] << endl;
        }
    }
    cout << dp[h][w] << endl;
}*/

const int inf = 1e18;
vector<pair<int, int>> djk(int v, vector<vector<pair<int, int>>> &g) {
    set<pair<int, int>> q;
    q.insert({ 0, v });
    vector<pair<int, int>> res(g.size(), make_pair(inf, 0));
    res[v] = { 0, 1 };
    while (!q.empty()) {
        auto [l, v] = *q.begin();
        q.erase(q.begin());
        for (auto [u, w] : g[v]) {
            if (res[u].first >= res[v].first + w) {
                if (res[u].first == res[v].first + w) {
                    res[u].second += res[v].second;
                } else {
                    q.erase({ res[u].first, u });
                    res[u] = {res[v].first + w, res[v].second};
                    q.insert({ res[u].first, u });
                }
            }
        }
    }
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    int s, t, l;
    cin >> s >> t >> l;
    --s; --t;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        g[u].push_back({ v, w });
        g[v].push_back({ u, w });
    }
    auto d1 = djk(s, g);
    auto d2 = djk(t, g);
    int ans = 0;
    if (l == d1[t].first) {
        cout << d1[t].second << endl;
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        if (i != t) {
            for (auto [u, w]: g[i]) {
                if (d1[i].first + w + d2[u].first == l && d1[t].first == d1[i].first + d2[i].first) {
                    ans += d1[i].second * d2[u].second;
                }
            }
        }
    }
    cout << ans;
}