#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>
using namespace std;

#define int long long

int32_t main()
{
	int n, B, C;
	cin >> n >> B >> C;

	vector<pair<int, int>> vec(n);
	for (auto& i : vec) {
		cin >> i.first >> i.second;
	}

	vec.push_back({ 2e9 + 1329, 0 });

	deque<pair<int, int>> dq = { {C, vec[0].second} };
	int ans = 0;
	for (int i = 1; i <= n; i++) {
		int cur = 0;
		int dist = vec[i].first - vec[i - 1].first;
		while (true) {
			if (dq.empty()) {
				cout << vec[i - 1].first + cur << endl;
				return 0;
			}
			
			int tmp = min(dq.front().first, dist - cur) * dq.front().second;
			if (tmp <= B) {
				B -= tmp;
				cur += min(dq.front().first, dist - cur);
				if (min(dq.front().first, dist - cur) == dq.front().first) dq.pop_front();
				else dq.front().first -= tmp / dq.front().second;
			}
			else {
				cout << vec[i - 1].first + cur + B / dq.front().second << endl;
				exit(0);
			}

			if (cur == dist) break;
		}

		int tmp = 0;
		while (!dq.empty() && dq.back().second > vec[i].second) {
			tmp += dq.back().first;
			dq.pop_back();
		}
		
		dq.push_back({ dist + tmp, vec[i].second});
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
/*
5 100 4
0 4
2 2
5 3
7 5
12 1

*/