#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <set>
#include <vector>

int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int n, q;
	std::cin >> n >> q;
	std::vector<int> input(n);
	for (auto& i : input) {
		std::cin >> i;
	}
	input.push_back(-1);
	input.push_back(1.1e9);
	std::sort(input.begin(), input.end());
	n = input.size();
	std::vector<int> dist(n -1);
	for (int i = 0; i < n - 1; i++) {
		dist[i] = input[i + 1] - input[i] - 1;
	}
	std::vector<int> prf(n);
	std::partial_sum(dist.begin(), dist.end(), prf.begin() + 1);

	for (int t = 0; t < q; t++) {
		int k;
		std::cin >> k;
		k--;
		int it = std::lower_bound(prf.begin(), prf.end(), k + 1) - prf.begin();
		it--;
		k -= prf[it];
		std::cout << input[it] + 1 + k << " \n"[t == q - 1];
	}

	return 0;
}

/*
4 10
1 2 6 7
1 2 3 4 5 6 7 8 10 11


*/