#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2")
#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <set>
#include <vector>
#include <queue>
#include <array>

#define int uint64_t
#define int64_t uint64_t

constexpr int mod = 1e9 + 7;

int mul(int a, int b) {
	return a * 1ULL * b % mod;
}
int add(int a, int b) {
	return a + b - mod * (a + b >= mod);
}

constexpr int N = 405;
using namespace std;
//typedef int64_t ll;
//const ll MOD = 1e9 + 7;*/

int dp[N][N];
int cnt[N][N];

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n, m; cin >> n >> m;
	//vector<vector<int>> dp(n + 1, vector<int>(m + 1, 0));

	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			int64_t cur_ans = 0;
			int64_t cur_cnt = 1;

			for (int ni = 1; ni +2<= i ; ++ni) {
				for (int nj = 1; nj+2 <= j; ++nj) {
					//curans += ((((ll)(dp[ni][nj] + i * j) * (i - ni - 1)) % MOD) * (j - nj - 1) % MOD);
					//curans %= MOD;
					cur_cnt += cnt[ni][nj] * 1ULL * (i - ni - 1) * (j - nj - 1);
					cur_ans += dp[ni][nj] * 1ULL * (i - ni - 1) * (j - nj - 1);
				}
				cur_ans %= mod;
				cur_cnt %= mod;
			}
			cur_ans = add(cur_ans, mul(cur_cnt, i * j));
			cnt[i][j] = cur_cnt;
			dp[i][j] = cur_ans;
		}
	}
	cout << dp[n][m] << "\n";
	return 0;
}
