#include <iostream>
#include <vector>

using namespace std;
int main() {
    int n, q; cin >> n >> q;
    vector<int> as(n);
    for (int i = 0; i < n; i++) {
        cin >> as[i];
    }
    as.push_back(as.back() + 1e9 + 7);
    vector<int> seg_lengths;
    int cur = -1;
    for (int i = 0; i < n + 1; i++) {
        seg_lengths.push_back(as[i] - cur - 1);
        cur = as[i];
    }
    vector<int> pref_sums(n + 2);
    pref_sums[0] = 0;
    for (int i = 0; i < n + 1; i++) {
        pref_sums[i + 1] = pref_sums[i] + seg_lengths[i];
    }
    while (q--) {
        int k; cin >> k;
        int idx = lower_bound(pref_sums.begin(), pref_sums.end(), k) - pref_sums.begin();
        cout << as[idx - 1] - (pref_sums[idx] - k + 1) << ' ';
    }
    cout << endl;
}
