//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,abm,popcnt,mmx")
#include<bits/stdc++.h>

#define girlfriend friend
//#define int int_fast64_t
#define input(a) for (auto &_ : a) cin >> _;
#define print(a) for (auto _ : a) {cout << _ << " ";} cout << '\n';

using namespace std;

typedef long long ll;
//typedef int_fast64_t ll;

constexpr ll INF32 = 2'000'000'000, INF64 = 4'000'000'000'000'000'000, MOD = 1'000'000'007;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

template<typename T>
bool assign_min(T& a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
T square(T a) {
    return a * a;
}

struct segment_tree {
    vector<pair<ll, ll>> tree;
    ll size;
    segment_tree(vector<ll> arr) {
        size = 1;
        while (size < arr.size()) {
            size *= 2;
        }
        tree.resize(size * 2, make_pair(INF32, INF32));
        arr.resize(size, 0);
        build(1, 0, size, arr);
    }
    void build(ll v, ll l, ll r, vector<ll>& arr) {
        if (r - l == 1) {
            tree[v] = make_pair(arr[l], l);
            return;
        }
        ll mid = (l + r) / 2;
        build(v * 2, l, mid, arr);
        build(v * 2 + 1, mid, r, arr);
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }
    pair<ll, ll> get(ll l, ll r) {
        return get(1, 0, size, l, r);
    }
    pair<ll, ll> get(ll v, ll l, ll r, ll ql, ll qr) {
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        if (l >= qr || r <= ql) {
            return make_pair(INF32, INF32);
        }
        ll mid = (l + r) / 2;
        return min(get(v * 2, l, mid, ql, qr), get(v * 2 + 1, mid, r, ql, qr));
    }
};

struct act {
    int pos, len, ind;

    act() = default;

    act(int a, int b, int c) : pos(a), len(b), ind(c) {}
};

bool cmp(act &a, act &b) {
    if (a.pos == b.pos) return a.len < b.len;
    return a.pos < b.pos;
}
int n, m;
vector<int> dx = {0, 0, -1, 1}, dy{-1, 1, 0, 0};

void dfs1(int ux, int uy, vector<vector<int>> &a, vector<vector<int>> &usd) {
    usd[ux][uy] = 1;
    for (int k = 0; k<4; ++k) {
        int vx = ux+dx[k], vy = uy+dy[k];
        if (vx < 0 || vx >= n || vy < 0 || vy >= m) continue;
        if (!usd[vx][vy] && !a[vx][vy]) dfs1(vx, vy, a, usd);
    }
}

void solve() {
    ll n;
    cin >> n;
    vector<tuple<ll, ll, ll>> t(n);
    for (auto&[a, b, c] : t) {
        cin >> a >> b >> c;
    }
    map<tuple<ll, ll, ll, ll>, ll> m;
    map<tuple<ll, ll, ll, ll, ll>, ll> m2;
    vector<tuple<ll, ll, ll, ll, ll, ll>> all;
    for (ll i = 0; i < n; i++) {
        auto[a, b, c] = t[i];
        for (ll j = 0; j < i; j++) {
            auto [aa, bb, cc] = t[j];
            for (ll _ = 0; _ < 3; _++) {
                swap(aa, bb);
                swap(bb, cc);
                if (aa == a) {
                    ll sum1 = 0, sum2 = 0;
                    for (ll _ = 0; _ < 2; _++) {
                        //swap(bb, cc);
                        for (ll _ = 0; _ < 2; _++) {
                            //swap(b, c);
                            for (ll _ = 0; _ < 4; _++) {
                                swap(b, c);
                                swap(c, bb);
                                swap(bb, cc);
                                sum1 += m[make_tuple(b, c, bb, cc)];
                                sum2 += m2[make_tuple(b, c, bb, cc, j)];
                            }
                        }
                    }
                    if (sum1 != sum2) {
                        cout << "Yes\n";
                        for (ll _ = 0; _ < 2; _++) {
                            //swap(bb, cc);
                            for (ll _ = 0; _ < 2; _++) {
                                //swap(b, c);
                                for (ll _ = 0; _ < 4; _++) {
                                    swap(b, c);
                                    swap(c, bb);
                                    swap(bb, cc);
                                    for (auto[aaa, bbb, ccc, ddd, ans1, ans2] : all) {
                                        if (aaa == b && bbb == c && ccc == bb && ddd == cc && i != ans1 && i != ans2 && j != ans1 && j != ans2) {
                                            cout << i + 1 << ' ' << j + 1 << ' ' << ans1 + 1 << ' ' << ans2 + 1 << '\n';
                                            return;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        for (ll j = 0; j < i; j++) {
            auto[aa, bb, cc] = t[j];
            for (ll _ = 0; _ < 3; _++) {
                swap(aa, bb);
                swap(bb, cc);
                if (aa == a) {
                    m[make_tuple(b, c, bb, cc)]++;
                    m2[make_tuple(b, c, bb, cc, i)]++;
                    m2[make_tuple(b, c, bb, cc, j)]++;
                    all.emplace_back(make_tuple(b, c, bb, cc, i, j));
                }
            }
        }
    }
    cout << "No\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    if (1) {
        ll t = 1;
        if (0) {
            cin >> t;
        }
        for (ll _ = 0; _ < t; _++) {
            solve();
        }
    } else {
        while (true) {
        }
    }
}