//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,abm,popcnt,mmx")
#include<bits/stdc++.h>

#define girlfriend friend
//#define int int_fast64_t
#define input(a) for (auto &_ : a) cin >> _;
#define print(a) for (auto _ : a) {cout << _ << " ";} cout << '\n';

using namespace std;

typedef long long ll;
//typedef int_fast64_t ll;

constexpr ll INF32 = 2'000'000'000, INF64 = 4'000'000'000'000'000'000, MOD = 1'000'000'007;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

template<typename T>
bool assign_min(T& a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T& a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
T square(T a) {
    return a * a;
}

struct segment_tree {
    vector<pair<ll, ll>> tree;
    ll size;
    segment_tree(vector<ll> arr) {
        size = 1;
        while (size < arr.size()) {
            size *= 2;
        }
        tree.resize(size * 2, make_pair(INF32, INF32));
        arr.resize(size, 0);
        build(1, 0, size, arr);
    }
    void build(ll v, ll l, ll r, vector<ll>& arr) {
        if (r - l == 1) {
            tree[v] = make_pair(arr[l], l);
            return;
        }
        ll mid = (l + r) / 2;
        build(v * 2, l, mid, arr);
        build(v * 2 + 1, mid, r, arr);
        tree[v] = min(tree[v * 2], tree[v * 2 + 1]);
    }
    pair<ll, ll> get(ll l, ll r) {
        return get(1, 0, size, l, r);
    }
    pair<ll, ll> get(ll v, ll l, ll r, ll ql, ll qr) {
        if (ql <= l && r <= qr) {
            return tree[v];
        }
        if (l >= qr || r <= ql) {
            return make_pair(INF32, INF32);
        }
        ll mid = (l + r) / 2;
        return min(get(v * 2, l, mid, ql, qr), get(v * 2 + 1, mid, r, ql, qr));
    }
};

void solve() {
    ll n;
    cin >> n;
    map<ll, ll> q1, q2;
    cout << (n + 1) / 2 << endl;
    for (ll i = 0; i < n; i++) {
        cout << i / 2 + 1 << ' ';
    }
    cout << endl;
    for (ll i = 0; i < (n + 1) / 2; i++) {
        ll col;
        cin >> col;
        if (col == 1) {
            ll _;
            cin >> _;
        } else {
            ll a, b;
            cin >> a >> b;
            q1[a] = b;
            q1[b] = a;
        }
    }
    cout << (n + 2) / 2 << endl;
    cout << 1 << ' ';
    for (ll i = 1; i < n; i++) {
        cout << (i + 1) / 2 + 1 << ' ';
    }
    cout << endl;
    for (ll i = 0; i < (n + 2) / 2; i++) {
        ll col;
        cin >> col;
        if (col == 1) {
            ll _;
            cin >> _;
        } else {
            ll a, b;
            cin >> a >> b;
            q2[a] = b;
            q2[b] = a;
        }
    }
    cout << 2 << endl;
    cout << 1 << ' ';
    for (ll i = 1; i < n; i++) {
        cout << 2 << ' ';
    }
    cout << endl;
    ll nz = 0;
    for (ll i = 0; i < 2; i++) {
        ll col;
        cin >> col;
        if (col != 1) {
            ll _;
            for (ll k = 0; k < col; k++) {
                cin >> _;
            }
        } else {
            ll a;
            cin >> a;
            nz = a;
        }
    }
    cout << nz << ' ';
    for (ll i = 1; i < n; i++) {
        if (i % 2) {
            nz = q1[nz];
        } else {
            nz = q2[nz];
        }
        cout << nz << ' ';
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    if (1) {
        ll t = 1;
        if (0) {
            cin >> t;
        }
        for (ll _ = 0; _ < t; _++) {
            solve();
        }
    } else {
        while (true) {
        }
    }
}
