#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;
#define all(a) a.begin(), a.end()
#define ll long long

int main() {
    int n, q;
    cin >> n >> q;
    vector <ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    a.push_back(-1); ++n;
    sort(all(a));
    vector <ll> b(n - 1, 0), p(n - 1, 0);
    for (int i = 0; i < n; ++i) {
        b[i] = a[i + 1] - a[i] - 1;
    }
    p[0] = b[0];
    for (int i = 1; i < n - 1; ++i) {
        p[i] = p[i - 1] + b[i];
    }
    while (q--) {
        ll k; cin >> k;
        auto t = lower_bound(all(p), k);
        if (t == p.end()) {
            cout << k + n - 2 << ' ';
        }
        else {
            ll ind = t - p.begin();
            cout << k + ind - 1 << ' ';
        }
    }
    cout << endl;
}
