//
// Created by orspc on 05.12.2022.
//

// 1 1 1 1 1 1 1 1 1 1
// 1 2 4 7 11 16 22 29 37 46
// 1 4 10 19 31 46 64 85 109 136
// 1 7 19 38 66 106 162 239 343 481
// 1 11 31 66 126 226 386 631 991 1501
// 1 16 46 106 226 452 848 1499 2515 4036
// 1 22 64 162 386 848 1716 3235 5755 9766
// 1 29 85 239 631 1499 3235 6470 12190 21886
// 1 37 109 343 991 2515 5755 12190 24310 46126
// 1 46 136 481 1501 4036 9766 21886 46126 92252
//
// 1 2 3 4 5 6 7 8 9 10 11
// 2 4 6 8 10 12 14 16 18 20 22
// 3 6 19 52 115 218 371 584 867 1230 1683
// 4 8 52 176 420 824 1428 2272 3396 4840 6644
// 5 10 115 420 1060 2240 4270 7600 12855 20870 32725
// 6 12 218 824 2240 5296 11452 23008 43314 76980 130086
// 7 14 371 1428 4270 11452 27818 61488 125097 237370 425117
// 8 16 584 2272 7600 23008 61488 146560 318264 641840 1219768
// 9 18 867 3396 12855 43314 125097 318264 735330 1576740 3183114
// 10 20 1230 4840 20870 76980 237370 641840 1576740 3592840 7690100
// 11 22 1683 6644 32725 130086 425117 1219768 3183114 7690100 17389922
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define rep(i, a, b) for(int i = (a); i < (b); i++)

using namespace std;

const int SIZE = 417;

ll f[SIZE][SIZE];
ll g[SIZE][SIZE];
ll MOD = 1000000007;

ll preff[SIZE][SIZE], prefg[SIZE][SIZE];
ll preff2[SIZE][SIZE], prefg2[SIZE][SIZE];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;

    for (ll x = 1; x < SIZE; x++) {
        for (ll y = 1; y < SIZE; y++) {

            f[x][y] = 1;

            if (x >= 3 && y >= 3) {
                f[x][y] += -x * preff[x - 2][y - 2];
                f[x][y] = (f[x][y] + MOD * 10000) % MOD;

                f[x][y] += -y * preff[x - 2][y - 2];
                f[x][y] = (f[x][y] + MOD * 10000) % MOD;

                f[x][y] += x * y * preff[x - 2][y - 2];
                f[x][y] = (f[x][y] + MOD * 10000) % MOD;

                f[x][y] += preff[x - 2][y - 2];
                f[x][y] = (f[x][y] + MOD * 10000) % MOD;

                f[x][y] += preff2[x - 2][y - 2];
                f[x][y] = (f[x][y] + MOD * 10000) % MOD;

                f[x][y] = (f[x][y] + MOD * 10000) % MOD;
                if (f[x][y] < 0) {
                    cout << f[x][y] << endl;
                    return 0;
                }

                ll s1 = 0;
                for (ll x1 = 1; x1 < x - 1; x1++) {
                    s1 += x1 * (preff[x1][y - 2] - preff[x1 - 1][y - 2] + MOD);

                }
                s1 %= MOD;
                f[x][y] += s1 * (1 - y + MOD);
                f[x][y] = (f[x][y] + MOD * 10000) % MOD;

                ll s2 = 0;
                for (ll y1 = 1; y1 < y - 1; y1++) {
                    s2 += y1 * (preff[x - 2][y1] - preff[x - 2][y1 - 1] + MOD);

                }
                s2 %= MOD;
                f[x][y] += s2 * (1 - x + MOD);
                f[x][y] = (f[x][y] + MOD * 10000) % MOD;
            }



            g[x][y] = x * y;


            if (x >= 3 && y >= 3) {
                g[x][y] = 1;
                g[x][y] += -x * preff[x - 2][y - 2];
                g[x][y] = (g[x][y] + MOD * 10000) % MOD;
                g[x][y] += -y * preff[x - 2][y - 2];
                g[x][y] = (g[x][y] + MOD * 10000) % MOD;
                g[x][y] += x * y * preff[x - 2][y - 2];
                g[x][y] = (g[x][y] + MOD * 10000) % MOD;
                g[x][y] += preff[x - 2][y - 2];
                g[x][y] = (g[x][y] + MOD * 10000) % MOD;
                g[x][y] += preff2[x - 2][y - 2];
                g[x][y] = (g[x][y] + MOD * 10000) % MOD;
                g[x][y] = g[x][y] % MOD;

                ll s1 = 0;
                for (ll x1 = 1; x1 < x - 1; x1++) {
                    s1 += x1 * (preff[x1][y - 2] - preff[x1 - 1][y - 2] + MOD);

                }
                s1 %= MOD;
                g[x][y] += s1 * (1 - y + MOD);
                g[x][y] = g[x][y] % MOD;

                ll s2 = 0;
                for (ll y1 = 1; y1 < y - 1; y1++) {
                    s2 += y1 * (preff[x - 2][y1] - preff[x - 2][y1 - 1] + MOD);

                }
                s2 %= MOD;
                g[x][y] += s2 * (1 - x + MOD);
                g[x][y] = g[x][y] % MOD;

                g[x][y] *= x * y;
                g[x][y] = g[x][y] % MOD;



                g[x][y] += -x * prefg[x - 2][y - 2];
                g[x][y] = (g[x][y] + MOD * 10000) % MOD;
                g[x][y] += -y * prefg[x - 2][y - 2];
                g[x][y] = (g[x][y] + MOD * 10000) % MOD;
                g[x][y] += x * y * prefg[x - 2][y - 2];
                g[x][y] += prefg[x - 2][y - 2];
                g[x][y] = (g[x][y] + MOD * 10000) % MOD;
                g[x][y] += prefg2[x - 2][y - 2];
                g[x][y] = (g[x][y] + MOD * 10000) % MOD;

                s1 = 0;
                for (ll x1 = 1; x1 < x - 1; x1++) {
                    s1 += x1 * (prefg[x1][y - 2] - prefg[x1 - 1][y - 2] + MOD);

                }
                s1 %= MOD;
                g[x][y] += s1 * (1 - y + MOD);
                g[x][y] = g[x][y] % MOD;

                s2 = 0;
                for (ll y1 = 1; y1 < y - 1; y1++) {
                    s2 += y1 * (prefg[x - 2][y1] - prefg[x - 2][y1 - 1] + MOD);

                }
                s2 %= MOD;
                g[x][y] += s2 * (1 - x + MOD);
                g[x][y] = (g[x][y] + MOD * 10000) % MOD;
            }



            preff[x][y] = (preff[x][y - 1] + preff[x - 1][y] - preff[x - 1][y - 1] + f[x][y] + 10000 * MOD) % MOD;
            prefg[x][y] = (prefg[x][y - 1] + prefg[x - 1][y] - prefg[x - 1][y - 1] + g[x][y] + 10000 * MOD) % MOD;
            preff2[x][y] =( preff2[x][y - 1] + preff2[x - 1][y] - preff2[x - 1][y - 1] + f[x][y] * x * y + 10000 * MOD) % MOD;
            prefg2[x][y] =( prefg2[x][y - 1] + prefg2[x - 1][y] - prefg2[x - 1][y - 1] + g[x][y] * x * y + 10000 * MOD) % MOD;
        }
    }
    cout << g[n][m] << endl;
    return 0;
}