#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define flt double

const flt eps = 1e-8;


struct dat{
    int l;
    int r;
    int i;
    int j;

    dat() {}
    dat(int l, int r, int i, int j) : l(l), r(r), i(i), j(j) {}
    dat(int l) : l(l) {}
};


bool operator<(const dat& d1, const dat& d2){
    return d1.l < d2.l;
}


flt get_h(int a, int b, int c){
    flt p = (flt)(a + b + c) / 2;
    flt s = sqrt(p * (p - a) * (p - b) * (p - c));
    return s * 2 / a;
}


flt get_ang(int a, int b, int c){
    return (a * a + b * b - c * c) / (flt)(2 * a * b);
}


flt get_d(int a, int b, int c){
    flt cs = get_ang(a, b, c);
    return b * cs;
}


bool biba(set<dat> &a, int ln, int i, int j){
    auto it = a.upper_bound(dat(ln));
    if(it == a.begin()){
        return false;
    }
    --it;
    if(it->r >= ln){
        cout << "Yes" << "\n";
        cout << i + 1 << " " << j + 1 << " " << it->i + 1 << " " << it->j + 1 << "\n";
        return true;
    }
    return false;
}



signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector <vector <int>> a(n);
    for (int i = 0; i < n; ++i) {
        a[i].resize(3);
        for (int j = 0; j < 3; ++j) cin >> a[i][j];
        sort(a[i].begin(), a[i].end());
    }
    map <array <int, 4>, set<dat>> d;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            for (int k = 0; k < 3; ++k) {
                vector <int> flex;
                int ln = a[i][k];
                for (int num = 0; num < 3; ++num) {
                    if (num == k) continue;
                    flex.push_back(a[i][num]);
                }
                bool ok = false;
                for (int num = 0; num < 3; ++num) {
                    if (!ok && a[j][num] == a[i][k]) {
                        ok = true;
                        continue;
                    }
                    flex.push_back(a[j][num]);
                }



                if ((int)flex.size() == 5) continue;
                for (int zalupa_slonika = 0; zalupa_slonika < 2; ++zalupa_slonika) {
                    for (int zalupa_gnomika = 0; zalupa_gnomika < 2; ++zalupa_gnomika) {
                        if (d.count({flex[1], flex[2], flex[3], flex[0]})) {
                            array <int, 4> xd = {flex[1], flex[2], flex[3], flex[0]};
                            if(biba(d[xd], ln, i, j)){
                                return 0;
                            }
                        }
                        if (d.count({flex[3], flex[0], flex[1], flex[2]})) {
                            array <int, 4> xd = {flex[3], flex[0], flex[1], flex[2]};
                            if(biba(d[xd], ln, i, j)){
                                return 0;
                            }
                        }
                        swap(flex[2], flex[3]);
                    }
                    swap(flex[0], flex[1]);
                }
            }
        }
        for (int j = 0; j < i; ++j) {
            for (int k = 0; k < 3; ++k) {
                vector <int> flex;
                for (int num = 0; num < 3; ++num) {
                    if (num == k) continue;
                    flex.push_back(a[i][num]);
                }
                bool ok = false;
                for (int num = 0; num < 3; ++num) {
                    if (!ok && a[j][num] == a[i][k]) {
                        ok = true;
                        continue;
                    }
                    flex.push_back(a[j][num]);
                }
                if ((int)flex.size() == 5) continue;
                int ln = a[i][k];
                flt _h1 = get_h(ln, flex[0], flex[1]);
                flt _h2 = get_h(ln, flex[2], flex[3]);
                for(int zalupa_bobra = 0; zalupa_bobra < 1; zalupa_bobra += 1){
                    flt h1 = _h1;
                    flt h2 = _h2;
                    flt d1 = get_d(ln, flex[0], flex[1]);
                    flt d2 = get_d(ln, flex[3], flex[2]);
                    if(h1 < h2){
                        swap(h1, h2);
                        swap(d1, d2);
                    }
                    flt mn_d = sqrt((h2 - h1) * (h2 - h1) + (d2 - d1) * (d2 - d1));
                    flt mx_d = sqrt((h2 + h1) * (h2 + h1) + (d2 - d1) * (d2 - d1));
                    int ml = floor(mn_d + 1);
                    int mr = ceil(mx_d - 1);

                    auto &mst = d[{flex[0], flex[1], flex[2], flex[3]}];
                    auto it = mst.upper_bound(dat(ml));
                    if(it == mst.begin() || prev(it)->r < mr){
                        while(it != mst.end() && it->r <= mr){
                            auto nit = next(it);
                            mst.erase(it);
                            it = nit;
                        }
                        mst.emplace(ml, mr, i, j);
                    }
                    swap(flex[0], flex[1]);
                }

            }
        }
    }
    cout << "No";
    return 0;
}

/*
4

3 4 5

3 4 3
3 3 5

3 5 5
 */