#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 2e9 + 1;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(a.begin(), a.end());

    vector<int> pref_max(n, 0), pref_min(n, INF);
    for (int i = 0; i < n - i - 1; ++i) {
        pref_max[i + 1] = max(pref_max[i], a[i] + a[n - i - 1]);
        pref_min[i + 1] = min(pref_min[i], a[i] + a[n - i - 1]);
    }

    int res = pref_max[n / 2] - pref_min[n / 2];

    int curr_max = a[n / 2] + a[n / 2 - 1];
    int curr_min = a[n / 2] + a[n / 2 - 1];
    for (int i = n / 2 + 1; i < n; ++i) {
        int curr_res = max(pref_max[n - i - 1], curr_max) - min(pref_min[n - i - 1], curr_min);
        res = min(res, curr_res);
        if (i != n - 1) {
            curr_max = max(curr_max, a[i] + a[n - i - 2]);
            curr_min = min(curr_min, a[i] + a[n - i - 2]);
        }
    }

    curr_max = a[n / 2 + 1] + a[n / 2];
    curr_min = a[n / 2 + 1] + a[n / 2];
    for (int i = n / 2 - 1; i >= 0; --i) {
        int curr_res = max(pref_max[i], curr_max) - min(pref_min[i], curr_min);
        res = min(res, curr_res);
        if (i != 0) {
            curr_max = max(curr_max, a[i] + a[n - i]);
            curr_min = min(curr_min, a[i] + a[n - i]);
        }
    }

    cout << res << '\n';
}

int32_t main() {
#ifdef DDD
    freopen("../input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    solve();
}