#include <bits/stdc++.h>

#define int long long

using namespace std;

void solve() {
    int n, b, c;
    cin >> n >> b >> c;
    vector<int> x(n), p(n);
    for (int i = 0; i < n; i++) cin >> x[i] >> p[i];
    vector<int> nearest_less(n, -1);
    vector<int> st;
    for (int i = n - 1; i >= 0; i--) {
        while (!st.empty() && st.back() > p[i]) {
            st.pop_back();
        }
        if (!st.empty()) nearest_less[i] = st.back();
        st.push_back(p[i]);
    }

    set<pair<int, int>> nums;
    int r = 1;
    vector<int> min_c(n, -1);
    for (int l = 0; l < n; l++) {
        nums.erase({l, p[l]});
        while (r < n && x[r] - x[l] <= c) {
            nums.insert({p[r], r});
            r++;
        }
        if (!nums.empty()) {
            min_c[l] = (*nums.begin()).second;
        }
    }

    int cur = 0, bought = 0;
    while (true) {
        if (min_c[cur] == -1) {
            cout << x[cur] + min(c, bought + (b / p[cur])) << "\n";
            exit(0);
        }
        if (nearest_less[cur] != -1 && x[nearest_less[cur]] - x[cur] <= c) {
            int dist = x[nearest_less[cur]] - x[cur];
            if (b < (dist - bought) * p[cur]) {
                cout << x[cur] + bought + b / p[cur] << "\n";
                exit(0);
            } else {
                b -= (dist - bought) * p[cur];
                bought = 0;
                cur = nearest_less[cur];
            }
        } else {
            int dist = x[min_c[cur]] - x[cur];
            if (b < (c - bought) * p[cur]) {
                cout << x[cur] + bought + b / p[cur] << "\n";
                exit(0);
            } else {
                b -= (c - bought) * p[cur];
                bought = c - dist;
                cur = min_c[cur];
            }
        }
    }
}

int32_t main() {
#ifdef DDD
    freopen("../input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif

    solve();
}