#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
template<typename A, typename B>
string to_string(pair<A, B> p);


string to_string(string s){
    return '"' + s + '"';
}

string to_string(const char *s){
    return to_string((string)s);
}

string to_string(bool a){
    return (a ? "true" : "false");
}

template<typename A, typename B>
string to_string(pair<A, B> p){
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

template<typename A>
string to_string(A v){
    bool f = 1;
    string res = "{";
    for(auto x : v){
        if (!f) res += ", ";
        res += to_string(x);
        f = 0;
    }
    res += "}";
    return res;
}

void debug_out(){
    cerr << endl;
}
template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T){
    cerr << " " << to_string(H);
    debug_out(T...);
}
#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

#define sz(a)(ll)(a).size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pikachu push_back
#define pll pair<ll, ll>
#define pii pair<int, int>
typedef long long ll;
typedef long double ld;


void run();
signed main() {
#ifdef LOCAL
    freopen("file.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    run();
}
vector<pll> d = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
void run(){
   ll n, m;
   cin >> n >> m;
   auto check = [&](ll x, ll y){
       return x >= 0 && y >= 0 && x < n && y < m;
   };
   vector<string> f(n);
   for(auto& e: f) cin >> e;
   deque<pll> bfs;
   vector<vector<char>> used(n, vector<char>(m, 0));
   for(ll j = 0; j < m; ++j){
       if (f[0][j] != '#'){
           bfs.pikachu({0, j});
           used[0][j] = 1;
       }
       if (f[n - 1][j] != '#'){
           bfs.pikachu({n- 1, j});
           used[n - 1][j] = 1;
       }
   }
   for(ll i = 0; i < n; ++i){
       if (f[i][0] != '#'){
           bfs.pikachu({i, 0});
           used[i][0] = 1;
       }
       if (f[i][m - 1] != '#'){
           bfs.pikachu({i, m - 1});
           used[i][m - 1] = 1;
       }
   }
    while(sz(bfs)){
        auto[x, y] = bfs.front();
        bfs.pop_front();
        for(auto[dx, dy] : d){
            ll nx = x + dx, ny = y + dy;
            if (!check(nx, ny)) continue;
            if (used[nx][ny] || f[nx][ny] == '#') continue;
            bfs.pikachu({nx, ny});
            used[nx][ny] = 1;
        }
    }
    ll mi = 1e6, miY;
    for(ll i = 0; i < n; ++i){
        for(ll j = 0; j < m; ++j){
            if (used[i][j] || f[i][j] == '#') continue;
            if (mi > i){
                mi = i;
                miY = j;
            }
        }
    }
    //debug(mi, miY);
    --mi;
    bfs.pikachu({mi, miY - 1});
    vector<vector<int>> dist(n, vector<int>(m, -1));
    vector<vector<pii>> pred(n, vector<pii>(m, {-1, -1}));
    dist[mi][miY - 1] = 0;
    while(sz(bfs)){
        auto[x, y] = bfs.front();
        bfs.pop_front();
        for(auto[dx, dy] : d){
            ll nx = x + dx, ny = y + dy;
            if (!check(nx, ny) || f[nx][ny] == '.') continue;
            if (dist[nx][ny] != -1) continue;
            if (ny == miY && nx <= mi) continue;
            dist[nx][ny] = dist[x][y] + 1;
            bfs.pikachu({nx, ny});
            pred[nx][ny] = {x, y};
        }
    }
    vector<vector<char>> ans(n, vector<char>(m, '.'));
    ans[mi][miY] = '#';
    ll x = mi, y = miY + 1;
    while(x != -1){
        ans[x][y] = '#';
        auto[a, b] = pred[x][y];
        x = a, y = b;
    }
    for(auto s: ans){
        for(auto e: s) cout << e;
        cout << '\n';
    }
}
