#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
typedef long long ll;
#define int long long

int n;
int a[500010];
multiset <int> s;
int ans;
int to[500010];

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
	}
	sort(a, a + n);

	for (int i = 1, j = n - 1; i < j; ++i, --j)
	{
		s.insert(a[i] + a[j]);
		to[i] = j;
		to[j] = i;
	}
	ans = *s.rbegin() - *s.begin();
	
	for (int i = 1; i < n; ++i)
	{
		int x = to[i];
		s.erase(s.find(a[i] + a[x]));
		to[x] = i - 1;
		to[i - 1] = x;
		s.insert(a[x] + a[i - 1]);
		ans = min(ans, *s.rbegin() - *s.begin());
	}

	cout << ans;

	return 0;
}