#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,fma,sse2,sse3,ssse3,sse4,sse4.1,lzcnt,popcnt,bmi,bmi2")

#include <iostream>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
using namespace std;

typedef unsigned long long ll;
typedef vector<ll> vi;

typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


signed main() {
    ll n, b, c; cin >> n >> b >> c;
    vector<pair<ll, ll> > v;

    ll x, p;

    for (ll i = 0; i < n; ++i){
        cin >> x >> p;
        v.push_back({x, p});
    }

    sort(v.begin(), v.end());

    vector<pair<ll, pair<ll, ll> > > s;
    vector<ll> k(n, LONG_LONG_MAX);

    for (ll i = 0; i < n; ++i){
        while (!s.empty() && s.back().second.second > v[i].second){
            pair<ll, pair<ll, ll> > tmp = s.back();
            s.pop_back();
            k[tmp.first] = v[i].first - v[tmp.first].first;
        }
        s.push_back({i, v[i]});
    }
    /*
    for (auto elem : k) cout << elem << " ";
    cout << endl;
     */
    ll ans = 0, l = 0, pr = 0;

    for (ll i = 0; i < n; ++i){
        if (i != 0 && l < v[i].first - pr){
            break;
        }

        l -= v[i].first - pr;
        ans = v[i].first;

        if (k[i] == LONG_LONG_MAX){
            ll km = min(b/v[i].second, c - l);
            l += km;
            b -= km*v[i].second;
            pr = v[i].first;
            continue;
        }

        ll km = min(b/v[i].second, min(k[i], c - l));
        l += km;
        b -= km*v[i].second;
        pr = v[i].first;
    }

    ans += l;
    cout << ans;
    return 0;
}