#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,fma,sse2,sse3,ssse3,sse4,sse4.1,lzcnt,popcnt,bmi,bmi2")

#include <iostream>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

typedef long long int ll;

void solve() {
    ll n, q, i, x, y, lb, rb, mid;

    ordered_set t;

    cin >> n >> q;

    for (i = 0; i < n; i++) {
        cin >> x;
        t.insert(x);
    }

    for (i = 0; i < q; i++) {
        cin >> x;

        lb = 0;
        rb = 1000100001;

        while (rb - lb > 1) {
            mid = lb + (rb - lb) / 2;

            if (mid - t.order_of_key(mid) < x) {
                lb = mid;
            } else {
                rb = mid;
            }
        }

        cout << lb << '\n';
    }
}

int main() {
    solve();
    return 0;
}