#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <stdio.h>
#include <queue>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")

#define ll long long
#define ld long double

using namespace std;

// BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
//vector<vector<pair<int, ll>>>adjs;
//vector<ll> getDistances(int n, int u0){
//    vector<ll>distances;
//    for (int i = 0; i < n; ++i) {
//        distances.push_back(1000000000000000);
//    }
//    vector<bool>isProcessed(n);
//    distances[u0] = 0;
//    priority_queue<pair<ll,int>>q;
//    q.push({0, u0});
//    while(!q.empty()){
//        int u = q.top().second;
//        q.pop();
//        if (isProcessed[u])continue;
//        for (auto vw : adjs[u]) {
//            int v = vw.first;
//            ll w = vw.second;
//            distances[v] = min(distances[v], distances[u]+w);
//            q.push({-distances[v], v});
//        }
//        isProcessed[u] = true;
//    }
//    return distances;
//}
//
//void solve(){
//    int n,m;
//    cin>>n>>m;
//    int s,t;
//    ll L;
//    cin>>s>>t>>L;
//    s--;t--;
//    adjs.resize(n);
//    for (int i = 0; i < m; ++i) {
//        int u, v;
//        ll w;
//        cin>>u>>v>>w;
//        u--;v--;
//        adjs[u].push_back({v,w});
//        adjs[v].push_back({u,w});
//    }
//    vector<ll>distancesT = getDistances(n, t);
//    vector<ll>distancesS = getDistances(n, s);
//    ll minL = distancesT[s];
//    if (minL==L){
//        vector<pair<ll,int>>minAdjs;
//        for (int i = 0; i < n; ++i) {
//            if (distancesT[i] + distancesS[i] == minL){
//                minAdjs.push_back({distancesS[i], i});
//            }
//        }
//        sort(minAdjs.begin(), minAdjs.end());
//        vector<ll>dp(n);
//        dp[s] = 1;
//        for (int i = 1; i < minAdjs.size(); ++i) {
//            int u = minAdjs[i].second;
//            for (auto vw : adjs[i]) {
//                int v = vw.first;
//                if (distancesS[v] + distancesT[v] == minL && distancesS[v] < distancesS[u]){
//                    dp[u]= (dp[u] + dp[v])%1000000007;
//                }
//            }
//        }
//        cout<<dp[t];
//        return;
//    }
//    int count = 0;
//    for (int i = 0; i < n; ++i) {
//        if (distancesS[i] + distancesT[i] == minL){
//            for (auto vw : adjs[i]) {
//                int v = vw.first;
//                ll w = vw.second;
//                if (distancesS[i]+w+distancesT[v]==L)count = (count+1)%(1000000007);
//            }
//        }
//    }
//    cout<<count;
//    return;
//}

//void solve() {
//    int n, b, c;
//    cin >> n >> b >> c;
//    vector<int> x(n);
//    vector<int> p(n);
//    for (int i = 0; i < n; i++) {
//        cin >> x[i] >> p[i];
//    }
//}

int inf = 2 * 1e9 + 100;

void solve() {
    int n; cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n ;i++) {
        cin >> a[i];
    }
    vector<vector<int>> v(n / 2 + 1, vector<int>(4));
    for (int i = 1; i <= n / 2; i++) {
        v[i][1] = a[n - i] + a[i];
        v[i][2] = a[n - i] + a[i - 1];
        v[i][3] = a[n - i - 1] + a[i - 1];
    }
    // min, max
    vector<pair<int, int>> t1(n + 1, {inf, -inf});
    vector<pair<int, int>> t2(n + 1, {inf, -inf});
    vector<pair<int, int>> t3(n + 1, {inf, -inf});
    for (int i = n / 2 - 1; i >= 0; i--) {
        t1[i].first = min(t1[i + 1].first, v[i + 1][1]);
        t1[i].second = max(t1[i + 1].second, v[i + 1][1]);
    }
    for (int i = 1; i <= n / 2; i++) {
        t2[i].first = min(t2[i - 1].first, v[i][2]);
        t2[i].second = max(t2[i - 1].second, v[i][2]);
    }
    for (int i = n - 2; i > n / 2; i--) {
        t2[i].first = min(t2[i + 1].first, v[n - i - 1][2]);
        t2[i].second = max(t2[i + 1].second, v[n - i - 1][2]);
    }
    for (int i = n / 2 + 1; i < n; i++) {
        t3[i].first = min(t3[i - 1].first, v[n - i][3]);
        t3[i].second = max(t3[i - 1].second, v[n - i][3]);
    }
    int r = inf;
    for (int i = 0; i < n; i++) {
        int mn = min(min(t1[i].first, t2[i].first), t3[i].first);
        int mx = max(max(t1[i].second, t2[i].second), t3[i].second);
        r = min(r, mx - mn);
    }
    cout << r << '\n';
}

//void solve(){
//    ll h, w;
//    vector<vector<ll>>dp(h);
//    for (int i = 0; i < h; ++i) {
//        dp[h].resize(w);
//    }
//    for (int i = 0; i < 2; ++i) {
//        for (int j = 0; j < w; ++j) {
//            dp[i][j] = (j+1)*(i+1);
//        }
//    }
//    for (int i = 2; i < h; ++i) {
//        dp[i][0] = i+1;
//        dp[i][1] = (i+1)*2;
//        for (int j = 2; j < w; ++j) {
//
//        }
//    }
//}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
