#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>
#include <set>
#include <map>
#include <deque>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
typedef long long ll;
int funcI(vector<ll>a){
    ll n = a.size();
    sort(a.begin(), a.end());
    multiset<int> p;
    for (int i = 1; i <= n / 2; i++) {
        p.insert(a[i] + a[n - i]);
    }
    int ans = (*p.rbegin()) - (*p.begin());
    for (int i = 1; i < n; i++) {
        int prev = 0;
        if (i <= n / 2) prev = a[i] + a[n - i];
        else prev = a[i] + a[n - i - 1];

        p.erase(p.find(prev));
        p.insert(a[i - 1] + a[n - i]);
        ans = min(ans, (*p.rbegin()) - (*p.begin()));
    }
    return ans;
}

ll funcC(vector<ll>a) {
    sort(all(a));
    ll dlt = 1e10;
    for (int i = 0; i < a.size(); i++){
        ll mn = 1e10, mx = 0;
        for (int j = 0; j < a.size() / 2; j++) {
            mn = min(mn, a[j] + a[a.size() - j - 1 - (a.size() - j - 1 <= i)]);
            mx = max(mx, a[j] + a[a.size() - j - 1 - (a.size() - j - 1 <= i)]);
        }
        dlt = min(dlt, mx - mn);
    }

    return dlt;
}

ll rand(ll l, ll r) {
    return rand() % (r - l + 1) + l;
}

vector<vector<pair<ll,ll>>>ejs;
void func(vector<pair<ll,ll>>&p, ll v) {
    set<pair<ll,ll>>dq;
    dq.insert({0, v});
    p[v] = {0, 1};

    while (dq.size())  {
        auto [wt, v] = *dq.begin();
        dq.erase(dq.begin());

        for (auto [ch, w] : ejs[v]) {
            if (p[ch].first > w + wt) {
                dq.erase({p[ch].first, ch});
                dq.insert({w + wt, ch  });
                p[ch]= {w + wt, 0};
            }
            if (p[ch].first == w + wt) p[ch].second += p[v].second;
        }
    }
}

int main(){
    ll q, w;
    cin>>q>>w;
    ll f, t, p;
    cin>>f>>t>>p;
    vector<pair<ll,ll>>dl(q, {2e18, 0}), dr(q, {2e18, 0});
    ejs.resize(q);
    while (w--) {
        ll v, u, w;
        cin >> v >> u >> w;
        ejs[--v].push_back({--u, w});
        ejs[u].push_back({v, w});
    }
    f--, t--;
    func(dl, f);
    func(dr, t);



    ll ans = 0;
    ll mn = dr[f].first;
    for (int l = 0; l < q; l++) {
        for (auto[r, w] : ejs[l]) {
            if (mn == dl[l].first + dr[l].first && dl[l].first + w + dr[r].first == p)
                ans = (ans + (dl[l].second * dr[r].second) % ll(7 + 1e9)) % ll(7 + 1e9);
        }
    }

    cout << ans % ll(1e9 + 7);
}


