#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <fstream>
using namespace std;
#define int long long
#define all(i) i.begin(), i.end()
#define For(i, n) for(int i = 0; i < n; ++i)
#define For3(i, s, n) for(int i = s; i < n; ++i)
#define For4(i, s, n, c) for(int i = s; (i < n) == (c > 0); i += c)
#define pi pair <int,int>

const int inf = 1e9 + 7;
int N = 400;


int n, m;
int s, t, L;
vector <vector <pi>> g;
vector <pi> distS;
vector <pi> distT;


void FF(vector<pi>& vvv, int nv)
{
	vvv[nv] = { 0, 1 };
	set <pi> st;
	st.insert({ 0, nv });
	while (!st.empty()) {
		pi p = *(st.begin());
		int d = p.first;
		int v = p.second;
		st.erase(st.begin());
		for (pi nxt_p : g[v]) {
			int nxt = nxt_p.first;
			int w = nxt_p.second;
			if (d + w < vvv[nxt].first) {
				st.erase({ vvv[nxt].first, nxt });
				vvv[nxt].first = d + w;
				vvv[nxt].second = vvv[v].second;
				st.insert({ vvv[nxt].first, nxt });

			}
			else if (d + w == vvv[nxt].first) {
				vvv[nxt].second += vvv[v].second;
				vvv[nxt].second %= inf;
			}
		}
	}
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> m;
	cin >> s >> t >> L;

	g.resize(n + 1);
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		g[u].push_back({ v, w });
		g[v].push_back({ u, w });
	}

	distS.resize(n + 1, { inf, 0 });
	distT.resize(n + 1, { inf, 0 });

	FF(distS, s);
	FF(distT, t);

	int ANS = 0;

	if (L == distS[t].first) {
		ANS = distS[t].second;
		cout << ANS << endl;
		return 0;
	}
	for (int u = 1; u <= n; ++u) {
		if (u == t) continue;
		for (pi p : g[u]) {
			int v = p.first;
			int w = p.second;
			int T = distS[u].first + w + distT[v].first;
			if (T == L && w + distT[v].first > distT[u].first) {
				ANS += (distS[u].second * distT[v].second) % inf;
				//cout << u << ' ' << v << ' ' << (distS[u].second * distT[v].second)%inf << endl;
				ANS %= inf;
			}
		}
	}
	cout << ANS << endl;
}
