#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <fstream>
using namespace std;
#define int long long
#define all(i) i.begin(), i.end()
#define For(i, n) for(int i = 0; i < n; ++i)
#define For3(i, s, n) for(int i = s; i < n; ++i)
#define For4(i, s, n, c) for(int i = s; (i < n) == (c > 0); i += c)


const int inf = 1e9 + 7;
int N = 400;

int str_to_num(string str) {
	int num = 0;
	for (auto c : str) num = (num * 10) + (c - '0');
	return num;
}

#define UMN(a, b) (((a) * (b)) % inf)

int f(int x) {
	return (x % inf + inf) % inf;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	vector <vector <int>> dp(N + 1, vector<int>(N + 1));
	vector <vector <int>> cnt(N + 1, vector<int>(N + 1));
	vector <vector <int>> ps_cnt(N + 1, vector<int>(N + 1));
	vector <vector <int>> ps_cntH(N + 1, vector<int>(N + 1));
	vector <vector <int>> ps_cntW(N + 1, vector<int>(N + 1));
	vector <vector <int>> ps_cntHW(N + 1, vector<int>(N + 1));
	vector <vector <int>> ps_dp(N + 1, vector<int>(N + 1));
	vector <vector <int>> ps_dpH(N + 1, vector<int>(N + 1));
	vector <vector <int>> ps_dpW(N + 1, vector<int>(N + 1));
	vector <vector <int>> ps_dpHW(N + 1, vector<int>(N + 1));


	int ans_w, ans_h;
	cin >> ans_w >> ans_h;
	for (int H = 1; H <= ans_h; ++H) {
		for (int W = 1; W <= ans_w; ++W) {
			dp[H][W] = W * H;
			cnt[H][W] = 1;
			if (H >= 3 && W >= 3) {
				dp[H][W] += UMN((W-1)*(H-1), ps_dp[H - 2][W - 2]);
				dp[H][W] -= UMN(H - 1, ps_dpW[H - 2][W - 2]);
				dp[H][W] -= UMN((W - 1), ps_dpH[H - 2][W - 2]);
				dp[H][W] += ps_dpHW[H - 2][W - 2];
				cnt[H][W] += UMN((W - 1) * (H - 1),ps_cnt[H - 2][W - 2]);
				cnt[H][W] -= UMN((H - 1),ps_cntW[H - 2][W - 2]);
				cnt[H][W] -= UMN((W - 1),ps_cntH[H - 2][W - 2]);
				cnt[H][W] += ps_cntHW[H - 2][W - 2];
				dp[H][W] += UMN(W * H,(cnt[H][W] - 1));
			}
			ps_cnt[H][W] = ps_cnt[H - 1][W] + ps_cnt[H][W - 1] - ps_cnt[H - 1][W - 1] + cnt[H][W];
			ps_cntH[H][W] = ps_cntH[H - 1][W] + ps_cntH[H][W - 1] - ps_cntH[H - 1][W - 1] + cnt[H][W] * H;
			ps_cntW[H][W] = ps_cntW[H - 1][W] + ps_cntW[H][W - 1] - ps_cntW[H - 1][W - 1] + cnt[H][W] * W;
			ps_cntHW[H][W] = ps_cntHW[H - 1][W] + ps_cntHW[H][W - 1] - ps_cntHW[H - 1][W - 1] + cnt[H][W] * H * W;

			ps_dp[H][W] = ps_dp[H - 1][W] + ps_dp[H][W - 1] - ps_dp[H - 1][W - 1] + dp[H][W];
			ps_dpH[H][W] = ps_dpH[H - 1][W] + ps_dpH[H][W - 1] - ps_dpH[H - 1][W - 1] + dp[H][W] * H;
			ps_dpW[H][W] = ps_dpW[H - 1][W] + ps_dpW[H][W - 1] - ps_dpW[H - 1][W - 1] + dp[H][W] * W;
			ps_dpHW[H][W] = ps_dpHW[H - 1][W] + ps_dpHW[H][W - 1] - ps_dpHW[H - 1][W - 1] + dp[H][W] * H * W;

			dp[H][W] = f(dp[H][W]);
			cnt[H][W] = f(cnt[H][W]);
			ps_cnt[H][W] = f(ps_cnt[H][W]);
			ps_cntH[H][W] = f(ps_cntH[H][W]);
			ps_cntW[H][W] = f(ps_cntW[H][W]);
			ps_cntHW[H][W] = f(ps_cntHW[H][W]);

			ps_dp[H][W] = f(ps_dp[H][W]);
			ps_dpH[H][W] = f(ps_dpH[H][W]);
			ps_dpW[H][W] = f(ps_dpW[H][W]);
			ps_dpHW[H][W] = f(ps_dpHW[H][W]);

			//cout << H << ' ' << W << ' ' << dp[H][W] << endl;
		}
	}
	cout << dp[ans_h][ans_w] << endl;
	return 0;
}
