import collections

h, w = map(int, input().split())
matrix = [input() for i in range(h)]
lake_cells = []
cell = [1, 1]
for row in matrix:
    if '#' in row:
        left = row.find('#')
        right = row.rfind('#')
        lake_cells.append([(row[i] == '.') and (i > left) and (i < right) for i in range(w)])
matrix = [list(i) for i in matrix]
for c in range(w):
    i = 0
    while i < h and matrix[i][c] == '.':
        lake_cells[i][c] = False
        i += 1
    i = h - 1
    while i >= 0 and matrix[i][c] == '.':
        lake_cells[i][c] = False
        i -= 1
    for i in range(h):
        if lake_cells[i][c]:
            cell = [i, c]
            break
    else:
        continue
    break
for i in range(cell[1]):
    matrix[cell[0]][i] = '.'
cell = cell[::-1]
prev = [[tuple([]) for _ in range(w)] for _ in range(h)]
x = collections.deque()
y = collections.deque()
x.append(cell[1] - 1)
y.append(cell[0] - 1)
prev[cell[1] - 1][cell[0] - 1] = (cell[1] - 1, cell[0] - 1)
while x:
    cur_x, cur_y = x.popleft(), y.popleft()
    for new_x, new_y in ((cur_x + 1, cur_y), (cur_x - 1, cur_y), (cur_x, cur_y + 1), (cur_x, cur_y - 1)):
        if (new_x >= 0) and (new_x < h) and (new_y >= 0) and (new_y < w):
            if not prev[new_x][new_y] and matrix[new_x][new_y] == '#':
                prev[new_x][new_y] = (cur_x, cur_y)
                x.append(new_x)
                y.append(new_y)
outp = [['.' for _ in range(w)] for _ in range(h)]
x, y = cell[0] - 1, cell[1] + 1
while prev[y][x] != (y, x):
    outp[y][x] = '#'
    y, x = prev[y][x]
outp[cell[1]][cell[0] - 1], outp[cell[1] - 1][cell[0] - 1] = '#', '#'
print('\n'.join([''.join(i) for i in outp]))
