#include <bits/stdc++.h>
#define int long long
#define ld long double
#define vc vector
#define F first
#define S second
#define pb push_back
#define debug(x) cerr<<(#x)<<": "<<x<<endl;
#define pii pair <int, int>
using namespace std;
const int mod = 1e9 + 7;
int add(int a, int b) {
    if ((a + b) >= mod) {
        return a + b - mod;
    }
    return a + b;
}
int mul(int a, int b) {
    return (a * b) % mod;
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    bool field[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            char c;
            cin >> c;
            if (c == '#') {
                field[i][j] = 1;
            } else {
                field[i][j] = 0;
            }
        }
    }
    vector<vector<bool>> us(n, vector<bool>(m));
    vector<pair<int, int>> zxc;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i == 0 || j == 0 || i == n - 1|| j == m - 1) {
                if (field[i][j] == 0) zxc.push_back({i, j});
            }
        }
    }
    for (auto start : zxc) {
        if (us[start.first][start.second]) continue;
        queue<pair<int, int>> q;
        q.push(start);
        us[start.first][start.second] = true;
        while (!q.empty()) {
            int x = q.front().first, y = q.front().second;
            q.pop();
            if (x != 0 && !us[x - 1][y] && field[x - 1][y] == 0) {
                us[x - 1][y] = true;
                q.push({x - 1, y});
            }
            if (x != n - 1 && !us[x + 1][y] && field[x + 1][y] == 0) {
                us[x + 1][y] = true;
                q.push({x + 1, y});
            }
            if (y != 0 && !us[x][y - 1] && field[x][y - 1] == 0) {
                us[x][y - 1] = true;
                q.push({x, y - 1});
            }
            if (y != m - 1 && !us[x][y + 1] && field[x][y + 1] == 0) {
                us[x][y + 1] = true;
                q.push({x, y + 1});
            }
        }
    }
    int xmin = INT_MAX, xmax = INT_MIN;
    int ymin = xmin, ymax = xmax;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (field[i][j] == 0 && !us[i][j]) {
                xmin = min(xmin, i);
                xmax = max(xmax, i);
                ymin = min(ymin, j);
                ymax = max(ymax, j);
            }
        }
    }
    xmin--, xmax++, ymin--, ymax++;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if ((i == xmin || i == xmax || j == ymin || j == ymax) && (xmin <= i && i <= xmax && ymin <= j && j <= ymax)) {
                cout << "#";
            } else {
                cout << ".";
            }
        }
        cout << "\n";
    }
}
